      PROGRAM PRESPOIR
*
*     This program helps to prepare the .dat file for ESPOIR
*
************************************************************************
*     ESPOIR is
*     a special purpose Monte Carlo code used for ab initio structure
*     determination by fitting to "|Fobs|" (powder or single crystal)
*
*     For more details see the documentation at
*                   http://www.cristal.org/sdpd/espoir/
*
*                            A. Le Bail - July 1999
*                            alb@cristal.org
*                            http://www.cristal.org/
*
*                            Residence Cristal - Appt 213
*                            2, rue de Gasperi
*                            72100 Le Mans
*                            FRANCE
*
*
************************************************************************
*
*    Copyright (C) 1999 Armel Le Bail
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************
*
*
*
      character*1 out
      character*4 version,NAMB(8)
      character*20 file
      character*24 tempo
      logical qex
      integer   NAT(8),ncum(8),ncum1(8),SS
      DIMENSION TEXT(20),XRYZ(5),XG(3)
      DIMENSION XL(5,100),XOLD(3,100),XLN(3,100),XLNN(3,100)
      DIMENSION TEMP(100),MTYP(100),B(8),FF(8),XLM(3,100)
	DIMENSION FC(8),DELFR(8),FA(8,10),FB(8,10)
      DIMENSION AL(3,3)
      DIMENSION CELPRE(6),RCELLN(6)
      DIMENSION CELPR2(6),AL2(3,3),RCELLN2(6)
      DIMENSION TM1(6),TM2(6),TM3(6),TM4(6)
      DIMENSION IGR(45)
	DIMENSION rcut(36),delta(8),nsp(100)
C
C
C
      PRINT 10
10    FORMAT(/'  Dear ESPOIR user, this program will help you'/
     &'  to prepare the parameters in filename.dat'/)
      PRINT 20
20    format('  Please give the filename (no extension): ',$)
      READ 30,file
30    format(A20)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
	 lfile=lfile-1
      enddo
      LPR=20
      tempo=file(1:lfile)//'.dat'
      inquire(file=tempo,exist=qex)
      if(qex.eq..FALSE.) go to 40
      call filedel(20,tempo)
40    call open_write1(20,tempo)
C
C.....READ PROBLEM IDENTIFICATION
C
      PRINT 45
45    FORMAT(/'  Please give an identification text (20A4): ',$)
      READ 50,TEXT
	WRITE(20,50)TEXT
50    FORMAT(20A4)
C
C.....INPUT CELL DIMENSIONS
C
      PRINT 55
55    FORMAT(/'  Please give the cell parameters '/
     &'  a b c alpha beta gamma: ',$)
      READ *,(CELPRE(I),I=1,6)
      WRITE(20,60)(CELPRE(I),i=1,6)
60    FORMAT(3F9.4,3F10.3)
C
C.....READ SPACE GROUP
C
      PRINT 70
70    FORMAT(/'  Please give the spacegroup'/
     &'  Examples : I 4/M, P 21/C, P 63/M M M : ',$) 
      READ 80,(IGR(IR),IR=1,36)
80    FORMAT(36A1)
      WRITE(LPR,90)(IGR(IR),IR=1,36)
90    FORMAT(36A1)
C
C...READ 
C                     SLABDA = Wavelength
C                     KXR (1 = neutron, >= 4 = RX)
C                     NA = Nbre atoms
C                     KLL = nbre atomes differents neutrons
C                     KMN = nbre atomes differents rayons X
C                     KP if 0, fit on |F|s, if 1, on profile
C
      PRINT 100
100   FORMAT(/'  Please give the wavelength in Angstroms: ',$)
      READ *,SLABDA
	PRINT 110
110   FORMAT(/'  Give the radiation code'/
     &'           1= neutron or 4 = RX : ', $)
      READ *,KXR
	PRINT 120
120   FORMAT(/'  Give the number of independent atoms'/
     &'                  in the asymmetric unit: ',$)
      READ *,NA
      PRINT 130
130   FORMAT(/'  Give the number of different atom types: ',$)
      READ *,KLL
	PRINT 140
140   FORMAT(/'  Give the type of fit you wish '/
     &'  0 if fit on |F|s'/
     &'  1 if fit on a pseudo-pattern regenerated from |F|s : ',$)
      READ *,KP
      WRITE(20,150)SLABDA,KXR,NA,KLL,KP
150   FORMAT(F7.5,4I4)
C
C  If KP=1  read the U,V,W,STEPN
C        STEPN is the number of points used for describing
C              the upper part of a peak, above the FWHM
C              Use STEPN between 3 and 5
C
      IF(KP.EQ.0)GO TO 9750
	PRINT 160
160   FORMAT(/'  Give the U V W values ',$)
      READ *,U,V,W
	PRINT 170
170   FORMAT(/'  Give the number of points above the FWHM'/
     &'   for the pseudo powder pattern (3 to 5): ',$)
	READ *,STEPN
      IF(STEPN.LT.3.)STEPN=3.
      IF(STEPN.GT.5.)STEPN=5.
	WRITE(20,180)U,V,W,STEPN
180   FORMAT(3F9.5,F5.0)
C
9750  if (na.gt.100) then
         write (*,*) na,' atoms are given'
         write (*,*) 'Arrays are only large enough for 100'
         stop
	endif
      if (KLL.gt.8) then
         write (*,*) KLL,' atom types are given'
         write (*,*) 'Arrays are only large enough for 8'
         stop
      endif
C
C.....Atom names
C
      PRINT 185
185   FORMAT(/'  Atom names should be in small letters'/
     &'  with 2 letters maximum followed by the charge'/
     &'  in case of RX and ions (ex : ba+2 or o-2)')
      DO 190 I=1,KLL
	PRINT 200,I
200   FORMAT(/'  Give name of atom ',I4,': ',$)
      READ 210,NAMB(I)
210   FORMAT(A4)
190   CONTINUE
C
C.....READ AND PRINT FOR EACH ATOM
C
      NTYP=KLL
C  npar = number of different atomic pairs
      npar=NTYP*(NTYP+1)/2
C  NAT(I) = nombre d'atomes dans chaque type
219   PRINT 220
220   FORMAT(/'  Give the number of atoms in each type')
      DO 240 I=1,NTYP
	PRINT 230,NAMB(I)
230   FORMAT(/'  For atom ',A4,' : ',$)
      READ *,NAT(I)
240   CONTINUE
      NSUM=0
      DO 245 I=1,NTYP
245   NSUM=NSUM+NAT(I)
      IF(NSUM.EQ.NA)GO TO 249
      PRINT *,'  The sum should be equal to ',NA,' try again'
      GO TO 219
249   WRITE(20,250)(NAMB(I),I=1,NTYP)
250   FORMAT(8A4)
      WRITE(20,260)(NAT(I),I=1,NTYP)
260   FORMAT(8I4)
C  BOV=B Overall
C  NOCC = code for reading individual guessed occupation factors
C       if = 1 : the next line should give all the occup. factors
C       if = 0 : the program generates all occup = 1.
C  NCON = code for constraints on shortest interatomic distances
C       if = 1 : read rcut below
C       if = 0 : no constraints
C  NSPE = code for general or special positions
C       if = 1 : read special positions codes nsp below
C       if = 0 : all atoms in general position, do not read anything
C  IPRI = code for printing Iobs/Icalc and Fobs/Fcalc at the end of a run
C       if = 0 : no printout
C       if = 1 : printout
C
      PRINT 270
270   FORMAT(/'  Give an overall thermal factor '/
     &'  suggested : 1.0 if inorganic'/
     &'              3.0 if organic : ',$)
	READ *,BOV
	PRINT 280
280   FORMAT(/'  Will you provide occupancy factors ?'/
     &'  YES = 1'/
     &'  NO  = 0 (all occup factors will be fixed to 1.0) : ',$)
	READ *,NOCC
	PRINT 290
290   FORMAT(/'  Will you provide constraints on distances ?'/
     &'  YES = 1'/
     &'  NO  = 0 : ',$)
	READ *,NCON
	PRINT 300
300   FORMAT(/'  Will you fix atoms on special positions ?'/
     &'  YES = 1'/
     &'  NO  = 0 (all atoms on general positions) : ',$)
	READ *,NSPE
	PRINT 310
310   FORMAT(/'  Do you want Iobs/Icalc and Fobs/Fcalc printout ?'/
     &'  YES = 1'/
     &'  NO  = 0 : ',$)
	READ *,IPRI
      WRITE(20,320)BOV,NOCC,NCON,NSPE,IPRI
320   FORMAT(F4.1,4I2)
C
      IF(NOCC.EQ.0)GO TO 9751
	PRINT 330
330   FORMAT(/'  Give now the occupation numbers for each atom'
     &/'     (in principle between 0. and 1.)')
      I=0
      DO 340 J=1,NTYP
	DO 340 K=1,NAT(J)
	I=I+1
	PRINT 350,K,NAMB(J)
	READ *,XL(5,I)
340   CONTINUE
350   FORMAT(/'  For atom ',I3,' with name ',A4,' ? ',$)
      IF(I.NE.NA)PRINT *,'Incoherency on the atom number'
      WRITE(20,360)(XL(5,I),I=1,NA)
360   FORMAT(8F10.5)
C
9751  IF(NCON.EQ.0)GO TO 9748
      PRINT 370
370   FORMAT(/'  Give now the minimal interatomic distances'/)
      ic=0
      DO 380 I=1,KLL
	DO 380 J=I,KLL
	ic=ic+1
	PRINT 390,NAMB(I),NAMB(J)
	READ *,rcut(ic)
380   CONTINUE
390   FORMAT(/'  Shortest distance between ',A4,' and ',A4,' ? ',$)
      WRITE(20,400)(rcut(ic),ic=1,npar)
400   FORMAT(10F8.3)
C
9748  do 9746 i=1,NA
9746  nsp(i)=1
      IF(NSPE.EQ.0)GO TO 9747
	PRINT 410
410   FORMAT(/'  Give now the special position for each atom')
      I=0
      DO 440 J=1,NTYP
	DO 440 K=1,NAT(J)
	I=I+1
	PRINT 450,K,NAMB(J)
	READ *,nsp(i)
440   CONTINUE
450   FORMAT(/'  Allowed codes are :'/ 
     *'   1 for   x,y,z general position'/
     *'   2 for   x,x,x      6 for    x,0,z'/
     *'   9 for   x,y,0     10 for    0,y,z'/
     *'  13 for   x,0,0     12 for    0,y,0'/
     *'   8 for   0,0,z      4 for    x,1/4,z'/
     *'   5 for   0,1/2,z    7 for    x,0,1/4'/
     *'  11 for   1/2,y,0    3 for    0,0,0'/
     *'  For atom ',I3,' with name ',A4,' ? ',$)
      IF(I.NE.NA)PRINT *,'Incoherency on the atom number'
      WRITE(20,460)(NSP(I),I=1,NA)
460   FORMAT(10I4)
C
C  sigma is precision expected from data
C  reject = accept a move even if -reject < deltaR < 0
9747  CONTINUE
      PRINT 470
470   FORMAT(/'  Give sigma : the data precision'/
     &'       (why not 1.0 ?): ',$)
	READ *,sigma
	PRINT 480
480   FORMAT(/'  Give reject (why not 0.001 ?)',$)
      READ *,reject
      WRITE(20,490)sigma,reject
490   FORMAT(2F8.4)
C  delta(i) is largest distance for moving atom-type i
      PRINT 500
500   FORMAT(/'  Give maximum move for each atom type')
      DO 510 J=1,NTYP
	PRINT 520,NAMB(J)
	READ *,delta(J)
510   CONTINUE
520   FORMAT(/'  For atom type ',A4,' ? ',$)
      WRITE(20,530)(delta(i),i=1,NTYP)
530   FORMAT(10F8.3)
C  nanneal is the law on moves reduction
C      move=move*(1.-ngen/timelim)**nanneal
C
      PRINT 540
540   FORMAT(/'  Give the annealing law'/
     &'   (why not second order : anneal=2.): ',$)
      read *,anneal
	WRITE(20,550)anneal
550   FORMAT(F4.2)
      PRINT 560
560   FORMAT(/'  Give number of moves between prints'/
     &'    (why not 20000 ?): ',$)
	READ *,iprint
	WRITE(20,570)iprint
570   FORMAT(I6)
      PRINT 580
580   FORMAT(/'  Give the maximum number of moves'/
     &'      (why not 200000 ?): ',$)
	READ *,imelim
      PRINT 590
590   FORMAT(/'  Give the maximum number for saving'/
     &'      (why not 100000 ?):',$)
	READ *,imesav
      WRITE(20,600)imelim,imesav
600   FORMAT(2I10)
C  if after nstart events, the R factor is larger than rmax, restart
      PRINT 610
610   FORMAT(/'  If after nstart events, the R factor is larger than'/
     &'  rmax, then restart'/
     &'      Give nstart and rmax'/
     &'      (why not 40000 and 0.2 ?): ',$)
      read *,nstart,rmax
C  ichi = 1 : test on Chi**2, ichi=2 : test on R
      PRINT 620
620   FORMAT(/'  If ichi = 1 : test on Chi**2, ichi=2 : test on R'/
     &'      Give ichi: ',$)
      read *,ichi
      WRITE(20,630)nstart,rmax,ichi
630   FORMAT(I6,F7.3,I4)
      PRINT 640
640   FORMAT(/'  try permutations after nperm moves'/
     &'  or try one translation after nperm rotations'/
     &'         Give nperm: ',$)
      read *,nperm
	WRITE(20,650)nperm
650   FORMAT(I4)
      PRINT 660
660   FORMAT(/'  If NTEST > 0, then NTEST random starting'/
     &'                configurations are tested'/
     &'  If NTEST = 0, then a non random starting'/
     &'                configuration is entered'/
     &'  if NTEST < 0, then a rigid model is translated'/
     &'                and rotated |NTEST| times'/
     &'             Give NTEST : ',$)   
      READ *,NTEST
	WRITE(20,670)NTEST
670   FORMAT(I5)
      CLOSE(20)
      tempo=file(1:lfile)//'.hkl'
      PRINT 680,tempo
680   FORMAT(/'  You should now prepare the file : ',A24)
      tempo=file(1:lfile)//'.dat'
      IF(NTEST.EQ.0)PRINT 690,tempo
690   FORMAT(/'  Do not forget to add your non random starting'/
     &'  configuration at the end of the file : ',A24)
      IF(NTEST.LT.0)PRINT 700,tempo
700   FORMAT(/'  Do not forget to add your rigid model and its'/
     &'  cell parameters at the end of the file : ',A24)
      PRINT 1000
1000  FORMAT(/'  Thanks for using PRESPOIR, and good luck '//
     &'  Type any character for ending this session : ',$)
      READ *,out
      STOP
      END
*
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
*
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close(unit,status='delete')
      return
      end
