      PROGRAM ESPOIR
*
*     Version 2.01 (with twinning by merohedry)
*
*     ESPOIR in french = HOPE in english
*     something not to lose when dealing with structure determination
*
************************************************************************
*
*     A special purpose Monte Carlo code used for ab initio structure
*     determination by fitting to "|Fobs|" (powder or single crystal)
*
*     For more details see the documentation at
*                   http://www.cristal.org/sdpd/espoir/
*
*     The MC code was inspired from RMCA written by Malcolm Howe                                    
*     Last altered as such by 26th May 1992 (version 2.11)
*               however, a more recent version 3.04 is available
*     See R.L. McGreevy, Nucl. Instr. and Meth. in Phys. Res. A354
*          (1995) 1-16 for one of the most recent reviews
*
*     Extensively modified by A. Le Bail - April 1999 for version 0.90
*                            alb@cristal.org
*                            http://www.cristal.org/
*
*                            Residence Cristal - Appt 213
*                            2, rue de Gasperi
*                            72100 Le Mans
*                            FRANCE
*
*    Modifications in version 1.00 :
*     Space groups recognition added
*     Simulated annealing
*     Tolerance for events not improving the fit, annealed too
*     No more constraints on distances or coordination
*                                        May 1999 (A. Le Bail)
*
*    Modifications in version 2.00 :
*     Fit possible on a pseudo powder pattern regenerated from
*        the extracted "|Fobs|" - this allows keeping the whole
*        set of extracted structure factors, and speed is enhanced
*        if compared to a fit on the true pattern. Moreover, the
*        step is variable : indexed on the FWHM
*     Option of minimal interatomic distances reinserted
*     Special positions considered
*     Molecular replacement method by rotation + translation
*        of a fragment
*
*
*                                       June 1999 (A. Le Bail)
*
*
*    Modification in version 2.01 : 
*      Possibility of twinning by merohedry 
*             (2 domains only with 50% each)
*
*                                       October 1999 (A. Le Bail)
*
*
*
*
************************************************************************
*
*    Copyright (C) 1999 Armel Le Bail
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************
*
*
*
      character*4 version,NAM(8)
      character*20 file
      character*24 tempo
      character Strsym*50
      logical qex
      logical   first,looping,acceptable
      parameter (version='2.01')
C
C
      CHARACTER*4 TABNC(128),TBXC(256),NAMB(8),NAMX(8),NX(100),NAX(8)
C
C
      real      move(192,6),movep(2,6),metric(3,3)
      integer   NAT(8),ncum(8),ncum1(8),SS
      DIMENSION HNN(2,3,1000),TEXT(20),XRYZ(5),XG(3)
      DIMENSION XL(5,100),XOLD(3,100),XLN(3,100),XLNN(3,100)
      DIMENSION TEMP(100),MTYP(100),B(8),FF(8),XLM(3,100)
      DIMENSION FOBS(1000),FNUC(2,1000),FNUCT(1000),D(1000)
	DIMENSION FC(8),DELFR(8),FA(8,10),FB(8,10)
      DIMENSION AL(3,3)
      DIMENSION CELPRE(6),RCELLN(6)
      DIMENSION CELPR2(6),AL2(3,3),RCELLN2(6)
      DIMENSION TM1(6),TM2(6),TM3(6),TM4(6)
      DIMENSION HH(3),IHH(2,3,1000),FFF(8,1000),IREFS(1000)
      DIMENSION T(24,3),SM(24,3,3),IGR(45),AT(2,3,3)
	DIMENSION rcut(36),delta(8),nsp(100)
      DIMENSION SS(24,3,3),TSS(24,3),IM(3,3),TS(3)
      COMMON /POSIT/ IGR
      COMMON/BURC/TSS,SS
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128)
      COMMON/YCALC/THETA(1000),HW(1000),U,V,W,NPTS,N1,N2,
     -YCALC(16000),YOBS(16000),BBB(1000),POS(16000),HW4(1000),
     -OMEGA(100,1000)
C
C
      DATA XRYZ(1),XRYZ(2),XRYZ(3),XRYZ(4),XRYZ(5)
     */2.28962,1.93597,1.54051,0.70926,0.556363/
C
      PI2=6.283185307179586
      PI=360./3.14159265359           
C
      PRINT 401
401   format('  entry file (no extension) ??',$)
      READ 402,file
402   format(A20)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
	 lfile=lfile-1
      enddo
      LCA=21
      tempo=file(1:lfile)//'.dat'
      call open_read1(21,tempo)
      LPR=20
      tempo=file(1:lfile)//'.imp'
      inquire(file=tempo,exist=qex)
      if(qex.eq..FALSE.) go to 403
      call filedel(20,tempo)
403   call open_write1(20,tempo)
      LHKL=22
      tempo=file(1:lfile)//'.hkl'
      call open_read1(22,tempo)
      write (*,100) version,file(1:lfile)
      write (20,100) version,file(1:lfile)
      call datn
C
C.....READ PROBLEM IDENTIFICATION
C
      READ(LCA,500) TEXT
500   FORMAT(20A4)
C
C.....INPUT CELL DIMENSIONS
C
      DO 29 I=1,3
      DO 29 J=1,3
      AL2(I,J)=0.0
29    AL(I,J)=0.0
      READ(LCA,*) (CELPRE(I),I=1,6)
      WRITE(20,3050)(CELPRE(I),i=1,6)
3050  FORMAT(/' Cell parameters : ',3F9.4,3F10.3/)
      CALL DCELL(CELPRE,AL,RCELLN,V1)
      WRITE(20,902)(RCELLN(I),i=1,6)
902   FORMAT(/' Reciprocal cell parameters : ',3F9.4,3F10.3/)
C
C.....READ SPACE GROUP
C
      READ(LCA,479)(IGR(IR),IR=1,36)
  479 FORMAT(36A1)
      WRITE(LPR,478)(IGR(IR),IR=1,36)
  478 FORMAT(' SPACE GROUP : ',36A1/)
      CALL BURZ (ISYST,ISY,ISYB,IRL)
C-----MAKE ARRAY FROM BURZ COMPATIBLE
      DO 125 I=1,3
      DO 125 IJ=1,3
      DO 125 IK=1,IRL
      SM(IK,IJ,I)=SS(IK,IJ,I)
      T(IK,IJ)=TSS(IK,IJ)
125   CONTINUE
C
C...READ 
C                     SLABDA = Wavelength
C                     KXR (1 = neutron, >= 4 = RX)
C                     NA = Nbre atoms
C                     KLL = nbre atomes differents neutrons
C                     KMN = nbre atomes differents rayons X
C                     KP if 0, fit on |F|s, if 1, on profile
C                              if 2 : twinning, fit on |F|s
C
      READ(LCA,*)SLABDA,KXR,NA,KLL,KP
C
C  If KP=1  read the U,V,W,STEPN
C        STEPN is the number of points used for describing
C              the upper part of a peak, above the FWHM
C              Use STEPN between 3 and 5
C
C  If KP > 1, NPAT is the NUMBER OF DIFFERENT TWINS (MAX=2)
	NPAT=KP
      IF(KP.EQ.0)NPAT=1
C.....READ THE MATRICES OF TWIN TRANSFORMATION (NPAT-1)
	IF(NPAT.EQ.1)GO TO 9749
	DO 8720 I=2,NPAT
	DO 8720 J=1,3
      AT(1,J,1)=1.
      AT(1,J,2)=1.
      AT(1,J,3)=1.
	READ(LCA,*)(AT(I,J,K),K=1,3)
8720  CONTINUE
C
C
9749  S=FLOAT(NA)
      IF(KP.NE.1)GO TO 9750
      READ(LCA,*)U,V,W,STEPN
      IF(STEPN.LT.3.)STEPN=3.
C
9750  if (na.gt.100) then
         write (*,*) na,' atoms are given'
         write (*,*) 'Arrays are only large enough for 100'
         write (20,*) na,' atoms are given'
         write (20,*) 'Arrays are only large enough for 100'
         stop
	endif
      if (KLL.gt.8) then
         write (*,*) KLL,' atom types are given'
         write (*,*) 'Arrays are only large enough for 8'
         write (20,*) KLL,' atoms types are given'
         write (20,*) 'Arrays are only large enough for 8'
         stop
      endif
      WRITE(20,5005)SLABDA
5005  FORMAT(' Wavelength : ',F9.5/)
      IF(KXR.LT.4)WRITE(20,*)'Neutron data'
      IF(KXR.GE.4)WRITE(20,*)'X-ray data'
      KMN=KLL
      IF(KXR.GE.4)KLL=0
      IF(KXR.LT.4)KMN=0
C   Wavelength identification
      DO 404 IX=1,5
      IF(SLABDA+0.1.GT.XRYZ(IX))GOTO 405
404   CONTINUE
405   IXRAY=IX
      WRITE(20,*)
      IF(KP.EQ.0)WRITE(20,*)'The fit will be on the "|Fobs|"'
      IF(KP.EQ.1)WRITE(20,*)'The fit will be on the pseudo powder
     - pattern'
      IF(KP.EQ.2)WRITE(20,*)'There is some twinning'
      IF(KP.EQ.1)WRITE(20,5011)U,V,W,STEPN
5011  FORMAT('    with U, V, W, STEPN  = ',4F9.4)
C
C.....Scattering factors retrieved by names
C
	IF(KLL)406,407,406
406   READ(LCA,408)(NAMB(I),I=1,KLL)
408   FORMAT(8A4)
      DO 409 I=1,KLL
      NAM(I)=NAMB(I)
      DO 410 J=1,92
      IF(NAMB(I).EQ.TABNC(J)) GO TO 411
410   CONTINUE
      WRITE(LPR,412)NAMB(I)
412   FORMAT(34H SCATTERING LENGTHS NOT FOUND FOR ,A4)
      STOP ' SCATTERING DATA MISSING'
411   FF(I)=TABN(J)
      B(I)=FF(I)
409   CONTINUE
407   IF(KMN)413,413,414
414   READ(LCA,408)(NAMX(I),I=1,KMN)
      DO 415 I=1,KMN
      NAM(I)=NAMX(I)
      DO 416 J=1,213      
      IF(NAMX(I).EQ.TBXC(J)) GO TO 417
416   CONTINUE
      WRITE(LPR,418)NAMX(I)
418   FORMAT(' SCATTERING COEFFICIENTS NOT FOUND FOR ',A4)
      STOP ' SCATTERING DATA MISSING'
417   FA(1,I)=TBX(J,1)
      FB(1,I)=TBX(J,2)
      FA(2,I)=TBX(J,3)
      FB(2,I)=TBX(J,4)
      FA(3,I)=TBX(J,5)
      FB(3,I)=TBX(J,6)
      FA(4,I)=TBX(J,7)
      FB(4,I)=TBX(J,8)
      FC(I)=TBX(J,9)
      IBX=TBX(J,10)+0.5
      DELFR(I)=TBD(IBX,IXRAY)
      B(I)=TBD(IBX,IXRAY+5)
415   CONTINUE
C
C.....READ AND PRINT FOR EACH ATOM
C
413   NTYP=KLL
      IF(KLL.EQ.0)NTYP=KMN
C  npar = number of different atomic pairs
      npar=NTYP*(NTYP+1)/2
C  NAT(I) = nombre d'atomes dans chaque type
      READ(LCA,*)(NAT(I),I=1,NTYP)
C  BOV=B Overall
C  NOCC = code for reading individual guessed occupation factors
C       if = 1 : the next line should give all the occup. factors
C       if = 0 : the program generates all occup = 1.
C  NCON = code for constraints on shortest interatomic distances
C       if = 1 : read rcut below
C       if = 0 : no constraints
C  NSPE = code for general or special positions
C       if = 1 : read special positions codes nsp below
C       if = 0 : all atoms in general position, do not read anything
C  IPRI = code for printing Iobs/Icalc and Fobs/Fcalc at the end of a run
C       if = 0 : no printout
C       if = 1 : printout
C
      READ(LCA,*)BOV,NOCC,NCON,NSPE,IPRI
      WRITE(20,5006)BOV
5006  FORMAT(/' Overall thermal parameter : ',F10.2/)
C
      IF(NOCC.EQ.0)GO TO 9751
      READ(LCA,*)(XL(5,I),I=1,NA)
      WRITE(20,5007)(XL(5,I),I=1,NA)
5007  FORMAT(/' You think to have guessed the following occupation
     -factors :'/,10X,10F8.3)
C
9751  IF(NCON.EQ.0)GO TO 9748
      READ(LCA,*)(rcut(ic),ic=1,npar)
      WRITE(20,5008)(rcut(ic),ic=1,npar)
5008  FORMAT(/' There will be minimal distance constraints :'/,
     -10X,10F8.3)
C
9748  do 9746 i=1,NA
9746  nsp(i)=1
      IF(NSPE.EQ.0)GO TO 9747
      READ(LCA,*)(nsp(i),i=1,na)
      WRITE(20,5009)(nsp(i),i=1,na)
5009  FORMAT(/' The special position codes are :',/10X,10I4/)
C
C  sigma is precision expected from data
C  reject = accept a move even if -reject < deltaR < 0
9747  IF(IPRI.EQ.1)WRITE(20,5012)
5012  FORMAT(' A .prf file will be created, and the
     - list of Fo/Fc will be given'/)
      READ(LCA,*)sigma,reject
C  delta(i) is largest distance for moving atom-type i
      read(LCA,*) (delta(i),i=1,NTYP)
C  nanneal is the law on moves reduction
C      move=move*(1.-ngen/timelim)**nanneal
C
      read(LCA,*) nanneal
C  print each iprint moves, up to timelin moves, saving each timesav moves
      read (LCA,*) iprint
      read (LCA,*) timelim,timesav
C  if after nstart events, the R factor is larger than rmax, restart
C  ichi = 1 : test on Chi**2, ichi=2 : test on R
      read (LCA,*) nstart,rmax,ichi 
C  try permutations after nperm moves
C  or try one translation after nperm rotations
      read (LCA,*) nperm
C  if NTEST > 0, then NTEST random starting configurations are tested
C  if NTEST = 0, then a non random starting configuration is entered
C  if NTEST < 0, then a rigid model is translated and rotated 
      READ(LCA,*)NTEST
C  MR is code for Molecular Replacement
      MR=0
      IF(NTEST.LT.0)MR=-NTEST
      IF(NTEST.LT.0)NTEST=MR
C
C.....BUILD AND PRINT OF SYMMETRY MATRICES
C
      IABRA=ISYB
      ICENT=ISY+1
      NAG=IRL
C   IF BRAVAIS LATTICE R,A,B,C, THEN ADD SYMMETRY WITH TRANSLATION
C                IABRA=5,6,7
C        P I F R A B C = 1 2 3 4 5 6 7
      GO TO(7199,7199,7199,6000,7100,7120,7130),IABRA
      GO TO 7199
6000  IRL=IRL*3
      DO 6001 IR=NAG+1,IRL-NAG
      DO 6001 I=1,3
      DO 6001 J=1,3
      IRR=IR-NAG
6001  SM(IR,I,J)=SM(IRR,I,J)
      DO 6002 IR=2*NAG+1,IRL
      DO 6002 I=1,3
      DO 6002 J=1,3
      IRR=IR-2*NAG
6002  SM(IR,I,J)=SM(IRR,I,J)
      DO 6003 IR=NAG+1,IRL-NAG
      IRR=IR-NAG
      T(IR,1)=T(IRR,1)+0.6666666667
      T(IR,2)=T(IRR,2)+0.3333333333
6003  T(IR,3)=T(IRR,3)+0.3333333333
      DO 6004 IR=2*NAG+1,IRL
      IRR=IR-2*NAG
      T(IR,1)=T(IRR,1)+0.3333333333
      T(IR,2)=T(IRR,2)+0.6666666667
6004  T(IR,3)=T(IRR,3)+0.6666666667
      GO TO 7199
7100  IRL=IRL*2
      DO 7001 IR=NAG+1,IRL
      DO 7001 I=1,3
      DO 7001 J=1,3
      IRR=IR-NAG
7001  SM(IR,I,J)=SM(IRR,I,J)
      DO 7102 IR=NAG+1,IRL
      IRR=IR-NAG
      T(IR,1)=T(IRR,1)
      T(IR,2)=T(IRR,2)+0.5
7102  T(IR,3)=T(IRR,3)+0.5
      GO TO 7199
7120  IRL=IRL*2
      DO 7002 IR=NAG+1,IRL
      DO 7002 I=1,3
      DO 7002 J=1,3
      IRR=IR-NAG
7002  SM(IR,I,J)=SM(IRR,I,J)
      DO 7122 IR=NAG+1,IRL
      IRR=IR-NAG
      T(IR,1)=T(IRR,1)+0.5
      T(IR,2)=T(IRR,2)
7122  T(IR,3)=T(IRR,3)+0.5
      GO TO 7199
7130  IRL=IRL*2
      DO 7131 IR=NAG+1,IRL
      DO 7131 I=1,3
      DO 7131 J=1,3
      IRR=IR-NAG
7131  SM(IR,I,J)=SM(IRR,I,J)
      DO 7132 IR=NAG+1,IRL
      IRR=IR-NAG
      T(IR,1)=T(IRR,1)+0.5
      T(IR,2)=T(IRR,2)+0.5
7132  T(IR,3)=T(IRR,3)
7199  CONTINUE
691	FORMAT(2X,I4)
      IF(ICENT.EQ.2) GOTO 690
      WRITE(LPR,301)
      GOTO 700
  690 WRITE(LPR,303)
  700 IF(IRL-2) 751,710,710
  710 WRITE(LPR,49)
      WRITE(LPR,1611)
      DO 740 IR=1,IRL
      WRITE(LPR,152) IR,((SM(IR,I,J),J=1,3),I=1,3),(T(IR,I),I=1,3)
  740 CONTINUE
  751 CONTINUE
      NATT=NA
      IF(NCON.EQ.0)GO TO 9720
C.....
      IBRA=1   ! if Bravais lattice P, A, B, C
C
C  Extension of symmetry operators
C
      DO 760 IR=1,IRL
      DO 760 I=1,3
      TT(IR,I)=T(IR,I)
      DO 760 J=1,3
760   SMT(IR,I,J)=SM(IR,I,J)
      NAG=IRL
C   IF BRAVAIS LATTICE I, F,  THEN ADD SYMMETRY WITH TRANSLATION
C                IABRA=2,3
C        P I F R A B C = 1 2 3 4 5 6 7
      GO TO(7200,6500,6600),IABRA
      GO TO 7200
6500  IRL=IRL*2
      DO 6501 IR=NAG+1,IRL
      DO 6501 I=1,3
      DO 6501 J=1,3
      IRR=IR-NAG
6501  SMT(IR,I,J)=SMT(IRR,I,J)
      DO 6502 IR=NAG+1,IRL
      IRR=IR-NAG
      TT(IR,1)=TT(IRR,1)+0.5
      TT(IR,2)=TT(IRR,2)+0.5
6502  TT(IR,3)=TT(IRR,3)+0.5
      IBRA=2
      IRL=IRL/2
      GO TO 7200
6600  IRL=IRL*4
      DO 6601 IR=NAG+1,IRL-2*NAG
      DO 6601 I=1,3
      DO 6601 J=1,3
      IRR=IR-NAG
6601  SMT(IR,I,J)=SMT(IRR,I,J)
      DO 6602 IR=2*NAG+1,IRL-NAG
      DO 6602 I=1,3
      DO 6602 J=1,3
      IRR=IR-2*NAG
6602  SMT(IR,I,J)=SMT(IRR,I,J)
      DO 6603 IR=3*NAG+1,IRL
      DO 6603 I=1,3
      DO 6603 J=1,3
      IRR=IR-3*NAG
6603  SMT(IR,I,J)=SMT(IRR,I,J)
      DO 6604 IR=NAG+1,IRL-2*NAG
      IRR=IR-NAG
      TT(IR,1)=TT(IRR,1)+0.5
      TT(IR,2)=TT(IRR,2)
6604  TT(IR,3)=TT(IRR,3)+0.5
      DO 6005 IR=2*NAG+1,IRL-NAG
      IRR=IR-2*NAG
      TT(IR,1)=TT(IRR,1)+0.5
      TT(IR,2)=TT(IRR,2)+0.5
6005  TT(IR,3)=TT(IRR,3)
      DO 6006 IR=3*NAG+1,IRL
      IRR=IR-3*NAG
      TT(IR,1)=TT(IRR,1)
      TT(IR,2)=TT(IRR,2)+0.5
6006  TT(IR,3)=TT(IRR,3)+0.5
      IBRA=4
      IRL=IRL/4
7200  CONTINUE
C
C
C  Add inversion center
C
C
      NAS=IRL*IBRA
      IF(ICENT.EQ.1)GO TO 782
      DO 780 II=1,NAS
      IR=NAS+II
      DO 780 I=1,3
      TT(IR,I)=TT(II,I)
      DO 780 J=1,3
780   SMT(IR,I,J)=0.
      DO 781 II=1,NAS
      IR=NAS+II
      DO 781 K=1,3
      DO 781 L=1,3
      SMT(IR,K,L)=-SMT(II,K,L)
781   CONTINUE
782   CONTINUE
C
C  NATT=NA*ICENT*IRL*IBRA = total number of atoms in cell
C  NAS=IRL*IBRA*ICENT = total number of symmetry operators
C
      NAS=IRL*IBRA*ICENT
      NATT=NA*NAS
      WRITE(20,*)' Total number of symmetry operators = ',NAS
      WRITE(LPR,*)'   Full list of symmetry operators :'
      WRITE(LPR,1611)
      DO 803 IR=1,NAS
      WRITE(LPR,152)IR,((SMT(IR,I,J),J=1,3),I=1,3),(TT(IR,I),I=1,3)
  803 CONTINUE
C
C  Print some data
C
9720  CALL list(TEXT,sigma,NTYP,nstart,rmax,nperm,ntest,
     -delta,nanneal,iprint,timelim,timesav,reject)
      write (*,1100) NA,NTYP
      write (20,1100) NA,NTYP
C
C.....PRINT SCATTERING FACTORS
C
      IF(KXR-4) 419,425,425
 419  WRITE(LPR,51)
      WRITE(LPR,52) (B(I),I,I=1,KLL)
      IF(KMN) 424,424,423
 423  IF(KXR-4) 424,425,425
 425  WRITE(LPR,55)
      DO 426 I=1,KMN
      WRITE(LPR,427)NAMX(I),(FA(J,I),FB(J,I),J=1,4),FC(I),DELFR(I),B(I)
426   CONTINUE
427   FORMAT(1X,A4,8F9.5/5X,3F9.5)
424   CONTINUE
C.....
C
C   BIG LOOP on NTEST
C
      NCART=0
      JTEST=0
      DIFFM=1.
8999  IF(NTEST.NE.0)JTEST=JTEST+1
      IF(JTEST.EQ.0)JTEST=1
      write (*,101) JTEST
      write (20,101) JTEST
101   format(////1x,'Test number : ',I3)
      call datn
*
*-------------------------------------------------------------------------
*     Initialisation
*
      call esp_init(iseed,time_start)
*
*-------------------------------------------------------------------------
C If molecular replacement, read also the cell parameters
C    in which the starting rigid model is described
C
      IF(JTEST.GT.1)GO TO 901
      IF(MR.EQ.0)GO TO 901
      READ(LCA,*)(CELPR2(I),I=1,6)
      IF(CELPR2(1).EQ.0.)NCART=1
      IF(NCART.EQ.0)GO TO 899
      CELPR2(1)=100.
      CELPR2(2)=100.
      CELPR2(3)=100.
899   WRITE(20,900)(CELPR2(I),i=1,6)
900   FORMAT(/' Starting rigid model cell parameters : '/
     -20X,3F9.4,3F10.3/)
      CALL DCELL(CELPR2,AL2,RCELLN2,V2)
      WRITE(20,902)(RCELLN2(I),i=1,6)
      CALL MATRIX(CELPRE,RCELLN,TM1,TM2)
      CALL MATRIX(CELPR2,RCELLN2,TM3,TM4)
901   time_used=0.
      nreject=0
      IF(MR.NE.0.AND.JTEST.GE.2)GO TO 953
C
C  Loop (Do 428) for XL = atomic coordinates
C
      I=0
      WRITE(20,5000)
5000  FORMAT(/' Starting coordinates x,y,z and occupation numbers'/)
      DO 428 L=1,NTYP
      NAX(L)(1:2)=NAM(L)(1:2)
      IF(NAX(L)(2:2).EQ.'+')NAX(L)(2:2)=' '
      IF(NAX(L)(2:2).EQ.'-')NAX(L)(2:2)=' '
      DO 428 K=1,NAT(L)
      I=I+1
      IF(K.LE.9)WRITE(NX(I),'(a,I1)')NAM(L)(1:2),K
      IF(K.GE.10)WRITE(NX(I),'(a,I2)')NAM(L)(1:2),K
      IF(NX(I)(2:2).EQ.'+')NX(I)(2:2)=' '
      IF(NX(I)(2:2).EQ.'-')NX(I)(2:2)=' '
      IF(NX(I)(2:2).NE.' ')GO TO 1576
      NX(I)(2:2)=NX(I)(3:3)
      NX(I)(3:3)=NX(I)(4:4)
      NX(I)(4:4)=' '
1576  IF(JTEST.GT.1)GO TO 9000
      IF(NTEST.EQ.0)READ(LCA,*)(XL(J,I),J=1,3),XL(5,I)
      IF(MR.NE.0)READ(LCA,*)(XL(J,I),J=1,3),XL(5,I)
C
C  Cartesian coordinates changed for a cubic cell with a=100A 
C
      IF(NCART.EQ.0)GO TO 898
      XL(1,I)=XL(1,I)/100.
      XL(2,I)=XL(2,I)/100.
      XL(3,I)=XL(3,I)/100.
898   IF(MR.EQ.0)GO TO 9000
C
C  Change coordinates of the rigid model in Cartesian coordinates
C
C      WRITE(20,904)(XL(J,I),J=1,3),XL(5,I)
C904   FORMAT(' Starting model  ',3F9.5,3X,F7.3)
      XL(1,I)=TM3(1)*XL(1,I)+TM3(2)*XL(2,I)+TM3(3)*XL(3,I)
      XL(2,I)=TM3(4)*XL(2,I)+TM3(5)*XL(3,I)
      XL(3,I)=TM3(6)*XL(3,I)
C      WRITE(20,905)(XL(J,I),J=1,3),XL(5,I)
C905   FORMAT(' Cartesian      ',3F9.5,3X,F7.3)
C
C  Refurbish the coordinates in the unknown structure cell
C
      XL(1,I)=TM2(1)*XL(1,I)+TM2(2)*XL(2,I)+TM2(3)*XL(3,I)
      XL(2,I)=TM2(4)*XL(2,I)+TM2(5)*XL(3,I)
      XL(3,I)=TM2(6)*XL(3,I)
C
C  We have now the rigid model inside the unknown
      GO TO 9001
9000  IF(MR.NE.0) GO TO 400
      IF(NTEST.EQ.0) GO TO 400
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14), nsp(i)
*
* 1 -    x,y,z general position
* 2 -    x,x,x
* 6 -    x,0,z
* 9 -    x,y,0
* 10-    0,y,z
* 13-    x,0,0
* 12-    0,y,0
* 8 -    0,0,z
* 4 -    x,1/4,z
* 5 -    0,1/2,z
* 7 -    x,0,1/4
* 11-    1/2,y,0
* 3 -    0,0,0
* 14-    1/2,0,0
*
*  x,y,z general position
1     XL(1,I)=RAN(iseed)
      XL(2,I)=RAN(iseed)
      XL(3,I)=RAN(iseed)
      GO TO 400
*  x,x,x
2     XL(1,I)=RAN(iseed)
      XL(2,I)=XL(1,I)
      XL(3,I)=XL(1,I)
      GO TO 400
*  0,0,0
3     XL(1,I)=0.
      XL(2,I)=XL(1,I)
      XL(3,I)=XL(1,I)
      GO TO 400
*  x,1/4,z
4     XL(1,I)=RAN(iseed)
      XL(2,I)=0.25
      XL(3,I)=RAN(iseed)
      GO TO 400
*  0,1/2,z
5     XL(1,I)=0.
      XL(2,I)=0.5
      XL(3,I)=RAN(iseed)
      GO TO 400
*  x,0,z
6     XL(1,I)=RAN(iseed)
      XL(2,I)=0.
      XL(3,I)=RAN(iseed)
      GO TO 400
*  x,0,1/4
7     XL(1,I)=RAN(iseed)
      XL(2,I)=0.
      XL(3,I)=0.25
      GO TO 400
*  0,0,z
8     XL(1,I)=0.
      XL(2,I)=0.
      XL(3,I)=RAN(iseed)
      GO TO 400
*  x,y,0
9     XL(1,I)=RAN(iseed)
      XL(2,I)=RAN(iseed)
      XL(3,I)=0.
      GO TO 400
*  0,y,z
10    XL(1,I)=0.
      XL(2,I)=RAN(iseed)
      XL(3,I)=RAN(iseed)
      GO TO 400
*  1/2,y,0
11    XL(1,I)=0.5
      XL(2,I)=RAN(iseed)
      XL(3,I)=0.
      GO TO 400
*  0,y,0
12    XL(1,I)=0.
      XL(2,I)=RAN(iseed)
      XL(3,I)=0.
      GO TO 400
*  x,0,0
13    XL(1,I)=RAN(iseed)
      XL(2,I)=0.
      XL(3,I)=0.
      GO TO 400
*  1/2,0,0
14    XL(1,I)=0.5
      XL(2,I)=0.
      XL(3,I)=0.
C  XL(5,I)= Occupation number (1=100% of the general position)
400   IF(NOCC.EQ.1)GO TO 9001
      XL(5,I)=1.
9001  MTYP(I)=L
      XL(4,I)=BOV
428   CONTINUE
      CLOSE (LCA)
953   IF(MR.EQ.0) GO TO 993
      IF(JTEST.GT.1)GO TO 992
      DO 991 I=1,NA
      XOLD(1,I)=XL(1,I)
      XOLD(2,I)=XL(2,I)
991   XOLD(3,I)=XL(3,I)
      GO TO 993
C
C  Restart from Xold for several tests of Molecular Replacement
C
992   DO 994 I=1,NA
      XL(1,I)=XOLD(1,I)
      XL(2,I)=XOLD(2,I)
994   XL(3,I)=XOLD(3,I)
993   I=0
      DO 1009 L=1,NTYP
      DO 1009 K=1,NAT(L)
      I=I+1
      WRITE(20,1010)NX(I),(XL(J,I),J=1,3),XL(5,I)
1009  CONTINUE
      IF(NCON.EQ.0)GO TO 9721
C
C  NATT Atoms really in the cell
C
      I=0
      DO 800 L=1,NA
      X=XL(1,L)
      Y=XL(2,L)
      Z=XL(3,L)
      DO 800 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
C      WRITE(20,*)I,(XLL(JJ,I),JJ=1,3)
800   CONTINUE
C
C  NGEN   = number of generated moves
C  NTRIED = Number of tried moves
C  NACC   = Number of accepted moves
9721  NGEN=0
      NTRIED=0
      NACC=0
1010  FORMAT(A4,3F11.5,5X,F6.3)
C
C.....CYCLE THROUGH INPUT REFLECTIONS
C
      IF(JTEST.GE.2) GO TO 9500
      READ(LHKL,*)NHKL
      if (NHKL.gt.1000) then
         write (*,*) NHKL,' reflections are given'
         write (*,*) 'Arrays are only large enough for 1000'
         write (20,*) NHKL,' reflections are given'
         write (20,*) 'Arrays are only large enough for 1000'
         stop
	endif
      sum_f=0.
      DO 1960 I=1,NHKL
      READ(LHKL,*)(IHH(1,J,I),J=1,3),FOBS(I)
C
C.....CALCULATE THE H K L OF TWIN DOMAIN 2
C
	IF(NPAT.EQ.1)GO TO 261
      DO 259 J=2,NPAT
      DO 259 K=1,3
      IHH(J,K,I)=0.
      DO 258 L=1,3
258   IHH(J,K,I)=IHH(J,K,I)+IHH(1,L,I)*AT(J,K,L)
      IF(IHH(J,K,I).LT.0.)IHH(J,K,I)=IHH(J,K,I)-0.1
      IF(IHH(J,K,I).GE.0.)IHH(J,K,I)=IHH(J,K,I)+0.1
259   CONTINUE
C      WRITE(20,*)(IHH(1,J,I),J=1,3),(IHH(2,J,I),J=1,3),FOBS(I)
261   DO 300 KK=1,3
300   HH(KK)=IHH(1,KK,I)
      sum_f=sum_f+FOBS(I)
C     HH IS INDICES OF REFLECTION
      X=0.
      DO 1840 J=1,3
      DO 1840 K=J,3
 1840 X=AL(J,K)*HH(J)*HH(K)+X
C     X IS DSTAR**2 FOR REFLECTION HH
      X=SQRT(X)*0.5
C     X IS DSTAR/2 FOR HH
      FF(1)=0.
      IF(KMN)1950,1950,1920
1920  CONTINUE
      DO 1930 J=1,KMN
      FF(J)=0.
      DO 1930 K=1,4            
      AR=-FB(K,J)*X**2
      FF(J)=FF(J)+FA(K,J)*EXP(AR) 
1930  CONTINUE
      DO 1940 J=1,KMN       
1940  FF(J)=FF(J)+DELFR(J)+FC(J)  
1950  DO 1952 J=1,NTYP
1952  FFF(J,I)=FF(J)
1960  CONTINUE
      CLOSE(LHKL)
C
CCC Normalization of |F| to 50. as a mean, arbitrarily
      XNHKL=NHKL
      HMIN=100.
      DO 1961 I=1,NHKL
1961  FOBS(I)=FOBS(I)/sum_f*XNHKL*50.
      sum_f=XNHKL*50.
C
C   9500 : Jump if NTEST different from zero
C
      FLOG =4.*ALOG(2.)
      SLOG =1./SQRT(FLOG)
9500  SUMCAL=0.
      sum_fs=0.
C
C   Sum on hkl
C
      DO 1000 NM=1,NHKL
      FNUCT(NM)=0.
C
C   Sum on twins
C
      DO 1000 NTW=1,NPAT
      IF(JTEST.GE.2) GO TO 111
      DO 105 I=1,3
105   HNN(NTW,I,NM)=IHH(NTW,I,NM)
C
      DO 109 IR=1,IRL
      TR(NTW,IR,NM)=0.0
      DO 108 I=1,3
      H(NTW,IR,I,NM)=0.0
      TR(NTW,IR,NM)=TR(NTW,IR,NM)+T(IR,I)*HNN(NTW,I,NM)
      DO 107 J=1,3
107   H(NTW,IR,I,NM)= SM(IR,J,I)*HNN(NTW,J,NM)+H(NTW,IR,I,NM)
108   CONTINUE
109   CONTINUE
C
      SSS=0.
      DO 110 I=1,3
      DO 110 J=I,3
110   SSS=AL(I,J)*HNN(1,I,NM)*HNN(1,J,NM)+SSS
C
C     SSS=1/d**2
C
      SSNN=0.25*SSS
C
C     Needs to calculate halfwidths and positions
C
      D(NM)=SQRT(1./SSS)
      SINTH=SLABDA*SLABDA*SSS/4.
      COSTH=1.-SINTH
      TANTH=SQRT(SINTH/COSTH)
      THETA(NM)=ATAN(TANTH)*PI
      HW(NM)=SQRT(U*TANTH*TANTH+V*TANTH+W)
      IF(HMIN.GT.HW(NM))HMIN=HW(NM)
      HW(NM)=HW(NM)*SLOG
      HW4(NM)=HW(NM)/SLOG*2.0
      BBB(NM)=HW(NM)*HW(NM)
C
111   DO 130 I=1,NA
      DO 120 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 70 J=1,3
70    ARG=ARG+H(NTW,IR,J,NM)*XL(J,I)
      ARG=6.28318530718*ARG
      COSAR(NTW,I,IR,NM)=COS(ARG)
120   SINAR(NTW,I,IR,NM)=SIN(ARG)
C     TEMP=Temperature factor for atom I
      IF(JTEST.GE.2) GO TO 130
      TEMP(I)=EXP(-XL(4,I)*SSNN)
130   CONTINUE
C
C
      AV=0.
      BV=0.
      DO 170 I=1,NA
      SAI=0.
      SBI=0.
      DO 140 IR=1,IRL
      SAI=SAI+COSAR(NTW,I,IR,NM)
      IF(ICENT.EQ.1)SBI=SINAR(NTW,I,IR,NM)+SBI
140   CONTINUE
      SAI=FLOAT(ICENT)*SAI
      IF(KXR.LT.4)GO TO 150
      IF(JTEST.GE.2) GO TO 161
      SNEXIX(I,NM)=FFF(MTYP(I),NM)*TEMP(I)*XL(5,I)
      SNXI(I)=B(MTYP(I))*XL(5,I)*TEMP(I)
      GOTO 161
150   IF(JTEST.GE.2) GO TO 552   
      SNEXIN(I)=B(MTYP(I))*TEMP(I)*XL(5,I)
552   AV=SNEXIN(I)*SAI+AV
      BV=SNEXIN(I)*SBI+BV
      IF(KXR.LT.4)GO TO 170
161   AV=SNEXIX(I,NM)*SAI+AV
      BV=SNEXIX(I,NM)*SBI+BV
      AVI=AV-SNXI(I)*SBI
      AVJ=AV+SNXI(I)*SBI
      BVI=BV-SNXI(I)*SAI
      BVJ=BV+SNXI(I)*SAI
170   CONTINUE
190   IF(KXR.LT.4)GOTO 200
      FNN=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)
      GOTO 210
200   FNN=(AV*AV+BV*BV)
210   FNUC(NTW,NM)=SQRT(FNN)
      FNUCT(NM)=FNUCT(NM)+FNUC(NTW,NM)
      SUMCAL=SUMCAL+FNUC(NTW,NM)
1000  CONTINUE
C      WRITE(20,*)' KP, NHKL ',KP,NHKL
      IF(KP.EQ.0.OR.KP.EQ.2)GO TO 999
      IF(JTEST.GE.2) GO TO 999
C  Variable step as a function of the FWHM
C  The minimum step is FWHMmin/STEPN
      PO=0.01
      STEP=HMIN/STEPN
      POS(1)=0.01
      DO 550 I=2,16000
      TANTH=TAN(POS(I-1)/PI)
      FWHM=SQRT(U*TANTH*TANTH+V*TANTH+W)
      ASTEP=STEP*FWHM/HMIN
      PO=PO+ASTEP
      IF(PO.GT.160.)GO TO 551
550   POS(I)=PO
551   NPTS=I-1
      CALL profile1(NHKL,FOBS)
      sum_y=0.
      DO 998 I=N1,N2
998   sum_y=sum_y+YOBS(I)
999   DIFF=0.
      DO 1001 NM=1,NHKL
      FNUCT(NM)=FNUCT(NM)/SUMCAL*sum_f
      IF(KP.EQ.1)GO TO 1001
      DIFF=DIFF+ABS(FOBS(NM)-FNUCT(NM))
      sum_fs=sum_fs+(FOBS(NM)-FNUCT(NM))**2
1001  CONTINUE
      IF(KP.EQ.1)GO TO 980
      DIFF=DIFF/sum_f
      GO TO 981
980   CALL profile3(NHKL,FNUCT,sum_fs,DIFF)
      DIFF=DIFF/sum_y
*
*-------------------------------------------------------------------------
*     a,b,c Cell parameters 
*
981   A=CELPRE(1)
      BB=CELPRE(2)
      C=CELPRE(3)
      IF(NCON.EQ.0)GO TO 9722
*
*-------------------------------------------------------------------------
*     Calculate metric matrix
*
      ALPH=CELPRE(4)*PI2/360.
      BET=CELPRE(5)*PI2/360.
      GAMM=CELPRE(6)*PI2/360.
      metric(1,1)=A**2
      metric(2,2)=BB**2
      metric(3,3)=C**2
      metric(1,2)=A*BB*COS(GAMM)
      metric(1,3)=A*C*COS(BET)
      metric(2,3)=BB*C*COS(ALPH)
      metric(2,1)=metric(1,2)
      metric(3,1)=metric(1,3)
      metric(3,2)=metric(2,3)
*
*-------------------------------------------------------------------------
*     Cumulated atom types
*
9722  IF(NCON.EQ.0)NAS=1
      ncum(1)=NAT(1)
      do itype=2,NTYP
         ncum(itype)=ncum(itype-1)+NAT(itype)
      enddo
      ncum1(1)=NAT(1)*NAS
      do itype=2,NTYP
         ncum1(itype)=ncum1(itype-1)+NAT(itype)*NAS
      enddo
C      WRITE(20,*)' NCUM, NCUM1 :',(ncum(i),i=1,NTYP),
C     -(ncum1(i),i=1,NTYP)
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*     This is where the loop begins. 
*
      save_time=min(timelim,timesav)
      ngenp=0
      ngent=0
      naccp=0
      ntriedp=0
      dump=1.
      dump0=1.
      diff0=1.
      lastprint=ngen-mod(ngen,iprint)
      first=.true.
      looping=.true.
      nper=-1
      ngrav=0
      do while (looping)
*
*-------------------------------------------------------------------------
         acceptable=.true.
         chisq1=0.
         diff1=0.
         nper=nper+1
         if (.not.first) then
         if(nper.eq.nperm) go to 2999
*
*-------------------------------------------------------------------------
*           Generate a random move or a model rotation
*
         ngen=mod(ngen+1,10000000)
*
*   Here is practiced some annealing
*
*   dump = dumping factor for reducing the move size with 
*          the number of already generated moves (move+perm in fact)
* 
      dump=(1.-(ngen+ngenp)/timelim)**nanneal
      IF(MR.EQ.0)GO TO 910
      IF(diff0.LT.rmax)dump0=dump*dump
      CALL ROTATE(XL,XLN,NA,iseed,TM1,TM2,S,dump0,ngrav,XG)
      ngrav=1
      GO TO 3001
910   call esp_genmove(NA,iseed,ncum,delta,imove,move,
     -A,BB,C,dump,nsp)
      call esp_newpos(XL,move,imove,NCON)
            go to 3001
*
*-------------------------------------------------------------------------
*           Generate a random permutation or a random translation
*           Care if an atom permute with itself
*           Care if an atom permute with another same atom-type
*
2999  IF(MR.EQ.0)GO TO 911
      DO 964 I=1,NA
      XLNN(1,I)=XLN(1,I)
      XLNN(2,I)=XLN(2,I)
964   XLNN(3,I)=XLN(3,I)
      CALL TRANSLA(XLNN,XLN,NA,iseed,delta,A,BB,C,dump)
            ngenp=ngenp+1
      GO TO 3001
911   call esp_genmovep(NA,XL,MTYP,iseed,ncum,delta,imove1,imove2,
     -movep,nsp)
         call esp_newposp(XL,movep,imove1,imove2)
            ngenp=ngenp+1
      go to 3002
*
*-------------------------------------------------------------------------
*           Check distances 
*
3001   IF(NCON.EQ.0)GO TO 3002 
       IF(MR.EQ.0)GO TO 997
       call esp_checkMR(XLN,NTYP,metric,ncum1,rcut,acceptable)
       GO TO 3002
997         call esp_check(NTYP,metric,ncum1,rcut,
     -       imove,move,acceptable)
C         endif
*----------------------------------------------------------------------
3002     ngent=ngen+ngenp
         if (acceptable.and.nper.ne.nperm) ntried=mod(ntried+1,10000000)
         if (nper.eq.nperm) ntriedp=ntriedp+1
         if (acceptable) then
         if(nper.eq.nperm) go to 3003
         if(MR.NE.0)GO TO 3003
*
*----------------------------------------------------------------------
*           Calculate sums for chi-squared
* 
      call esp_sumstot(NHKL,FOBS,KXR,XL,imove,move,DIFF,
     -NA,sum_fs,sum_f,sum_y,KP,NPAT)
      go to 3004
*----------------------------------------------------------------------
*           Calculate sums for chi-squared
* 
3003  if(MR.EQ.0)GO TO 920
      call esp_sumMR(NHKL,FOBS,KXR,XLN,
     -DIFF,NA,sum_fs,sum_f,sum_y,KP,NPAT)
      GO TO 3004
920   call esp_sumstotp(NHKL,FOBS,KXR,XL,imove1,imove2,movep,
     -DIFF,NA,sum_fs,sum_f,sum_y,KP,NPAT)
       endif
       endif
*
*----------------------------------------------------------------------
*           Calculate chi-squared
*
3004  call esp_chisq(sum_fs,sigma,chisq,chisq1,DIFF,ichi,diff1)
*
*----------------------------------------------------------------------
*        Decide whether to accept move
*
         if (first) then
            acceptable=.false.
            chisq0=chisq1
            diff0=diff1
         else
            prat=chisq0-chisq1
            if(prat.ge.0.)go to 3010
*
*  Accept times to times an event that does not improve the fit
*  on a criteria linked to dump
*
            rej=reject*dump
            pdiff=diff0-diff1
            if(pdiff.ge.0.)go to 3010
            if (pdiff.gt.-rej) prat=exp(pdiff/rej)
            if (prat.lt.ran(iseed)) acceptable=.false.
            if (pdiff.le.-rej) acceptable=.false.
            if(acceptable)nreject=nreject+1
         endif
 3010    if (acceptable) nacc=mod(nacc+1,10000000)
         if (acceptable.and.nper.eq.nperm) naccp=naccp+1
*
*----------------------------------------------------------------------
*        Write summary
*
      if(first.or.(abs(ngent-lastprint).ge.iprint.and.acceptable)) 
     -    then
            call espo_summary(nacc,ngen,ntried,naccp,ntriedp,
     -       DIFF,chisq1,nreject,NCON,dump,MR)
            lastprint=ngent-mod(ngent,iprint)
         endif
*
         if (acceptable) then
        if(nper.eq.nperm) go to 3005
         if(MR.NE.0)GO TO 3005
*----------------------------------------------------------------------
*           Make move
*
      call esp_makemove(XL,imove,move,NHKL,NCON,NPAT)
            chisq0=chisq1
            diff0=diff1
       go to 3006

*----------------------------------------------------------------------
*           Make move in case of accepted permutation
*
3005  IF(MR.EQ.0)GO TO 930
      call esp_makeMR(XL,XLN,NCON)
      ngrav=0
      GO TO 931
930   call esp_makemovep(XL,imove1,imove2,movep,NHKL,NCON,NPAT)
931         chisq0=chisq1
            diff0=diff1
3006      continue
         endif
*   counter for permutation reset to zero
          if(nperm.eq.nper)nper=0
*
*----------------------------------------------------------------------
*        Check time
*
         time_used=time_used+1.
         if (time_used.lt.0.or.time_used.ge.save_time) then
*
*
*----------------------------------------------------------------------
*           Write out the configuration, 
*
            write (*,*)
            write (*,*) 'Saving configuration and results to disk'
            write (*,*) 
     -       '*** DO NOT INTERRUPT UNTIL SAVING IS COMPLETED ***'
      call open_write(3,file,'new.cfg')
      call write_config(TEXT,ngent,ntried+ntriedp,nacc,nsaved,
     -NA,NTYP,NAT,XL,3)
            close(3)
*
*
            write (*,*) 'Saving has been completed'
            write (*,*)
            save_time=save_time+timesav
         endif
*
*----------------------------------------------------------------------
*        Decide whether to continue program
*
         if ((time_used.lt.0.).or.(time_used.ge.timelim))
     -                 looping=.false.
         first=.false.
         if(ngent.ge.nstart) then
         if(DIFF0.ge.rmax) go to 8990
         endif
      enddo
*
*        End of loop
*----------------------------------------------------------------------
*----------------------------------------------------------------------
*----------------------------------------------------------------------
C
C  Output of the final coordinates
C
      go to 8991
8990  WRITE(*,*)' Bad luck ! Try again.'
      go to 8888
8991  call espo_summary(nacc,ngen,ntried,naccp,ntriedp,
     -DIFF0,chisq1,nreject,NCON,dump,MR)
8888  WRITE(20,5001)
5001  FORMAT(/' Final coordinates x,y,z and occupation numbers'/)
      I=0
      DO 1500 L=1,NTYP
      DO 1500 K=1,NAT(L)
      I=I+1
      IL=I
      if(MR.NE.0)IL=NA
         do j=1,3
           XL(j,I)=XL(j,I)-INT(XL(j,IL))
             if(MR.NE.0)GO TO 8889
           if(XL(j,IL).GT.1.)XL(j,I)=XL(j,I)-1.
           if(XL(j,IL).LT.0.)XL(j,I)=XL(j,I)+1.
8889         if(DIFF0.LT.DIFFM)XLM(j,I)=XL(j,I)
         enddo
      WRITE(20,1010)NX(I),(XL(J,I),J=1,3),XL(5,I)
1500  CONTINUE
           if(DIFF0.LT.DIFFM)DIFFM=DIFF0
*
*----------------------------------------------------------------------
*           Write out the .spf file for PLATON 
*
      call open_write(3,file,'.spf')
      write(3,501)(TEXT(I),I=1,20),(CELPRE(I),I=1,6),(IGR(IR),IR=1,36)
      I=0
      DO 1502 L=1,NTYP
      DO 1502 K=1,NAT(L)
      I=I+1
      WRITE(3,502)NX(I),(XLM(J,I),J=1,3)
1502  CONTINUE
      close(3)
*
*----------------------------------------------------------------------
*           Write out the .res file for SHELX 
*
      call open_write(3,file,'.res')
      write(3,1561)(TEXT(I),I=1,20),SLABDA,(CELPRE(I),I=1,6)
      IBRA=IABRA
      IF(IABRA.EQ.3)IBRA=4
      IF(IABRA.EQ.4)IBRA=3
      IF(ICENT.EQ.1)IBRA=-IBRA
      write(3,1571)IBRA
C
C  WRITE SYMMETRY OPERATORS
C
      IRLLL=IRL
      IF(IABRA.EQ.4)IRLLL=IRLLL/3
      IF(IABRA.EQ.5)IRLLL=IRLLL/2
      IF(IABRA.EQ.6)IRLLL=IRLLL/2
      IF(IABRA.EQ.7)IRLLL=IRLLL/2
      DO 1572 IR=2,IRLLL
        DO 1573 J=1,3
        TS(J)=T(IR,J)
        DO 1573 L=1,3
        IM(J,L)=INT(SM(IR,J,L))
 1573 CONTINUE
      call StringSym(IM,TS,strsym)
      Write(3,'(a,a)')'SYMM ',strsym
 1572 CONTINUE
      WRITE(3,1566)(NAX(L),L=1,NTYP)
1568  CONTINUE
      WRITE(3,1569)(NAT(L),L=1,NTYP)
      WRITE(3,1570)
      I=0
      DO 1563 L=1,NTYP
      DO 1563 K=1,NAT(L)
      I=I+1
      OCCC=XL(5,I)+10.
      WRITE(3,1562)NX(I),L,(XLM(J,I),J=1,3),OCCC
1563  CONTINUE
      WRITE(3,1565)
1561  FORMAT('TITL ',20A4/'CELL 'F9.5,6F9.4/
     -'ZERR 1 0.001 0.001 0.001 0.0 0.0 0.0')
1562  FORMAT(A4,1X,I2,4F11.5,'  10.05000')
1565  FORMAT('HKLF 3'/'END')
1566  FORMAT('SFAC',8(X,A2))
1569  FORMAT('UNIT',8(X,I2))
1570  FORMAT('ACTA'/'L.S. 4'/'BOND'/'FMAP 2'/'PLAN 20'/
     -'WGHT    0.100000'/'FVAR       1.00')
1571  FORMAT('LATT ',I2)
      close(3)
      call datn
      if(NTEST.EQ.0)NTEST=JTEST
      if(ipri.eq.0.OR.JTEST.NE.NTEST) go to 250
*
      SUMCAL=0.
      DO 220 NM=1,NHKL
      FNUCT(NM)=0.
      DO 220 NTW=1,NPAT
C
      DO 231 I=1,NA
      DO 232 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 233 J=1,3
233   ARG=ARG+H(NTW,IR,J,NM)*XLM(J,I)
      ARG=6.28318530718*ARG
      COSAR(NTW,I,IR,NM)=COS(ARG)
232   SINAR(NTW,I,IR,NM)=SIN(ARG)
231   CONTINUE
      AV=0.
      BV=0.
      DO 224 I=1,NA
      SAI=0.
      SBI=0.
      DO 225 IR=1,IRL
      SAI=SAI+COSAR(NTW,I,IR,NM)
      IF(ICENT.EQ.1)SBI=SINAR(NTW,I,IR,NM)+SBI
225   CONTINUE
      SAI=FLOAT(ICENT)*SAI
      IF(KXR.LT.4)GO TO 226
      GOTO 227
226   AV=SNEXIN(I)*SAI+AV
      BV=SNEXIN(I)*SBI+BV
      IF(KXR.LT.4)GO TO 224
227   AV=SNEXIX(I,NM)*SAI+AV
      BV=SNEXIX(I,NM)*SBI+BV
      AVI=AV-SNXI(I)*SBI
      AVJ=AV+SNXI(I)*SBI
      BVI=BV-SNXI(I)*SAI
      BVJ=BV+SNXI(I)*SAI
224   CONTINUE
      IF(KXR.LT.4)GOTO 228
      FNN=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)
      GOTO 229
228   FNN=(AV*AV+BV*BV)
229   FNUC(NTW,NM)=SQRT(FNN)
      SUMCAL=SUMCAL+FNUC(NTW,NM)
      FNUCT(NM)=FNUCT(NM)+FNUC(NTW,NM)
220   CONTINUE
      WRITE(20,*)
      WRITE(20,*)'  h   k   l   Fcalc    Fobs     d(A)   2-theta   FWHM'
      WRITE(20,*)
      DIFF=0.
      DO 249 NM=1,NHKL
      FNUCT(NM)=FNUCT(NM)/SUMCAL*sum_f
      DIFF=DIFF+ABS(FOBS(NM)-FNUCT(NM))
      WRITE(LPR,1002)(IHH(1,K,NM),K=1,3),FNUCT(NM),FOBS(NM),D(NM),
     -THETA(NM),HW(NM)/SLOG
249   CONTINUE
      DIFF=DIFF/sum_f 
      WRITE(20,*)' Final RF factor    = ',DIFF
      IF(KP.EQ.0.OR.KP.EQ.2) GO TO 254
252   CALL profile2(NHKL,FNUCT,sum_fs,DIFF)
      DIFF=DIFF/sum_y
      WRITE(20,*)' Final Rp(F) factor = ',DIFF
*
*  .PRF file output
*
254   tempo=file(1:lfile)//'.prf'
      inquire(file=tempo,exist=qex)
      if(qex.eq..FALSE.) go to 204
      call filedel(15,tempo)
204   call open_write1(15,tempo)
      IVERS=8
      ZERO=0.
      WRITE(15,'(20A4)') TEXT
      WRITE(15,'(A,F9.4)') '3111   1.0000',ZERO
      THMAX=POS(N2)
      THMIN=POS(N1)
      ICN=NHKL
      DO 205 i=1,NHKL
      I1=IHH(1,1,i)
      I2=IHH(1,2,i)
      I3=IHH(1,3,i)
205   IREFS(i)=256*(256*(256*(8+1)+128+I1)+128+I2)+128+I3
      ICZ=NHKL
      NPTS=N2-N1+1
      WRITE(15,'(2F8.3,F8.5,I8)') THMAX,THMIN,STEP,IVERS
      AMDA1=SLABDA
      AMDA2=SLABDA
      NPAT1=1
      NVK=0
      WRITE(15,'(I3,I7,5f10.5)')NPAT1,NPTS,AMDA1,AMDA2,ZERO
      WRITE(15,'(8I5,8i3)')ICN,NVK
      WRITE(15,'(8(F7.0,1X))') (YOBS(J),J=N1,N2)
      WRITE(15,'(8(F7.0,1X))') (YCALC(J),J=N1,N2)
      WRITE(15,'(8I10)') (IREFS(J),J=1,ICZ)
      WRITE(15,'(10F8.3)')(THETA(J),J=1,ICZ)
      NEXCRG=0
      EXCRG=0
      WRITE(15,'(I8)') NEXCRG
      WRITE(15,'(2F8.2)') EXCRG,EXCRG
*
*
*
250   WRITE(20,5002)
5002  FORMAT(/' End of this test'////)
      IF(JTEST.EQ.NTEST)JTEST=0
      IF(JTEST.NE.0)GO TO 8999
*
*
501   FORMAT('TITL ',20A4/'CELL '6F9.4/'SPGR '36A1)
502   FORMAT('ATOM ',A4,3F11.5)
1002  FORMAT(3I4,5F8.3)
   49 FORMAT(1H 30X,'AND THE EQUIV. POS. ARE:')
   51 FORMAT(35H NEUTRON NUCLEAR SCATTERING LENGTHS/)
   52 FORMAT(1H ,8(F7.3,5H = B(,I1,2H);))
   55 FORMAT(' REAL AND IM. X-RAY SCATTER. FACT.')
100   format(/1x,'============================================
     -=================='/
     -        1x,' ESPOIR version ',a,' by A. Le Bail - 1999 -  
     -alb@cristal.org'/
     -        1x,'============================================
     -=================='//
     -        1x,'Using files : ',a/)
  152 FORMAT(' POS.',I3,2X,9F5.1,3F8.4)
  301 FORMAT(' THE STRUCT. IS NON CENTRIC,')
  303 FORMAT(' THE STRUCT. IS CENTRIC,')
1100  format(/1x,'Configuration contains ',i5,' atoms of ',i1,' types'/) 
1200  format(/' Using ',i4,' r points spaced at ',f5.3,
     - 'A up to ',f6.3,'A'/)
1300  format(' WARNING: ',i3,' pairs cause g',2i1,' to be ',
     - 'non-zero at ',f4.2,'A')
 1611 FORMAT(24X,15HROTATION MATRIX,15X,18HTRANSLATION VECTOR)
      STOP
      END
      SUBROUTINE DATN
C 
C-
C      IMPLICIT NONE
      CHARACTER*8 DA
      CHARACTER*10 TIME
      CHARACTER*5 ZONE
      INTEGER*4 DT_VALUES(8)    ! Return values from DATE_AND_TIME
      CHARACTER*3 MONTHS(12)    ! Month names
      DATA MONTHS /'Jan','Feb','Mar','Apr','May','Jun',
     1             'Jul','Aug','Sep','Oct','Nov','Dec'/

C
C Get current date values
C
      CALL DATE_AND_TIME (DA,TIME,ZONE,DT_VALUES)
C
C Format date
C
      WRITE(20,10) DT_VALUES(3),
     1 MONTHS(DT_VALUES(2)),DT_VALUES(1),DT_VALUES(5),
     2 DT_VALUES(6),DT_VALUES(7)
10    FORMAT(1X,I2,'-',A3,'-',I4,'   Hour: ',I2,' Min: ',I2,
     -' Sec: ',I2)
C
C
      RETURN
      END
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
*
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
*
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close(unit,status='delete')
      return
      end
*
*-----------------------------------------------------------------------
*
*     Subroutine open_write opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
      subroutine open_write(unit,file,extension)
      integer unit
      character*(*) file,extension,temp*80
      temp=file
      i=index(file,'.')
      l=len(file)
      do while (file(l:l).eq.' ')
         l=l-1
      enddo
      if (i.eq.0) temp=file(1:l)//extension
      open (unit,file=temp,status='old',err=10)
      close(unit,status='delete')
10    open (unit,file=temp,status='new')
      return
      end
*
*-----------------------------------------------------------------------
*
*     Subroutine esp_init must set the seed for the random number 
*     generator and obtain the current cpu clock reading in minutes
*
      subroutine esp_init(iseed,time_start)
      use portlib
      iseed=int(secnds(0.0))*2+1
      time_start=0.
*
*  run the random number generator 100 times
*  for avoiding affects of starting value
*
      do 10 i=1,100
      bidon=ran(iseed)
10    iseed=iseed/3
      write(20,*)' iseed = ',iseed
      return
      end
*
*-----------------------------------------------------------------------
*
      Subroutine list(TEXT,sigma,NTYP,nstart,rmax,nperm,ntest,
     -delta,nanneal,iprint,timelim,timesav,reject)
*
* Print some values and list to terminal
*
	DIMENSION delta(8)
      DIMENSION TEXT(20)
      write (*,100) TEXT
      write (20,100) TEXT
      write (*,140) sigma
      write (20,140) sigma
      write (*,141) reject
      write (20,141) reject
      do i=1,NTYP
         write (*,220) delta(i),i
         write (20,220) delta(i),i
      enddo
      write (*,221) nanneal
      write (20,221) nanneal
      write (*,260) iprint,timelim,timesav
      write (20,260) iprint,timelim,timesav
      write (*,261) nstart,rmax
      write (20,261) nstart,rmax
      write (*,262) nperm
      write (20,262) nperm
      write (*,263) ntest
      write (20,263) ntest
      return
100   format(/1x,'Title of run : ',20A4)
140   format(/1x,'Overall standard deviation is ',f7.4/)
141   format(1x,'Accept a move even if -',F10.6,' < deltaR < 0.'/)
180   format(10x,i1,'-',i1,5x,f6.3,' A')
220   format(' Maximum change in any coordinate is ',f8.3,
     - 'A for particles of type ',i2)
221   format(/' Move amplitudes will be progressively reduced by
     - move=move*(1.-ngen/maxngen)**n'/,20X,'with n = ',I4)
260   format(/' Writing summary every ',i10,' generated moves'/
     - ' Programme will run for ',f10.1,' moves saving every ',
     - f10.1,' moves'/)
261   format(' Restart after',i7,' events',
     - ' if the R factor is still higher than ',f6.3/)
262   format(' One permutation after ',i10,' generated moves'/)
263   format(' Number of different starting configurations to test :',
     -i5)
      end
*
***********************************************************************
*
      subroutine profile1(NHKL,F)
      COMMON/YCALC/THETA(1000),HW(1000),U,V,W,N,N1,N2,
     -YCALC(16000),Y(16000),BBB(1000),POS(16000),HW4(1000),
     -OMEGA(100,1000)
      DIMENSION F(1000)
*  Sum at each point 
100   continue
      DO 191 K=1,N
      Y(K)=0.   
*  SUM on all hkl     
      DO 190 J=1,NHKL   
      DELTA=POS(K)-THETA(J)
      IF(ABS(DELTA).GT.HW4(J))GO TO 190
      DELT=DELTA*DELTA
      OMEG=EXP(-DELT/BBB(J))/HW(J)
      Y(K)=Y(K)+OMEG*F(J)
190   CONTINUE
C      write(20,*)POS(K),Y(K)
      IF(Y(K).LT.0.01)Y(K)=0.
191   CONTINUE
      DO 192 K=1,N
192   IF(Y(K).NE.0.)GO TO 193
193   N1=K   
      L=N+1
      DO 194 K=1,N
      L=L-1
194   IF(Y(L).NE.0.)GO TO 195
195   N2=L   
      RETURN
      END
*
***********************************************************************
*
      subroutine profile3(NHKL,F,sum_fs,DIFF)
      COMMON/YCALC/THETA(1000),HW(1000),U,V,W,N,N1,N2,
     -Y(16000),YOBS(16000),BBB(1000),POS(16000),HW4(1000),
     -OMEGA(100,1000)
      DIMENSION F(1000),KK(1000)
*  Sum at each point 
      sum_fs=0.
      DIFF=0.
      DO 189 J=1,NHKL
189   KK(J)=0
      DO 191 K=N1,N2
      IF(YOBS(K).EQ.0.)GO TO 191
      Y(K)=0.   
*  SUM on all hkl      
      DO 190 J=1,NHKL   
      DELTA=POS(K)-THETA(J)
      IF(ABS(DELTA).GT.HW4(J))GO TO 190
      KK(J)=KK(J)+1
      DELT=DELTA*DELTA
      OMEGA(KK(J),J)=EXP(-DELT/BBB(J))/HW(J)
      Y(K)=Y(K)+OMEGA(KK(J),J)*F(J)
190   CONTINUE
191   CONTINUE
      DO 192 K=N1,N2
      IF(YOBS(K).EQ.0.)GO TO 192
      sum_fs=sum_fs+(YOBS(K)-Y(K))**2
      DIFF=DIFF+ABS(YOBS(K)-Y(K))
192   CONTINUE
      RETURN
      END
*
***********************************************************************
*
      subroutine profile2(NHKL,F,sum_fs,DIFF)
      COMMON/YCALC/THETA(1000),HW(1000),U,V,W,N,N1,N2,
     -Y(16000),YOBS(16000),BBB(1000),POS(16000),HW4(1000),
     -OMEGA(100,1000)
      DIMENSION F(1000),KK(1000)
*  Sum at each point 
      sum_fs=0.
      DIFF=0.
      DO 189 J=1,NHKL
189   KK(J)=0
      DO 191 K=N1,N2
      IF(YOBS(K).EQ.0.)GO TO 191
      Y(K)=0.   
*  SUM on all hkl      
      DO 190 J=1,NHKL   
      DELTA=POS(K)-THETA(J)
      IF(ABS(DELTA).GT.HW4(J))GO TO 190
      KK(J)=KK(J)+1
      Y(K)=Y(K)+OMEGA(KK(J),J)*F(J)
190   CONTINUE
191   CONTINUE
      DO 192 K=N1,N2
      IF(YOBS(K).EQ.0.)GO TO 192
      sum_fs=sum_fs+(YOBS(K)-Y(K))**2
      DIFF=DIFF+ABS(YOBS(K)-Y(K))
192   CONTINUE
      RETURN
      END
*
*-----------------------------------------------------------------------
*
      subroutine esp_genmove(NA,iseed,ncum,delta,imove,move,
     -A,BB,C,dump,nsp)
      real    move(192,6),delta(*)
      dimension nsp(100)
      integer ncum(*) 
1000  imove=int(ran(iseed)*NA)+1
      mtype=1
      do while (imove.gt.ncum(mtype))
         mtype=mtype+1
      enddo
      if (delta(mtype).le.0.) goto 1000
      go to (1,2,3,4,5,6,7,8,9,10,11,12,13,14), nsp(imove)
*  General position
1     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=2.*(ran(iseed)-0.5)*delta(mtype)/BB*dump
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  x,x,x : supposes a cubic symmetry
2     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=move(1,4)
      move(1,6)=move(1,4)
      return
*  0,0,0 : no move
3     GO TO 1000
*  1/2,0,0 : no move
14    GO TO 1000
*  x,1/4,z
4     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=0.
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  0,1/2,z
5     move(1,4)=0.
      move(1,5)=0.
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  x,0,z
6     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=0.
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  x,0,1/4
7     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=0.
      move(1,6)=0.
      return
*  0,0,z
8     move(1,4)=0.
      move(1,5)=0.
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  x,y,0
9     move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=2.*(ran(iseed)-0.5)*delta(mtype)/BB*dump
      move(1,6)=0.
      return
*  0,y,z
10    move(1,4)=0.
      move(1,5)=2.*(ran(iseed)-0.5)*delta(mtype)/BB*dump
      move(1,6)=2.*(ran(iseed)-0.5)*delta(mtype)/C*dump
      return
*  1/2,y,0
11    move(1,4)=0.
      move(1,5)=2.*(ran(iseed)-0.5)*delta(mtype)/BB*dump
      move(1,6)=0.
      return
*  0,y,0
12    move(1,4)=0.
      move(1,5)=2.*(ran(iseed)-0.5)*delta(mtype)/BB*dump
      move(1,6)=0.
      return
*  x,0,0
13    move(1,4)=2.*(ran(iseed)-0.5)*delta(mtype)/A*dump
      move(1,5)=0.
      move(1,6)=0.
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_genmovep(NA,XL,MTYP,iseed,ncum,delta,imove1,
     -   imove2,movep,nsp)
      real    movep(2,6),delta(*),XL(5,100)
      integer ncum(*),nsp(*),MTYP(100)
*
*  Find two atoms to be permuted
*
      jn=0
10    imove1=int(ran(iseed)*NA)+1
      jn=jn+1
      if(jn.ge.1000) go to 1000
      mtype=1
      do while (imove1.gt.ncum(mtype))
         mtype=mtype+1
      enddo
      if (delta(mtype).le.0.) goto 10
20    imove2=int(ran(iseed)*NA)+1
      jn=jn+1
      if(jn.ge.1000) go to 1000
      mtype=1
      do while (imove2.gt.ncum(mtype))
         mtype=mtype+1
      enddo
      if (delta(mtype).le.0.) goto 20
      if(MTYP(imove1).eq.MTYP(imove2))go to 10
      if(nsp(imove1).ne.nsp(imove2))go to 10
      movep(1,4)=XL(1,imove2)
      movep(1,5)=XL(2,imove2)
      movep(1,6)=XL(3,imove2)
      movep(2,4)=XL(1,imove1)
      movep(2,5)=XL(2,imove1)
      movep(2,6)=XL(3,imove1)
      return
1000  Write(*,*)' Are you sure that permutations are possible ?'
      Write(20,*)' Are you sure that permutations are possible ?'
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_newpos(XL,move,imove,NCON)
      real move(192,6),XL(5,100)
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
*
      move(1,1)=XL(1,imove)
      move(1,2)=XL(2,imove)
      move(1,3)=XL(3,imove)
      move(1,4)=move(1,1)+move(1,4)+3.
      move(1,5)=move(1,2)+move(1,5)+3.
      move(1,6)=move(1,3)+move(1,6)+3.
      move(1,4)=2.*(move(1,4)/2.-int(move(1,4)/2.))-1.
      move(1,5)=2.*(move(1,5)/2.-int(move(1,5)/2.))-1.
      move(1,6)=2.*(move(1,6)/2.-int(move(1,6)/2.))-1.
      IF(NCON.EQ.1)GO TO 10
      return
10    X=move(1,1)
      Y=move(1,2)
      Z=move(1,3)
      DO 801 K=2,NAS
      move(K,1)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      move(K,2)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
801   move(K,3)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
      X=move(1,4)
      Y=move(1,5)
      Z=move(1,6)
      DO 802 K=2,NAS
      move(K,4)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      move(K,5)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
802   move(K,6)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_newposp(XL,movep,imove1,imove2)
      real movep(2,6),XL(5,100)
*
      movep(1,1)=XL(1,imove1)
      movep(1,2)=XL(2,imove1)
      movep(1,3)=XL(3,imove1)
      movep(2,1)=XL(1,imove2)
      movep(2,2)=XL(2,imove2)
      movep(2,3)=XL(3,imove2)
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_check(NTYP,metric,ncum,rcut,imove,move,acceptable)
      real rcut(*),metric(3,3),move(192,6)
      integer ncum(*)
      logical acceptable
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
*
*     Check whether the move
*     is acceptable according to the cut-off restrictions
*
      im=imove*NAS-NAS+1
      itype=1
      jtype=1
      do while (im.gt.ncum(jtype))
         jtype=jtype+1
      enddo
* Sum on independent atoms
      do 10 i=1,NATT,NAS
* Sum on moving atoms
      do 10 L=1,NAS
        if (i.gt.ncum(itype)) itype=itype+1
         if (i.ne.(L+im-1)) then
            i1=min(itype,jtype)
            j1=max(itype,jtype)
            ic=(i1-1)*(2*NTYP-i1)/2+j1
*
            x=XLL(1,i)-move(L,1)+3.
            y=XLL(2,i)-move(L,2)+3.
            z=XLL(3,i)-move(L,3)+3.
            x=2.*(x/2.-int(x/2.))-1.
            y=2.*(y/2.-int(y/2.))-1.
            z=2.*(z/2.-int(z/2.))-1.
            dold=metric(1,1)*x*x+metric(2,2)*y*y+metric(3,3)*z*z
     -       +2.*(metric(1,2)*x*y+metric(1,3)*x*z+metric(2,3)*y*z)
            dold=sqrt(dold)
*
* Avoid problems with special positions
*
            if(dold.lt.0.0001)go to 10
*
            x=XLL(1,i)-move(L,4)+3.
            y=XLL(2,i)-move(L,5)+3.
            z=XLL(3,i)-move(L,6)+3.
            x=2.*(x/2.-int(x/2.))-1.
            y=2.*(y/2.-int(y/2.))-1.
            z=2.*(z/2.-int(z/2.))-1.
            dnew=metric(1,1)*x*x+metric(2,2)*y*y+metric(3,3)*z*z
     -       +2.*(metric(1,2)*x*y+metric(1,3)*x*z+metric(2,3)*y*z)
            dnew=sqrt(dnew)
            if (dnew.lt.rcut(ic).and.(dnew.lt.dold)) acceptable=.false.
C       write(20,21)i,L,jtype,itype,ic,im,dold,dnew,rcut(ic)
C  21    format(6I4,3F9.5)
            if(.not.acceptable)return
*
         endif
10      continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_checkMR(XL,NTYP,metric,ncum,rcut,acceptable)
      real XL(3,100),rcut(*),metric(3,3)
      integer ncum(*)
      logical acceptable
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
*
*     Check whether the move
*     is acceptable according to the cut-off restrictions
*
      I=0
      DO 800 L=1,NA
      X=XL(1,L)
      Y=XL(2,L)
      Z=XL(3,L)
      DO 800 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
800   CONTINUE
      itype=1
* Sum on independent atoms
      do 10 i=1,NATT,NAS
* Sum on moving atoms
      do 10 L=1,NATT
        if (i.gt.ncum(itype)) itype=itype+1
         if (i.ne.L) then
      jtype=1
      do while (L.gt.ncum(jtype))
         jtype=jtype+1
      enddo
            i1=min(itype,jtype)
            j1=max(itype,jtype)
            ic=(i1-1)*(2*NTYP-i1)/2+j1
*
            x=XLL(1,i)-XLL(1,L)+3.
            y=XLL(2,i)-XLL(2,L)+3.
            z=XLL(3,i)-XLL(3,L)+3.
            x=2.*(x/2.-int(x/2.))-1.
            y=2.*(y/2.-int(y/2.))-1.
            z=2.*(z/2.-int(z/2.))-1.
            d=metric(1,1)*x*x+metric(2,2)*y*y+metric(3,3)*z*z
     -       +2.*(metric(1,2)*x*y+metric(1,3)*x*z+metric(2,3)*y*z)
            d=sqrt(d)
*
* Avoid problems with special positions
*
            if(d.lt.0.0001)go to 10
*
            if (d.lt.rcut(ic)) acceptable=.false.
            if(.not.acceptable)return
*
         endif
10      continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_sumstot(NHKL,FOBS,KXR,XL,imove,move,DIFF,
     -NA,sum_fs,sum_f,sum_y,KP,NPAT)
      DIMENSION FOBS(1000),XL(5,100),SNEWT(1000),SNEW(2,1000)
      real move(192,6)
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
*
      im=imove
      XL(1,im)=move(1,4)
      XL(2,im)=move(1,5)
      XL(3,im)=move(1,6)
         sum_fs=0.
C
C  CALCULATION OF NEW |F|s
C
      SUMCAL=0.
C
C  Main loop
C
      DO 1000 NM=1,NHKL
      SNEWT(NM)=0.
      DO 1000 NTW=1,NPAT
      DO 121 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 72 J=1,3
72    ARG=ARG+H(NTW,IR,J,NM)*XL(J,im)
      ARG=6.28318530718*ARG
      COSAR(NTW,im,IR,NM)=COS(ARG)
121   SINAR(NTW,im,IR,NM)=SIN(ARG)
      AV=0.
      BV=0.
      DO 170 I=1,NA
      SAI=0.
      SBI=0.
      DO 140 IR=1,IRL
      SAI=SAI+COSAR(NTW,I,IR,NM)
      IF(ICENT.EQ.1)SBI=SINAR(NTW,I,IR,NM)+SBI
140   CONTINUE
      SAI=FLOAT(ICENT)*SAI
      IF(KXR.LT.4)GO TO 150
      GOTO 161
150   AV=SNEXIN(I)*SAI+AV
      BV=SNEXIN(I)*SBI+BV
      IF(KXR.LT.4)GO TO 170
161   AV=SNEXIX(I,NM)*SAI+AV
      BV=SNEXIX(I,NM)*SBI+BV
      AVI=AV-SNXI(I)*SBI
      AVJ=AV+SNXI(I)*SBI
      BVI=BV-SNXI(I)*SAI
      BVJ=BV+SNXI(I)*SAI
170   CONTINUE
190   IF(KXR.LT.4)GOTO 200
      snew(NTW,NM)=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)
      GOTO 210
200   snew(NTW,NM)=(AV*AV+BV*BV)
210   snew(NTW,NM)=SQRT(snew(NTW,NM))
      SUMCAL=SUMCAL+snew(NTW,NM)
      SNEWT(NM)=SNEWT(NM)+SNEW(NTW,NM)
1000  CONTINUE
      DIFF=0.
      XL(1,im)=move(1,1)
      XL(2,im)=move(1,2)
      XL(3,im)=move(1,3)
      DO 1001 NM=1,NHKL
      snewt(NM)=snewt(NM)/SUMCAL*sum_f
      IF(KP.EQ.1)GO TO 74
      sum_fs=sum_fs+(FOBS(NM)-snewt(NM))**2
      DIFF=DIFF+ABS(FOBS(NM)-snewt(NM))
74    DO 1001 NTW=1,NPAT
      DO 131 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 73 J=1,3
73    ARG=ARG+H(NTW,IR,J,NM)*XL(J,im)
      ARG=6.28318530718*ARG
      COSAR(NTW,im,IR,NM)=COS(ARG)
131   SINAR(NTW,im,IR,NM)=SIN(ARG)
1001  CONTINUE
      IF(KP.EQ.1)GO TO 1003
      DIFF=DIFF/sum_f
      IF(KP.EQ.0.OR.KP.EQ.2)GO TO 1004
1003  CALL profile2(NHKL,SNEWT,sum_fs,DIFF)
      DIFF=DIFF/sum_y
1004  continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_sumstotp(NHKL,FOBS,KXR,XL,imove1,imove2,movep,
     -DIFF,NA,sum_fs,sum_f,sum_y,KP,NPAT)
      DIMENSION FOBS(1000),XL(5,100),SNEWT(1000),SNEW(2,1000)
      real movep(2,6)
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
*
      XL(1,imove1)=movep(1,4)
      XL(2,imove1)=movep(1,5)
      XL(3,imove1)=movep(1,6)
      XL(1,imove2)=movep(2,4)
      XL(2,imove2)=movep(2,5)
      XL(3,imove2)=movep(2,6)
         sum_fs=0.
C
C  CALCULATION OF NEW |F|s
C
      SUMCAL=0.
C
C
      DO 1000 NM=1,NHKL
      SNEWT(NM)=0.
      DO 1000 NTW=1,NPAT
      DO 120 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 70 J=1,3
70    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove1)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove1,IR,NM)=COS(ARG)
120   SINAR(NTW,imove1,IR,NM)=SIN(ARG)
      DO 130 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 71 J=1,3
71    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove2)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove2,IR,NM)=COS(ARG)
130   SINAR(NTW,imove2,IR,NM)=SIN(ARG)
      AV=0.
      BV=0.
      DO 170 I=1,NA
      SAI=0.
      SBI=0.
      DO 140 IR=1,IRL
      SAI=SAI+COSAR(NTW,I,IR,NM)
      IF(ICENT.EQ.1)SBI=SINAR(NTW,I,IR,NM)+SBI
140   CONTINUE
      SAI=FLOAT(ICENT)*SAI
      IF(KXR.LT.4)GO TO 150
      GOTO 161
150   AV=SNEXIN(I)*SAI+AV
      BV=SNEXIN(I)*SBI+BV
      IF(KXR.LT.4)GO TO 170
161   AV=SNEXIX(I,NM)*SAI+AV
      BV=SNEXIX(I,NM)*SBI+BV
      AVI=AV-SNXI(I)*SBI
      AVJ=AV+SNXI(I)*SBI
      BVI=BV-SNXI(I)*SAI
      BVJ=BV+SNXI(I)*SAI
170   CONTINUE
190   IF(KXR.LT.4)GOTO 200
      snew(NTW,NM)=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)
      GOTO 210
200   snew(NTW,NM)=(AV*AV+BV*BV)
210   snew(NTW,NM)=SQRT(snew(NTW,NM))
      SUMCAL=SUMCAL+snew(NTW,NM)
      snewt(NM)=snewt(NM)+snew(NTW,NM)
1000  CONTINUE
      DIFF=0.
      XL(1,imove1)=movep(1,1)
      XL(2,imove1)=movep(1,2)
      XL(3,imove1)=movep(1,3)
      XL(1,imove2)=movep(2,1)
      XL(2,imove2)=movep(2,2)
      XL(3,imove2)=movep(2,3)
      DO 1001 NM=1,NHKL
      DO 131 NTW=1,NPAT
      DO 121 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 72 J=1,3
72    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove1)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove1,IR,NM)=COS(ARG)
121   SINAR(NTW,imove1,IR,NM)=SIN(ARG)
      DO 131 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 73 J=1,3
73    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove2)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove2,IR,NM)=COS(ARG)
131   SINAR(NTW,imove2,IR,NM)=SIN(ARG)
      snewt(NM)=snewt(NM)/SUMCAL*sum_f
      IF(KP.EQ.1)GO TO 1001
      sum_fs=sum_fs+(FOBS(NM)-snewt(NM))**2
      DIFF=DIFF+ABS(FOBS(NM)-snewt(NM))
1001  CONTINUE
      IF(KP.EQ.1)GO TO 1003
      DIFF=DIFF/sum_f
      IF(KP.EQ.0.OR.KP.EQ.2)GO TO 1004
1003  CALL profile2(NHKL,SNEWT,sum_fs,DIFF)
      DIFF=DIFF/sum_y
1004  continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_sumMR(NHKL,FOBS,KXR,XL,
     -DIFF,NA,sum_fs,sum_f,sum_y,KP,NPAT)
      DIMENSION FOBS(1000),XL(3,100),SNEW(2,1000),SNEWT(1000)
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
*
         sum_fs=0.
C
C  CALCULATION OF NEW |F|s
C
      SUMCAL=0.
C
C
      DO 1000 NM=1,NHKL
      SNEWT(NM)=0.
      DO 1000 NTW=1,NPAT
      DO 120 I=1,NA
      DO 120 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 70 J=1,3
70    ARG=ARG+H(NTW,IR,J,NM)*XL(J,I)
      ARG=6.28318530718*ARG
      COSAR(NTW,I,IR,NM)=COS(ARG)
120   SINAR(NTW,I,IR,NM)=SIN(ARG)
      AV=0.
      BV=0.
      DO 170 I=1,NA
      SAI=0.
      SBI=0.
      DO 140 IR=1,IRL
      SAI=SAI+COSAR(NTW,I,IR,NM)
      IF(ICENT.EQ.1)SBI=SINAR(NTW,I,IR,NM)+SBI
140   CONTINUE
      SAI=FLOAT(ICENT)*SAI
      IF(KXR.LT.4)GO TO 150
      GOTO 161
150   AV=SNEXIN(I)*SAI+AV
      BV=SNEXIN(I)*SBI+BV
      IF(KXR.LT.4)GO TO 170
161   AV=SNEXIX(I,NM)*SAI+AV
      BV=SNEXIX(I,NM)*SBI+BV
      AVI=AV-SNXI(I)*SBI
      AVJ=AV+SNXI(I)*SBI
      BVI=BV-SNXI(I)*SAI
      BVJ=BV+SNXI(I)*SAI
170   CONTINUE
190   IF(KXR.LT.4)GOTO 200
      snew(NTW,NM)=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)
      GOTO 210
200   snew(NTW,NM)=(AV*AV+BV*BV)
210   snew(NTW,NM)=SQRT(snew(NTW,NM))
      SUMCAL=SUMCAL+snew(NTW,NM)
      SNEWT(NM)=SNEWT(NM)+SNEW(NTW,NM)
1000  CONTINUE
      DIFF=0.
      DO 1001 NM=1,NHKL
      snewt(NM)=snewt(NM)/SUMCAL*sum_f
      IF(KP.EQ.1)GO TO 1001
      sum_fs=sum_fs+(FOBS(NM)-snewt(NM))**2
      DIFF=DIFF+ABS(FOBS(NM)-snewt(NM))
1001  CONTINUE
      IF(KP.EQ.1)GO TO 1003
      DIFF=DIFF/sum_f
      IF(KP.EQ.0.OR.KP.EQ.2)GO TO 1004
1003  CALL profile2(NHKL,SNEWT,sum_fs,DIFF)
      DIFF=DIFF/sum_y
1004  continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_chisq(sum_fs,sigma,chisq,chisq1,DIFF,ichi,diff1)
*
*
      go to (1,2),ichi
1        chisq=sum_fs
         chisq=chisq/sigma/sigma
         chisq1=chisq1+chisq
         diff1=diff1+diff
         go to 3
2        chisq=DIFF
         chisq1=chisq1+chisq
         diff1=diff1+diff
3     continue
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_makemovep(XL,imove1,imove2,movep,NHKL,NCON,NPAT)
      real movep(2,6)
      DIMENSION XL(5,100)
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
      XL(1,imove1)=movep(1,4)
      XL(2,imove1)=movep(1,5)
      XL(3,imove1)=movep(1,6)
      IF(NCON.EQ.0)GO TO 10
      im1=imove1
      X=XL(1,im1)
      Y=XL(2,im1)
      Z=XL(3,im1)
      I=(im1-1)*NAS
      DO 801 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
801   CONTINUE
10    XL(1,imove2)=movep(2,4)
      XL(2,imove2)=movep(2,5)
      XL(3,imove2)=movep(2,6)
      IF(NCON.EQ.0)GO TO 20
      im2=imove2
      X=XL(1,im2)
      Y=XL(2,im2)
      Z=XL(3,im2)
      I=(im2-1)*NAS
      DO 803 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
803   CONTINUE
C
C
20    DO 1000 NM=1,NHKL
      DO 1000 NTW=1,NPAT
      DO 121 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 72 J=1,3
72    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove1)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove1,IR,NM)=COS(ARG)
121   SINAR(NTW,imove1,IR,NM)=SIN(ARG)
      DO 131 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 73 J=1,3
73    ARG=ARG+H(NTW,IR,J,NM)*XL(J,imove2)
      ARG=6.28318530718*ARG
      COSAR(NTW,imove2,IR,NM)=COS(ARG)
131   SINAR(NTW,imove2,IR,NM)=SIN(ARG)
1000  CONTINUE
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_makemove(XL,imove,move,NHKL,NCON,NPAT)
      real move(192,6)
      DIMENSION XL(5,100)
      COMMON/TABCOS/COSAR(2,100,24,1000),SINAR(2,100,24,1000),
     -TR(2,24,1000),H(2,24,3,1000),IRL,ICENT,SNXI(100),
     -SNEXIN(100),SNEXIX(100,1000)
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
      im=imove
      XL(1,im)=move(1,4)
      XL(2,im)=move(1,5)
      XL(3,im)=move(1,6)
         do i=1,3
           XL(i,im)=XL(i,im)-INT(XL(i,im))
           if(XL(i,im).GT.1.)XL(i,im)=XL(i,im)-1.
           if(XL(i,im).LT.0.)XL(i,im)=XL(i,im)+1.
         enddo
      IF(NCON.EQ.0)GO TO 10
      I=(im-1)*NAS
      X=XL(1,im)
      Y=XL(2,im)
      Z=XL(3,im)
      DO 801 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
         do j=1,3
           XLL(j,i)=XLL(j,i)-INT(XLL(j,i))
           if(XLL(j,I).GT.1.)XLL(j,I)=XLL(j,I)-1.
           if(XLL(j,I).LT.0.)XLL(j,I)=XLL(j,I)+1.
         enddo
801   CONTINUE
C
C
10    DO 1000 NM=1,NHKL
      DO 1000 NTW=1,NPAT
      DO 121 IR=1,IRL
      ARG=TR(NTW,IR,NM)
      DO 72 J=1,3
72    ARG=ARG+H(NTW,IR,J,NM)*XL(J,im)
      ARG=6.28318530718*ARG
      COSAR(NTW,im,IR,NM)=COS(ARG)
121   SINAR(NTW,im,IR,NM)=SIN(ARG)
1000  CONTINUE
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine esp_makeMR(XL,XLN,NCON)
      DIMENSION XL(5,100),XLN(3,100)
      COMMON/XYZ/XLL(3,19200),NATT,NAS,NA,SMT(192,3,3),TT(192,3)
      DO 900 im=1,NA
      XL(1,im)=XLN(1,im)
      XL(2,im)=XLN(2,im)
      XL(3,im)=XLN(3,im)
c         do i=1,3
c           XL(i,im)=XL(i,im)-INT(XL(i,im))
c           if(XL(i,im).GT.1.)XL(i,im)=XL(i,im)-1.
c           if(XL(i,im).LT.0.)XL(i,im)=XL(i,im)+1.
c         enddo
      IF(NCON.EQ.0)GO TO 900
      I=(im-1)*NAS
      X=XL(1,im)
      Y=XL(2,im)
      Z=XL(3,im)
      DO 801 K=1,NAS
      I=I+1
      XLL(1,I)=X*SMT(K,1,1)+Y*SMT(K,1,2)+Z*SMT(K,1,3)+TT(K,1)
      XLL(2,I)=X*SMT(K,2,1)+Y*SMT(K,2,2)+Z*SMT(K,2,3)+TT(K,2)
      XLL(3,I)=X*SMT(K,3,1)+Y*SMT(K,3,2)+Z*SMT(K,3,3)+TT(K,3)
         do j=1,3
           XLL(j,i)=XLL(j,i)-INT(XLL(j,i))
           if(XLL(j,I).GT.1.)XLL(j,I)=XLL(j,I)-1.
           if(XLL(j,I).LT.0.)XLL(j,I)=XLL(j,I)+1.
         enddo
801   CONTINUE
900   CONTINUE
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine espo_summary(nacc,ngen,ntried,naccp,ntriedp,
     -DIFF,chisq1,nreject,NCON,dump,MR)
      if(ntriedp.le.1)ntriedp=0
      nacc=nacc-naccp
      IF(NCON.EQ.1.AND.MR.EQ.0)GO TO 10
      IF(MR.NE.0)GO TO 20
         write (*,*)
         write (*,'(2(i7,a),g9.3,a,F5.3)') nacc,' moves acc. ',
     -   ntried,' tested; Chi**2=',chisq1,', R=',DIFF
      write (*,'(2(i7,a))') naccp,' perm. acc. ',ntriedp,' tested'
         write(*,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
         write (20,*)
         write (20,'(2(i7,a),g9.3,a,F5.3)') nacc,' moves acc. ',
     -    ntried,' tested; Chi**2=',chisq1,', R=',DIFF
       write (20,'(2(i7,a))') naccp,' perm. acc. ',ntriedp,' tested'
         write(20,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
      nacc=nacc+naccp
      return
10    continue
         write (*,*)
         write (*,'(3(i7,a),g9.3,a,F5.3)') nacc,' moves acc. ',
     -    ngen,' gen. and ',ntried,
     - ' tested; Chi**2=',chisq1,', R=',DIFF
      write (*,'(2(i7,a))') naccp,' perm. acc. ',ntriedp,' tested'
         write(*,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
         write (20,*)
         write (20,'(3(i7,a),g9.3,a,F5.3)') nacc,' moves acc. ',
     -    ngen,' gen. and ',ntried,
     - ' tested; Chi**2=',chisq1,', R=',DIFF
       write (20,'(2(i7,a))') naccp,' perm. acc. ',ntriedp,' tested'
         write(20,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
      nacc=nacc+naccp
      return
20    continue
         write (*,*)
         write (*,'(3(i7,a),g9.3,a,F5.3)') nacc,' rot. acc. ',
     -    ngen,' gen. and ',ntried,
     - ' tested; Chi**2=',chisq1,', R=',DIFF
      write (*,'(2(i7,a))') naccp,' trans. acc. ',ntriedp,' tested'
         write(*,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
         write (20,*)
         write (20,'(3(i7,a),g9.3,a,F5.3)') nacc,' rot. acc. ',
     -    ngen,' gen. and ',ntried,
     - ' tested; Chi**2=',chisq1,', R=',DIFF
       write (20,'(2(i7,a))') naccp,' trans. acc. ',ntriedp,' tested'
         write(20,'(i7,a,F9.6)')nreject,' events did not improved
     - the fit, dump =',dump
      nacc=nacc+naccp
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine write_config(TEXT,ngen,ntried,nacc,nsaved,
     - NA,NTYP,NAT,XL,ichan)
      real          XL(5,100)
      integer       NAT(*)
      real          sites(3,1,100)
      integer       nsites(100)
      DIMENSION TEXT(20)
*
      do i=1,NTYP
         nsites(i)=1
         sites(1,1,i)=0.
         sites(2,1,i)=0.
         sites(3,1,i)=0.
      enddo
      call write_esp_config(TEXT,ngen,ntried,nacc,
     -NA,NTYP,NAT,0,XL,ichan)
*
      return
      end
*
*-----------------------------------------------------------------------
*
      subroutine write_esp_config(TEXT,ngen,ntried,nacc,
     -NA,NTYP,NAT,neuler,XL,ichan)
      real          XL(5,100),TEXT(20)
      integer       NAT(*)
*
*     Writes a configuration data file
*
      write (ichan,20) TEXT
20    format(20A4)
*
      write (ichan,*) 
      write (ichan,'(1x,3i10,a)') ngen,ntried,nacc,
     - ' moves generated, tried, accepted'
      write (ichan,*) 
      write (ichan,'(1x,i10,a)') NA,' molecules (of all types)'
*
      write (ichan,*)
*
      do itype=1,NTYP
         write (ichan,'(1x,i10,a,i2)') NAT(itype),
     -     ' molecules of type ',itype
      enddo
*
      do i=1,NA
         write (ichan,'(3(1x,f10.7),3(1x,f10.8))') 
     -    (XL(j,i),j=1,3+neuler)
      enddo
      return
      end
*
*-----------------------------------------------------------------------
*
      SUBROUTINE DCELL(CELLN,AL,RCELLN,V)
      DIMENSION CELLN(6),AL(3,3),RCELLN(6),CELL(6)
      DEGRAD=3.14159265359/180.0
      DO 30 I=1,6
30    CELL(I)=CELLN(I)
      DO 31 I=1,3
      L=I+3
      IF(CELL(L)-90.0)32,33,32
33    CELL(L)=0.0
      GOTO 31
32    CELL(L)=COS(DEGRAD*CELL(L))
31    CONTINUE
      CALL TRCL(CELL,RCELLN,V)
C     RCELL IS THE RECIPROCAL CELL CONSTANTS
      DO 34 I=1,3
      AL(I,I)=RCELLN(I)*RCELLN(I)
      CALL PERM(I,J,K)
      IF(J-K)35,36,36
35    AL(J,K)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
      GOTO 34
36    AL(K,J)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
34    CONTINUE
      DO 37 I=4,6
37    RCELLN(I)=ACOS(RCELLN(I))/DEGRAD
      RETURN
      END
*
*-----------------------------------------------------------------------
*
      SUBROUTINE TRCL(CELLN,RCELLN,V)
C     TRANSFORMS REAL CELL TO RECIPROCAL OR VICE VERSA
C     INPUT CELL IS IN ARRAY CELL AS LENGTHS AND COSINES
      DIMENSION CELLN(6),RCELLN(6)
	DIMENSION SINA(3)
      ABC=1.0
      PROD=2.0
      V=-2.0
      DO 10 I=1,3
      L=I+3
      SINA(I)=1.0-CELLN(L)**2
      V=V+SINA(I)
      SINA(I)=SQRT(SINA(I))
      PROD=PROD*CELLN(L)
10    ABC=ABC*CELLN(I)
      V=ABC*SQRT(V+PROD)
C      V IS CELL VOLUME
C     PUT INVERTED CELL INTO RCELL
      DO 20 I=1,3
      CALL PERM(I,J,K)
      RCELLN(I)=CELLN(J)*CELLN(K)*SINA(I)/V
      L=I+3
20    RCELLN(L)=(CELLN(J+3)*CELLN(K+3)-CELLN(L))/(SINA(J)
     2 *SINA(K))
      RETURN
      END
*
*-----------------------------------------------------------------------
*
      SUBROUTINE PERM(I,J,K)
C     PERMS USEFUL COMBINATIONS OF INTEGERS IN THE RANGE 1 TO 3
      IF(I-2)10,20,30
10    J=2
      K=3
      RETURN
20    J=3
      K=1
      RETURN
30    J=1
      K=2
      RETURN
      END
*
*********************************************************
*
      SUBROUTINE MATRIX(CELLN,RCELLN,TM2,TM1)
      DIMENSION CELLN(6),RCELLN(6),TM1(6),TM2(6)
      RAD=57.2957795    ! 180./Pi
C
C *** CALCULATE ORTHOGONAL MATRIX ***
C
      SING=SIN(CELLN(6)/RAD)
      COSG=COS(CELLN(6)/RAD)
      TM1(1)=1./CELLN(1)
      TM1(2)=-COSG/(CELLN(1)*SING)
      TM1(3)=RCELLN(1)*COS(RCELLN(5)/RAD)
      TM1(4)=1./(CELLN(2)*SING)
      TM1(5)=RCELLN(2)*COS(RCELLN(4)/RAD)
      TM1(6)=RCELLN(3)
C
C *** CALCULATE INVERSE MATRIX ***
C
      TM2(1)=CELLN(1)
      TM2(2)=CELLN(2)*COSG
      TM2(3)=CELLN(3)*COS(CELLN(5)/RAD)
      TM2(4)=CELLN(2)*SING
      TM2(5)=-CELLN(3)*SIN(CELLN(5)/RAD)*COS(RCELLN(4)/RAD)
      TM2(6)=1/TM1(6)
	RETURN
      END
*
*********************************************************
*
      SUBROUTINE TRANSLA(XL,XLN,NA,iseed,delta,A,BB,C,dump)
      DIMENSION XL(3,100),XLN(3,100)
      real delta(*)
      amove1=2.*(ran(iseed)-0.5)*delta(1)/A*dump
      amove2=2.*(ran(iseed)-0.5)*delta(1)/BB*dump
      amove3=2.*(ran(iseed)-0.5)*delta(1)/C*dump
      DO 1 I=1,NA
      XLN(1,I)=XL(1,I)+amove1
      XLN(2,I)=XL(2,I)+amove2
1     XLN(3,I)=XL(3,I)+amove3
      RETURN
      END
*
*********************************************************
*
      SUBROUTINE ROTATE(XL,XLN,NA,iseed,TM1,TM2,S,dump,ngrav,XG)
      DIMENSION XL(5,100),XLN(3,100),TM1(6),TM2(6),XG(3)
      PI=3.141592654
      PI2=6.283185307
C
C  Find current gravity center
C
      if(ngrav.eq.1) go to 101
      X=0.
      Y=0.
      Z=0.
      DO 100 I=1,NA
      X=X+XL(1,I)
      Y=Y+XL(2,I)
100   Z=Z+XL(3,I)
      XG(1)=X/S
      XG(2)=Y/S
      XG(3)=Z/S      
C
C  Change coordinates of the rigid model in Cartesian coordinates
C
101   DO 1 I=1,NA
      XA=XL(1,I)-XG(1)
      YA=XL(2,I)-XG(2)
      ZA=XL(3,I)-XG(3)
      XLN(1,I)=TM1(1)*XA+TM1(2)*YA+TM1(3)*ZA
      XLN(2,I)=TM1(4)*YA+TM1(5)*ZA
      XLN(3,I)=TM1(6)*ZA
1     CONTINUE
C
C  Find 3 Euler angles at random
C
C      t1=ran(iseed)*PI2*dump
      t1=ran(iseed)*PI*dump
      t2=ran(iseed)*PI2*dump
      t3=ran(iseed)*PI2*dump
      ct1=COS(t1)
      st1=SIN(t1)
      ct2=COS(t2)
      st2=SIN(t2)
      ct3=COS(t3)
      st3=SIN(t3)
      R1=ct1*ct3-st1*ct2*st3
      R2=st1*ct3+ct1*ct2*st3
      R3=st2*st3
      R4=-st1*ct2*ct3-ct1*st3
      R5=-st1*st3+ct1*ct2*ct3
      R6=st2*ct3
      R7=st1*st2
      R8=-ct1*st2
      R9=ct2
      DO 20 I=1,NA
C
C  Apply the rotation matrix
C
      XX=R1*XLN(1,I)+R2*XLN(2,I)+R3*XLN(3,I)
      YY=R4*XLN(1,I)+R5*XLN(2,I)+R6*XLN(3,I)
      ZZ=R7*XLN(1,I)+R8*XLN(2,I)+R9*XLN(3,I)
      XLN(1,I)=XX
      XLN(2,I)=YY
      XLN(3,I)=ZZ
C
C  Refurbish the coordinates in the unknown structure cell
C
      XLN(1,I)=TM2(1)*XLN(1,I)+TM2(2)*XLN(2,I)+TM2(3)*XLN(3,I)+XG(1)
      XLN(2,I)=TM2(4)*XLN(2,I)+TM2(5)*XLN(3,I)+XG(2)
      XLN(3,I)=TM2(6)*XLN(3,I)+XG(3)
20    CONTINUE
C
C  We have now the new rotated rigid model inside the unknown
C
      RETURN
      END
*
*********************************************************
*
      SUBROUTINE BURZ (ISYSTM,ISYMCE,IBRAVL,NG)
C-----ROUTINE TO INTERPRET HERMANN MAUGUIN SYMBOL FOR SPACE GROUP
C-----THIS ROUTINE HAS BEEN ADAPTED FROM A PROGRAM SUPPLIED BY
C-----PROF. BURZLAFF, UNIVERSITY OF ERLANGEN, GERMANY
      INTEGER E(3,3),ZEI(3,4),SYS,SS
      COMMON/BURC/TS,SS
      COMMON /POSIT/ NT
      DIMENSION NT(45), IBRA(7), NMA(3), SH(3),TE(3)
      DIMENSION RN(3), RD(3), S1(3), S2(3), S3(3),ISYS(7)
      DIMENSION SS(24,3,3),TS(24,3)
      INTEGER N3(20)
      DATA ISYS/7,1,2,4,6,5,3/
      DATA IBRA/'P','A','B','C','F','I','R'/,NMA/3*0/,SH/3*0.25/
      DATA N3/'1','2','3','4',' ','6','A','B','C','D','M','N','P',
     1        ' ','/','-',4*' '/
 1    NBL=-1
      NG=1
      NS=1
      DO 2 I=1,24
      DO 2 J=1,3
      TS(I,J)=0.0
      DO 2 K=1,3
      E(J,K)=0
      SS(I,J,K)=0
 2    CONTINUE
      SS(1,1,1)=1
      SS(1,2,2)=1
      SS(1,3,3)=1
      DO 3 I=1,3
      TE(I)=0.0
      DO 3 J=1,4
 3    ZEI(I,J)=0
      DO 8 I=1,36
      KXK=NT(I)
      IF (KXK.NE.N3(5)) GO TO 4
      NLQ=0
      IC=0
      GO TO 8
 4    IF (NBL.GE.0) GO TO 7
      DO 5 J=1,7
      NBR=J
      IF (KXK.EQ.IBRA(J)) GO TO 6
 5    CONTINUE
      NBR=8
 6    NBL=0
      IF(KXK.EQ.'P')IBRAVL=1
      IF(KXK.EQ.'I')IBRAVL=2
      IF(KXK.EQ.'F')IBRAVL=3
      IF(KXK.EQ.'R')IBRAVL=4
      IF(KXK.EQ.'A')IBRAVL=5
      IF(KXK.EQ.'B')IBRAVL=6
      IF(KXK.EQ.'C')IBRAVL=7
      GO TO 8
 7    IF (NLQ.EQ.0) NBL=NBL+1
      IC=IC+1
      ZEI(NBL,IC)=KXK
      NLQ=1
      IF (KXK.EQ.N3(15)) NS=0
 8    CONTINUE
      DO 9 I=1,4
      IF (ZEI(2,I).NE.N3(3)) GO TO 9
      SYS=6
      GO TO 15
 9    CONTINUE
      DO 11 I=1,4
      IF (ZEI(1,I).NE.N3(3).AND.ZEI(1,I).NE.N3(6)) GO TO 10
      SYS=5
      GO TO 15
 10   IF (ZEI(1,I).NE.N3(4)) GO TO 11
      SYS=4
      GO TO 15
 11   CONTINUE
      IF (NBL.GT.1) GO TO 14
      IF (ZEI(1,1).NE.N3(1).AND.ZEI(1,1).NE.N3(16)) GO TO 12
      SYS=1
      GO TO 15
 12   SYS=2
      DO 13 I=1,4
 13   ZEI(2,I)=ZEI(1,I)
      ZEI(1,1)=N3(1)
      ZEI(3,1)=N3(1)
 14   SYS=3
      IF (ZEI(1,1).EQ.N3(1).OR.ZEI(2,1).EQ.N3(1)) SYS=2
 15   GO TO (16,17,22,46,58,68), SYS
C-----TRICLINIC
 16   IF (ZEI(1,1).EQ.N3(16)) NS=0
      GO TO 76
C-----MONOCLINIC
 17   NG=2
      DO 18 I=1,3
 18   IF (ZEI(I,1).NE.N3(1)) IND=I
      ID=1
      IF (ZEI(IND,1).EQ.N3(2)) ID=-1
      DO 19 I=1,3
 19   SS(2,I,I)=SS(1,I,I)*ID
      SS(2,IND,IND)=-SS(2,IND,IND)
      DO 21 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(2,I)=0.5
      DO 21 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(2,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(2,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(2,3)=0.5
      IF (ZEI(I,J).EQ.N3(12)) GO TO 20
      GO TO 21
 20   K=I+1
      IF (K.GT.3) K=K-3
      TS(2,K)=0.5
      TS(2,6-K-I)=0.5
 21   CONTINUE
      GO TO 76
C-----ORTHORHOMBIC
 22   NG=4
      IC=0
      IND=1
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(2,1).NE.N3(2).AND.ZEI(3,1).NE.N3(2))
     1IND=-1
      IF (IND.EQ.-1) NS=0
      DO 24 I=1,3
      ID=1
      IF (ZEI(I,1).EQ.N3(2)) ID=-1
      DO 23 J=1,3
 23   SS(1+I,J,J)=SS(1,J,J)*ID*IND
 24   SS(1+I,I,I)=-SS(1+I,I,I)
      DO 28 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(1+I,I)=0.5
      DO 28 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(1+I,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(1+I,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(1+I,3)=0.5
      IF (ZEI(I,J).EQ.N3(12).OR.ZEI(I,J).EQ.N3(10)) GO TO 25
      GO TO 28
 25   K=I+1
      IF (K.GT.3) K=K-3
      IF (ZEI(I,J).EQ.N3(10)) GO TO 26
      TS(1+I,K)=0.5
      TS(1+I,6-K-I)=0.5
      GO TO 28
 26   IC=1
      IF (NS.EQ.1) GO TO 27
      TS(1+I,K)=0.25
      TS(1+I,6-K-I)=0.25
      GO TO 28
 27   TS(1+I,1)=0.25
      TS(1+I,2)=0.25
      TS(1+I,3)=0.25
 28   CONTINUE
      IF (IC.EQ.1) GO TO 76
      IF (NS.EQ.1) GO TO 36
      DO 29 I=1,3
      K=1+I
      IF (K.GT.3) K=K-3
      TC=TS(1+K,I)+TS(1+6-I-K,I)
      IF (TC.EQ.1.0) TC=0.0
 29   TS(1+I,I)=TC
C-----SPECIAL TREATMENT OF C M M A, C M C A, I M M A
      IF (NBR.EQ.1.OR.NBR.EQ.5) GO TO 76
      MA=0
      DO 31 I=1,3
      DO 30 J=1,4
 30   IF (ZEI(I,J).EQ.N3(11)) NMA(I)=1
 31   MA=MA+NMA(I)
      IF (NBR.EQ.6.AND.MA.EQ.2) GO TO 33
      IF (MA.EQ.0.OR.MA.EQ.3.OR.NBR.EQ.6) GO TO 76
      DO 32 I=1,3
      IF (NMA(NBR-1).EQ.1) GO TO 76
 32   SH(NBR-1)=0.
C-----ORIGIN SHIFT
 33   DO 35 I=1,NG
      DO 35 J=1,3
      DO 34 K=1,3
      ID=1
      IF (J.NE.K) ID=0
 34   TS(I,J)=TS(I,J)+(ID-SS(I,J,K))*SH(K)
      IF (TS(I,J).GT.1.) TS(I,J)=TS(I,J)-1.
 35   IF (TS(I,J).LT.1.0) TS(I,J)=TS(I,J)+1.
      GO TO 76
 36   IC=0
      DO 37 I=1,3
 37   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.-1) IC=1
      IF (IC.EQ.1) GO TO 41
      TC=TS(2,1)+TS(3,2)+TS(4,3)
      IF (TC.EQ.0.0) GO TO 76
      DO 40 I=1,3
      K=I+1
      IF (K.GT.3) K=K-3
      IF (TC.GT.0.5) GO TO 38
      IF (TS(1+I,I).EQ.0.0) GO TO 40
      M=I-1
      IF (M.EQ.0) M=M+3
      TS(1+M,I)=0.5
      GO TO 40
 38   IF (TC.GT.1.0) GO TO 39
      IF (TS(1+I,I).NE.0.0) GO TO 40
      L=K+1
      IF (L.GT.3) L=L-3
      TS(1+K,L)=0.5
      TS(1+L,K)=0.5
      GO TO 40
 39   TS(1+I,K)=0.5
 40   CONTINUE
      GO TO 76
 41   DO 42 I=1,3
 42   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.1) ID=I
      DO 45 I=1,3
      TC=TS(2,I)+TS(3,I)+TS(4,I)
      IF (TC.EQ.0.0.OR.TC.EQ.1.0) GO TO 45
      IF (ZEI(1,1).EQ.N3(11).AND.ZEI(2,1).EQ.N3(12).OR.ZEI(2,1).EQ.
     1N3(11).AND.ZEI(3,1).EQ.N3(12).OR.ZEI(3,1).EQ.N3(11).AND.ZEI(1,1)
     2.EQ.N3(12)) GO TO 44
      DO 43 J=1,3
      IF (ID.EQ.J) GO TO 43
      IF (TS(1+J,I).EQ.0.5) GO TO 43
      TS(1+J,I)=0.5
 43   CONTINUE
      GO TO 45
 44   K=I-1
      IF (K.EQ.0) K=K+3
      TS(1+K,I)=0.5
 45   CONTINUE
      GO TO 76
C-----TETRAGONAL
 46   NG=4
      IF (NBL.EQ.3) NG=8
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      M=ZEI(1,1)
      N=ZEI(1,2)
      DO 47 I=1,3
      DO 47 J=1,3
 47   IF (M.EQ.N3(16)) SS(2,I,J)=-SS(2,I,J)
      IF (M.EQ.N3(16)) GO TO 50
      IF (N.EQ.N3(1)) TS(2,3)=0.25
      IF (N.EQ.N3(2)) TS(2,3)=0.5
      IF (N.EQ.N3(3)) TS(2,3)=0.75
      IF (ZEI(1,3).EQ.N3(12).OR.(ZEI(1,4).EQ.N3(12).AND.NBL.EQ.3))
     1TS(2,1)=0.5
      IF ((ZEI(1,4).EQ.N3(12).AND.NBL.EQ.1).OR.(N.EQ.N3(1).AND.NS.EQ.1.
     1AND.NBR.EQ.6)) TS(2,2)=0.5
      IF (N.EQ.N3(1).AND.NS.EQ.0.AND.NBR.EQ.6) GO TO 48
      IF (ZEI(2,2).EQ.N3(1).OR.(ZEI(1,4).NE.N3(12).AND.ZEI(2,1).EQ.
     1N3(12).AND.ZEI(3,1).EQ.N3(11))) GO TO 49
      GO TO 50
 48   TS(2,1)=0.25
      TS(2,2)=0.75
      IF (NBL.EQ.1) TS(2,1)=0.75
      IF (NBL.EQ.1) TS(2,2)=0.25
      GO TO 50
 49   TS(2,1)=0.5
      TS(2,2)=0.5
 50   SS(3,1,1)=-1
      SS(3,2,2)=-1
      SS(3,3,3)=1
      TS(3,1)=SS(2,1,2)*TS(2,2)+TS(2,1)
      TS(3,2)=SS(2,2,1)*TS(2,1)+TS(2,2)
      TS(3,3)=SS(2,3,3)*TS(2,3)+TS(2,3)
      DO 51 I=1,3
 51   IF (NBR.EQ.6.AND.TS(3,1).EQ.0.5.AND.TS(3,2).EQ.0.5.AND.TS(3,3).EQ.
     10.5) TS(3,I)=0.0
      DO 52 I=1,3
      TS(4,I)=TS(2,I)
      DO 52 J=1,3
      TS(4,I)=TS(4,I)+SS(2,I,J)*TS(3,J)
      DO 52 K=1,3
 52   SS(4,I,J)=SS(4,I,J)+SS(2,I,K)*SS(3,K,J)
      IF (NBL.EQ.1) GO TO 76
      IF (NS.EQ.0) GO TO 56
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.NE.N3(2).AND.N.NE.N3(2)) GO TO 55
      IF (M.EQ.N3(2).AND.N.EQ.N3(2)) GO TO 54
      IF (M.EQ.N3(2)) GO TO 53
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.NE.N3(12).AND.M.NE.N3(8)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 53   E(1,1)=1
      E(2,2)=-1
      E(3,3)=-1
      IF (N.EQ.N3(9)) TE(3)=0.5
      IF (N.EQ.N3(10)) TE(3)=0.25
      IF (N.EQ.N3(10)) TE(2)=0.5
      IF (ZEI(2,2).NE.N3(1)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 54   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      IF (ZEI(2,2).NE.0.OR.NBR.EQ.6.OR.ZEI(1,2).EQ.0) GO TO 57
      IF (ZEI(1,2).EQ.N3(1)) TE(3)=0.75
      IF (ZEI(1,2).EQ.N3(2)) TE(3)=0.5
      IF (ZEI(1,2).EQ.N3(3)) TE(3)=0.25
      GO TO 57
 55   M=ZEI(2,1)
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(1)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(2)=0.5
      GO TO 57
 56   E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (ZEI(2,1).EQ.N3(9).OR.ZEI(2,1).EQ.N3(12)) TE(3)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(2)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(1)=0.5
      IF (ZEI(1,3).EQ.N3(12).OR.ZEI(1,4).EQ.N3(12)) TE(1)=TE(1)+0.5
 57   NE=4
      GO TO 74
C-----HEXAGONAL
 58   NG=3
      M=ZEI(1,1)
      N=ZEI(1,2)
      IF (M.EQ.N3(16).AND.N.EQ.N3(3)) NS=0
      IF (M.EQ.N3(6)) GO TO 61
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,2,2)=-1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/3.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/3.0
      SS(3,1,1)=-1
      SS(3,2,1)=-1
      SS(3,1,2)=1
      SS(3,3,3)=1
      TS(3,3)=2.0*TS(2,3)
      IF (TS(3,3).GE.1.0) TS(3,3)=TS(3,3)-1.0
      IF (NBL.EQ.1.AND.N.NE.N3(6)) GO TO 76
      IF (N.NE.N3(6)) GO TO 60
      NG=NG+NG
      DO 59 I=1,3
      DO 59 J=1,3
      DO 59 K=1,3
      SS(3+I,J,K)=SS(I,J,K)
 59   SS(3+I,3,3)=-1
 60   IF (NBL.EQ.1) GO TO 76
      IF (ZEI(2,1).NE.N3(9).AND.ZEI(3,1).NE.N3(9)) GO TO 63
      TS(4,3)=0.5
      TS(5,3)=0.5
      TS(6,3)=0.5
      GO TO 63
 61   NG=NG+NG
      SS(2,1,1)=1
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/6.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/6.0
      IF (N.EQ.N3(3)) TS(2,3)=3.0/6.0
      IF (N.EQ.N3(4)) TS(2,3)=4.0/6.0
      IF (N.EQ.N3(5)) TS(2,3)=5.0/6.0
      DO 62 I=1,4
      DO 62 J=1,3
      TS(2+I,J)=TS(2,J)
      DO 62 K=1,3
      TS(2+I,J)=TS(2+I,J)+SS(2,J,K)*TS(1+I,K)
      IF (TS(2+I,J).GT.1.0) TS(2+I,J)=TS(2+I,J)-1.0
      DO 62 L=1,3
 62   SS(2+I,J,K)=SS(2+I,J,K)+SS(2,J,L)*SS(1+I,L,K)
      IF (NBL.EQ.1) GO TO 76
 63   NG=NG+NG
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.EQ.N3(1)) GO TO 65
      IF (M.EQ.N3(2)) GO TO 64
      E(1,2)=-1
      E(2,1)=-1
      E(3,3)=1
      IF (M.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 64   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
C-----GROUP P 31 I 2 AND P 32 I 2
      IF (ZEI(1,1).EQ.N3(3).AND.(ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.
     1N3(2))) TE(3)=0.
      GO TO 67
 65   IF (N.EQ.N3(2)) GO TO 66
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (N.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 66   E(1,2)=-1
      E(2,1)=-1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
      IF (TE(3).GT.1.0) TE(3)=TE(3)-1.0
 67   NE=6
      IF (ZEI(1,1).EQ.N3(3).OR.(ZEI(1,2).EQ.N3(3).AND.ZEI(1,1).EQ.
     1N3(16))) NE=3
      GO TO 74
C-----CUBIC
 68   NG=12
      IF (NBL.EQ.3) NG=24
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(1,1).NE.N3(4).AND.ZEI(1,1).NE.
     1N3(16)) NS=0
      DO 69 I=1,3
      DO 69 J=1,3
      SS(1+I,J,J)=1
      IF (I.EQ.J) GO TO 69
      SS(1+I,J,J)=-1
      IF (ZEI(1,1).EQ.N3(12)) TS(1+I,J)=0.5
      IF (ZEI(1,1).EQ.N3(10)) TS(1+I,J)=0.25
 69   CONTINUE
      IF (ZEI(1,1).NE.N3(7).AND.ZEI(3,1).NE.N3(10).AND.ZEI(1,2).NE.N3(3)
     1.AND.ZEI(1,2).NE.N3(1).OR.NBR.EQ.5) GO TO 71
      DO 70 I=1,3
      TS(1+I,I)=0.5
      K=I+1
      IF (K.EQ.4) K=1
 70   TS(1+I,K)=0.5
 71   DO 72 I=1,4
      DO 72 J=1,3
      DO 72 K=1,3
      L=J+1
      IF (L.EQ.4) L=1
      M=J-1
      IF (M.EQ.0) M=3
      SS(4+I,J,K)=SS(I,L,K)
      SS(8+I,J,K)=SS(I,M,K)
      TS(4+I,J)=TS(I,L)
 72   TS(8+I,J)=TS(I,M)
      IF (NG.EQ.12) GO TO 76
      NE=12
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (ZEI(3,1).EQ.N3(2)) E(3,3)=-1
      IF (ZEI(3,1).EQ.N3(9)) TE(3)=0.5
      DO 73 I=1,3
      IF (ZEI(3,1).EQ.N3(12).OR.ZEI(1,2).EQ.N3(2)) TE(I)=0.5
 73   IF (ZEI(3,1).EQ.N3(10).OR.ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.N3(3))
     1TE(I)=0.25
      IF (ZEI(1,2).EQ.N3(1).AND.NBR.EQ.1) TE(1)=0.75
      IF ((ZEI(1,2).NE.N3(1).OR.NBR.NE.6).AND.(ZEI(1,2).NE.N3(3).OR.NBR
     1.NE.1)) GO TO 74
      TE(2)=0.75
      TE(3)=0.75
 74   DO 75 I=1,NE
      DO 75 J=1,3
      TS(NE+I,J)=TE(J)
      DO 75 K=1,3
      TS(NE+I,J)=TS(NE+I,J)+E(J,K)*TS(I,K)
      DO 75 L=1,3
 75   SS(NE+I,J,K)=SS(NE+I,J,K)+E(J,L)*SS(I,L,K)
 76   DO 81 I=1,NG
      DO 81 J=1,3
 77   IF (TS(I,J).GE.1.0) GO TO 78
      GO TO 79
 78   TS(I,J)=TS(I,J)-1.0
      GO TO 77
 79   IF (TS(I,J).LT.0.0) GO TO 80
      GO TO 81
 80   TS(I,J)=TS(I,J)+1.0
      GO TO 79
 81   CONTINUE
      ISYSTM=ISYS(SYS)
      ISYMCE=1-NS
      RETURN
      END
C*****************************************************************
      Subroutine StringSym(IM,TS,Strsym)
      Character Strsym*50,sigx(3)*1,xlab(3)*1,xyzt(3)*15,auxc*15
      dimension IM(3,3),TS(3),ino(3),lni(3)
      data xlab/'X','Y','Z'/
      do i=1,3
       auxc=' '
       lenx=1

       do j=1,3
        ino(j)=0
        IF(IM(i,j).EQ.1) sigx(j)='+'
        IF(IM(i,j).EQ.-1) sigx(j)='-'
        IF(IM(i,j).EQ.0) ino(j)=1
       end do

       do j=1,3
        if(lenx.lt.1) lenx=1
        if(ino(j).eq.0) then
         if(j.eq.1.and.sigx(j).eq.'+') then
           auxc=trim(auxc(1:lenx)//xlab(j))
          else
           auxc=trim(auxc(1:lenx)//sigx(j)//xlab(j))
         endif
        endif
        lenx=Len_trim(auxc)
       end do

       if(abs(TS(i)).gt.0.0001) then
       write(xyzt(i),'(a,a,f6.4,a)') auxc(1:lenx),'+',TS(i),','
       else
       write(xyzt(i),'(a,a)') auxc(1:lenx),','
       endif

        lni(i)=Len_trim(xyzt(i))

      end do

      Strsym=xyzt(1)(1:lni(1))//xyzt(2)(1:lni(2))//xyzt(3)(1:lni(3)-1)

      return
      end
*
*************************************************************
*
      BLOCK DATA                                                       
      CHARACTER*4 TABNC(128),TBXC(256)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128)
C  Scattering factor tables
C     V. F. Sears, Neutron News 3, 26 (1992)
      DATA TABNC(1),TABN(1)/'h   ',-0.3739/
      DATA TABNC(2),TABN(2)/'he  ',0.326/
      DATA TABNC(3),TABN(3)/'li  ',-0.190/
      DATA TABNC(4),TABN(4)/'be  ',0.779/
      DATA TABNC(5),TABN(5)/'b   ',0.665/
      DATA TABNC(6),TABN(6)/'c   ',0.6646/
      DATA TABNC(7),TABN(7)/'n   ',0.936/
      DATA TABNC(8),TABN(8)/'o   ',0.5803/
      DATA TABNC(9),TABN(9)/'f   ',0.565/
      DATA TABNC(10),TABN(10)/'ne  ',0.4566/
      DATA TABNC(11),TABN(11)/'na  ',0.363/
      DATA TABNC(12),TABN(12)/'mg  ',0.5375/
      DATA TABNC(13),TABN(13)/'al  ',0.3449/
      DATA TABNC(14),TABN(14)/'si  ',0.4149/
      DATA TABNC(15),TABN(15)/'p   ',0.513/
      DATA TABNC(16),TABN(16)/'s   ',0.2847/
      DATA TABNC(17),TABN(17)/'cl  ',0.95770/
      DATA TABNC(18),TABN(18)/'ar  ',0.1909/
      DATA TABNC(19),TABN(19)/'k   ',0.367/
      DATA TABNC(20),TABN(20)/'ca  ',0.470/
      DATA TABNC(21),TABN(21)/'sc  ',1.23/
      DATA TABNC(22),TABN(22)/'ti  ',-0.3438/
      DATA TABNC(23),TABN(23)/'v   ',-0.0382/
      DATA TABNC(24),TABN(24)/'cr  ',0.3635/
      DATA TABNC(25),TABN(25)/'mn  ',-0.373/
      DATA TABNC(26),TABN(26)/'fe  ',0.945/
      DATA TABNC(27),TABN(27)/'co  ',0.249/
      DATA TABNC(28),TABN(28)/'ni  ',1.03/
      DATA TABNC(29),TABN(29)/'cu  ',0.7718/
      DATA TABNC(30),TABN(30)/'zn  ',0.5680/
      DATA TABNC(31),TABN(31)/'ga  ',0.7288/
      DATA TABNC(32),TABN(32)/'ge  ',0.819/
      DATA TABNC(33),TABN(33)/'as  ',0.658/
      DATA TABNC(34),TABN(34)/'se  ',0.7970/
      DATA TABNC(35),TABN(35)/'br  ',0.680/
      DATA TABNC(36),TABN(36)/'kr  ',0.781/
      DATA TABNC(37),TABN(37)/'rb  ',0.709/
      DATA TABNC(38),TABN(38)/'sr  ',0.702/
      DATA TABNC(39),TABN(39)/'y   ',0.775/
      DATA TABNC(40),TABN(40)/'zr  ',0.716/
      DATA TABNC(41),TABN(41)/'nb  ',0.7054/
      DATA TABNC(42),TABN(42)/'mo  ',0.672/
      DATA TABNC(43),TABN(43)/'tc  ',0.68/
      DATA TABNC(44),TABN(44)/'ru  ',0.703/
      DATA TABNC(45),TABN(45)/'rh  ',0.588/
      DATA TABNC(46),TABN(46)/'pd  ',0.591/
      DATA TABNC(47),TABN(47)/'ag  ',0.5922/
      DATA TABNC(48),TABN(48)/'cd  ',0.487/
      DATA TABNC(49),TABN(49)/'in  ',0.407/
      DATA TABNC(50),TABN(50)/'sn  ',0.6225/
      DATA TABNC(51),TABN(51)/'sb  ',0.557/
      DATA TABNC(52),TABN(52)/'te  ',0.580/
      DATA TABNC(53),TABN(53)/'i   ',0.528/
      DATA TABNC(54),TABN(54)/'xe  ',0.492/
      DATA TABNC(55),TABN(55)/'cs  ',0.542/
      DATA TABNC(56),TABN(56)/'ba  ',0.507/
      DATA TABNC(57),TABN(57)/'la  ',0.824/
      DATA TABNC(58),TABN(58)/'ce  ',0.484/
      DATA TABNC(59),TABN(59)/'pr  ',0.458/
      DATA TABNC(60),TABN(60)/'nd  ',0.769/
      DATA TABNC(61),TABN(61)/'eu  ',0.722/
      DATA TABNC(62),TABN(62)/'gd  ',0.65/
      DATA TABNC(63),TABN(63)/'tb  ',0.738/
      DATA TABNC(64),TABN(64)/'dy  ',1.69/
      DATA TABNC(65),TABN(65)/'ho  ',0.801/
      DATA TABNC(66),TABN(66)/'er  ',0.779/
      DATA TABNC(67),TABN(67)/'tm  ',0.707/
      DATA TABNC(68),TABN(68)/'yb  ',1.243/
      DATA TABNC(69),TABN(69)/'lu  ',0.721/
      DATA TABNC(70),TABN(70)/'hf  ',0.78/
      DATA TABNC(71),TABN(71)/'ta  ',0.691/
      DATA TABNC(72),TABN(72)/'w   ',0.486/
      DATA TABNC(73),TABN(73)/'re  ',0.92/
      DATA TABNC(74),TABN(74)/'os  ',1.07/
      DATA TABNC(75),TABN(75)/'ir  ',1.06/
      DATA TABNC(76),TABN(76)/'pt  ',0.960/
      DATA TABNC(77),TABN(77)/'au  ',0.763/
      DATA TABNC(78),TABN(78)/'hg  ',1.269/
      DATA TABNC(79),TABN(79)/'tl  ',0.8776/
      DATA TABNC(80),TABN(80)/'pb  ',0.9405/
      DATA TABNC(81),TABN(81)/'bi  ',0.8532/
      DATA TABNC(82),TABN(82)/'th  ',1.031/
      DATA TABNC(83),TABN(83)/'u   ',0.8417/
      DATA TABNC(84),TABN(84)/'np  ',1.06/
      DATA TABNC(85),TABN(85)/'pu  ',0.77/
      DATA TABNC(86),TABN(86)/'d   ',0.6671/
      DATA TABNC(87),TABN(87)/'pm  ',1.26/
      DATA TABNC(88),TABN(88)/'sm  ',0.80/
      DATA TABNC(89),TABN(89)/'ra  ',1.0/
      DATA TABNC(90),TABN(90)/'pa  ',0.91/
      DATA TABNC(91),TABN(91)/'am  ',0.83/
      DATA TABNC(92),TABN(92)/'cm  ',0.95/
      DATA TBD(  2, 1),TBD(  2, 2),TBD(  2, 3),TBD(  2, 4),TBD(  2, 5)
     *    /   .002    ,   .002    ,   .001    ,  -.000    ,  -.000    /
      DATA TBD(  2, 6),TBD(  2, 7),TBD(  2, 8),TBD(  2, 9),TBD(  2,10)
     *    /   .001    ,   .001    ,   .000    ,   .000    ,   .000    /
      DATA TBD(  3, 1),TBD(  3, 2),TBD(  3, 3),TBD(  3, 4),TBD(  3, 5)
     *    /   .008    ,   .005    ,   .003    ,  -.000    ,  -.001    /
      DATA TBD(  3, 6),TBD(  3, 7),TBD(  3, 8),TBD(  3, 9),TBD(  3,10)
     *    /   .003    ,   .002    ,   .001    ,   .000    ,   .000    /
      DATA TBD(  4, 1),TBD(  4, 2),TBD(  4, 3),TBD(  4, 4),TBD(  4, 5)
     *    /   .018    ,   .013    ,   .008    ,   .000    ,  -.000    /
      DATA TBD(  4, 6),TBD(  4, 7),TBD(  4, 8),TBD(  4, 9),TBD(  4,10)
     *    /   .009    ,   .007    ,   .004    ,   .001    ,   .000    /
      DATA TBD(  5, 1),TBD(  5, 2),TBD(  5, 3),TBD(  5, 4),TBD(  5, 5)
     *    /   .035    ,   .026    ,   .017    ,   .002    ,   .000    /
      DATA TBD(  5, 6),TBD(  5, 7),TBD(  5, 8),TBD(  5, 9),TBD(  5,10)
     *    /   .021    ,   .015    ,   .009    ,   .002    ,   .001    /
      DATA TBD(  6, 1),TBD(  6, 2),TBD(  6, 3),TBD(  6, 4),TBD(  6, 5)
     *    /   .059    ,   .044    ,   .029    ,   .004    ,   .001    /
      DATA TBD(  6, 6),TBD(  6, 7),TBD(  6, 8),TBD(  6, 9),TBD(  6,10)
     *    /   .042    ,   .029    ,   .018    ,   .003    ,   .002    /
      DATA TBD(  7, 1),TBD(  7, 2),TBD(  7, 3),TBD(  7, 4),TBD(  7, 5)
     *    /   .090    ,   .069    ,   .047    ,   .008    ,   .003    /
      DATA TBD(  7, 6),TBD(  7, 7),TBD(  7, 8),TBD(  7, 9),TBD(  7,10)
     *    /   .073    ,   .052    ,   .032    ,   .006    ,   .004    /
      DATA TBD(  8, 1),TBD(  8, 2),TBD(  8, 3),TBD(  8, 4),TBD(  8, 5)
     *    /   .129    ,   .100    ,   .069    ,   .014    ,   .006    /
      DATA TBD(  8, 6),TBD(  8, 7),TBD(  8, 8),TBD(  8, 9),TBD(  8,10)
     *    /   .119    ,   .085    ,   .053    ,   .010    ,   .006    /
      DATA TBD(  9, 1),TBD(  9, 2),TBD(  9, 3),TBD(  9, 4),TBD(  9, 5)
     *    /   .174    ,   .138    ,   .097    ,   .021    ,   .011    /
      DATA TBD(  9, 6),TBD(  9, 7),TBD(  9, 8),TBD(  9, 9),TBD(  9,10)
     *    /   .184    ,   .132    ,   .083    ,   .016    ,   .010    /
      DATA TBD( 10, 1),TBD( 10, 2),TBD( 10, 3),TBD( 10, 4),TBD( 10, 5)
     *    /   .223    ,   .180    ,   .129    ,   .030    ,   .016    /
      DATA TBD( 10, 6),TBD( 10, 7),TBD( 10, 8),TBD( 10, 9),TBD( 10,10)
     *    /   .270    ,   .195    ,   .124    ,   .025    ,   .015    /
      DATA TBD( 11, 1),TBD( 11, 2),TBD( 11, 3),TBD( 11, 4),TBD( 11, 5)
     *    /   .272    ,   .224    ,   .165    ,   .042    ,   .023    /
      DATA TBD( 11, 6),TBD( 11, 7),TBD( 11, 8),TBD( 11, 9),TBD( 11,10)
     *    /   .381    ,   .277    ,   .177    ,   .036    ,   .022    /
      DATA TBD( 12, 1),TBD( 12, 2),TBD( 12, 3),TBD( 12, 4),TBD( 12, 5)
     *    /   .318    ,   .269    ,   .204    ,   .056    ,   .032    /
      DATA TBD( 12, 6),TBD( 12, 7),TBD( 12, 8),TBD( 12, 9),TBD( 12,10)
     *    /   .522    ,   .381    ,   .246    ,   .052    ,   .031    /
      DATA TBD( 13, 1),TBD( 13, 2),TBD( 13, 3),TBD( 13, 4),TBD( 13, 5)
     *    /   .355    ,   .311    ,   .244    ,   .072    ,   .042    /
      DATA TBD( 13, 6),TBD( 13, 7),TBD( 13, 8),TBD( 13, 9),TBD( 13,10)
     *    /   .693    ,   .509    ,   .330    ,   .071    ,   .043    /
      DATA TBD( 14, 1),TBD( 14, 2),TBD( 14, 3),TBD( 14, 4),TBD( 14, 5)
     *    /   .377    ,   .347    ,   .283    ,   .090    ,   .055    /
      DATA TBD( 14, 6),TBD( 14, 7),TBD( 14, 8),TBD( 14, 9),TBD( 14,10)
     *    /   .900    ,   .664    ,   .434    ,   .095    ,   .058    /
      DATA TBD( 15, 1),TBD( 15, 2),TBD( 15, 3),TBD( 15, 4),TBD( 15, 5)
     *    /   .374    ,   .370    ,   .319    ,   .110    ,   .068    /
      DATA TBD( 15, 6),TBD( 15, 7),TBD( 15, 8),TBD( 15, 9),TBD( 15,10)
     *    /  1.142    ,   .847    ,   .557    ,   .124    ,   .076    /
      DATA TBD( 16, 1),TBD( 16, 2),TBD( 16, 3),TBD( 16, 4),TBD( 16, 5)
     *    /   .335    ,   .375    ,   .348    ,   .132    ,   .084    /
      DATA TBD( 16, 6),TBD( 16, 7),TBD( 16, 8),TBD( 16, 9),TBD( 16,10)
     *    /  1.423    ,  1.061    ,   .702    ,   .159    ,   .099    /
      DATA TBD( 17, 1),TBD( 17, 2),TBD( 17, 3),TBD( 17, 4),TBD( 17, 5)
     *    /   .243    ,   .352    ,   .366    ,   .155    ,   .101    /
      DATA TBD( 17, 6),TBD( 17, 7),TBD( 17, 8),TBD( 17, 9),TBD( 17,10)
     *    /  1.747    ,  1.309    ,   .872    ,   .201    ,   .125    /
      DATA TBD( 18, 1),TBD( 18, 2),TBD( 18, 3),TBD( 18, 4),TBD( 18, 5)
     *    /   .070    ,   .286    ,   .365    ,   .179    ,   .118    /
      DATA TBD( 18, 6),TBD( 18, 7),TBD( 18, 8),TBD( 18, 9),TBD( 18,10)
     *    /  2.110    ,  1.589    ,  1.066    ,   .250    ,   .156    /
      DATA TBD( 19, 1),TBD( 19, 2),TBD( 19, 3),TBD( 19, 4),TBD( 19, 5)
     *    /  -.221    ,   .163    ,   .341    ,   .203    ,   .137    /
      DATA TBD( 19, 6),TBD( 19, 7),TBD( 19, 8),TBD( 19, 9),TBD( 19,10)
     *    /  2.514    ,  1.904    ,  1.286    ,   .306    ,   .193    /
      DATA TBD( 20, 1),TBD( 20, 2),TBD( 20, 3),TBD( 20, 4),TBD( 20, 5)
     *    /  -.717    ,  -.038    ,   .285    ,   .226    ,   .156    /
      DATA TBD( 20, 6),TBD( 20, 7),TBD( 20, 8),TBD( 20, 9),TBD( 20,10)
     *    /  2.968    ,  2.256    ,  1.533    ,   .372    ,   .235    /
      DATA TBD( 21, 1),TBD( 21, 2),TBD( 21, 3),TBD( 21, 4),TBD( 21, 5)
     *    / -1.683    ,  -.357    ,   .189    ,   .248    ,   .175    /
      DATA TBD( 21, 6),TBD( 21, 7),TBD( 21, 8),TBD( 21, 9),TBD( 21,10)
     *    /  3.470    ,  2.643    ,  1.807    ,   .446    ,   .283    /
      DATA TBD( 22, 1),TBD( 22, 2),TBD( 22, 3),TBD( 22, 4),TBD( 22, 5)
     *    / -3.841    ,  -.896    ,   .035    ,   .267    ,   .194    /
      DATA TBD( 22, 6),TBD( 22, 7),TBD( 22, 8),TBD( 22, 9),TBD( 22,10)
     *    /   .459    ,  3.070    ,  2.110    ,   .530    ,   .338    /
      DATA TBD( 23, 1),TBD( 23, 2),TBD( 23, 3),TBD( 23, 4),TBD( 23, 5)
     *    / -2.161    , -1.973    ,  -.198    ,   .284    ,   .213    /
      DATA TBD( 23, 6),TBD( 23, 7),TBD( 23, 8),TBD( 23, 9),TBD( 23,10)
     *    /   .548    ,  3.533    ,  2.443    ,   .624    ,   .399    /
      DATA TBD( 24, 1),TBD( 24, 2),TBD( 24, 3),TBD( 24, 4),TBD( 24, 5)
     *    / -1.639    , -3.367    ,  -.568    ,   .295    ,   .229    /
      DATA TBD( 24, 6),TBD( 24, 7),TBD( 24, 8),TBD( 24, 9),TBD( 24,10)
     *    /   .650    ,   .481    ,  2.808    ,   .729    ,   .468    /
      DATA TBD( 25, 1),TBD( 25, 2),TBD( 25, 3),TBD( 25, 4),TBD( 25, 5)
     *    / -1.339    , -2.095    , -1.179    ,   .301    ,   .244    /
      DATA TBD( 25, 6),TBD( 25, 7),TBD( 25, 8),TBD( 25, 9),TBD( 25,10)
     *    /   .764    ,   .566    ,  3.204    ,   .845    ,   .545    /
      DATA TBD( 26, 1),TBD( 26, 2),TBD( 26, 3),TBD( 26, 4),TBD( 26, 5)
     *    / -1.124    , -1.623    , -2.464    ,   .299    ,   .256    /
      DATA TBD( 26, 6),TBD( 26, 7),TBD( 26, 8),TBD( 26, 9),TBD( 26,10)
     *    /   .893    ,   .662    ,  3.608    ,   .973    ,   .630    /
      DATA TBD( 27, 1),TBD( 27, 2),TBD( 27, 3),TBD( 27, 4),TBD( 27, 5)
     *    /  -.956    , -1.343    , -2.956    ,   .285    ,   .261    /
      DATA TBD( 27, 6),TBD( 27, 7),TBD( 27, 8),TBD( 27, 9),TBD( 27,10)
     *    /  1.036    ,   .769    ,   .509    ,  1.113    ,   .724    /
      DATA TBD( 28, 1),TBD( 28, 2),TBD( 28, 3),TBD( 28, 4),TBD( 28, 5)
     *    /  -.795    , -1.129    , -2.019    ,   .263    ,   .265    /
      DATA TBD( 28, 6),TBD( 28, 7),TBD( 28, 8),TBD( 28, 9),TBD( 28,10)
     *    /  1.196    ,   .888    ,   .589    ,  1.266    ,   .826    /
      DATA TBD( 29, 1),TBD( 29, 2),TBD( 29, 3),TBD( 29, 4),TBD( 29, 5)
     *    /  -.684    ,  -.978    , -1.612    ,   .222    ,   .260    /
      DATA TBD( 29, 6),TBD( 29, 7),TBD( 29, 8),TBD( 29, 9),TBD( 29,10)
     *    /  1.373    ,  1.021    ,   .678    ,  1.431    ,   .938    /
      DATA TBD( 30, 1),TBD( 30, 2),TBD( 30, 3),TBD( 30, 4),TBD( 30, 5)
     *    /  -.570    ,  -.841    , -1.354    ,   .163    ,   .249    /
      DATA TBD( 30, 6),TBD( 30, 7),TBD( 30, 8),TBD( 30, 9),TBD( 30,10)
     *    /  1.569    ,  1.168    ,   .777    ,  1.609    ,  1.059    /
      DATA TBD( 31, 1),TBD( 31, 2),TBD( 31, 3),TBD( 31, 4),TBD( 31, 5)
     *    /  -.462    ,  -.717    , -1.163    ,   .081    ,   .228    /
      DATA TBD( 31, 6),TBD( 31, 7),TBD( 31, 8),TBD( 31, 9),TBD( 31,10)
     *    /  1.786    ,  1.331    ,   .886    ,  1.801    ,  1.190    /
      DATA TBD( 32, 1),TBD( 32, 2),TBD( 32, 3),TBD( 32, 4),TBD( 32, 5)
     *    /  -.365    ,  -.607    , -1.011    ,  -.030    ,   .196    /
      DATA TBD( 32, 6),TBD( 32, 7),TBD( 32, 8),TBD( 32, 9),TBD( 32,10)
     *    /  2.022    ,  1.508    ,  1.006    ,  2.007    ,  1.332    /
      DATA TBD( 33, 1),TBD( 33, 2),TBD( 33, 3),TBD( 33, 4),TBD( 33, 5)
     *    /  -.273    ,  -.503    ,  -.879    ,  -.178    ,   .152    /
      DATA TBD( 33, 6),TBD( 33, 7),TBD( 33, 8),TBD( 33, 9),TBD( 33,10)
     *    /  2.283    ,  1.704    ,  1.139    ,  2.223    ,  1.481    /
      DATA TBD( 34, 1),TBD( 34, 2),TBD( 34, 3),TBD( 34, 4),TBD( 34, 5)
     *    /  -.198    ,  -.413    ,  -.767    ,  -.374    ,   .090    /
      DATA TBD( 34, 6),TBD( 34, 7),TBD( 34, 8),TBD( 34, 9),TBD( 34,10)
     *    /  2.563    ,  1.916    ,  1.283    ,  2.456    ,  1.643    /
      DATA TBD( 35, 1),TBD( 35, 2),TBD( 35, 3),TBD( 35, 4),TBD( 35, 5)
     *    /  -.130    ,  -.328    ,  -.665    ,  -.652    ,   .008    /
      DATA TBD( 35, 6),TBD( 35, 7),TBD( 35, 8),TBD( 35, 9),TBD( 35,10)
     *    /  2.872    ,  2.149    ,  1.439    ,  2.713    ,  1.820    /
      DATA TBD( 36, 1),TBD( 36, 2),TBD( 36, 3),TBD( 36, 4),TBD( 36, 5)
     *    /  -.082    ,  -.256    ,  -.574    , -1.044    ,  -.099    /
      DATA TBD( 36, 6),TBD( 36, 7),TBD( 36, 8),TBD( 36, 9),TBD( 36,10)
     *    /  3.201    ,  2.398    ,  1.608    ,  2.973    ,  2.003    /
      DATA TBD( 37, 1),TBD( 37, 2),TBD( 37, 3),TBD( 37, 4),TBD( 37, 5)
     *    /  -.012    ,  -.161    ,  -.465    , -1.657    ,  -.230    /
      DATA TBD( 37, 6),TBD( 37, 7),TBD( 37, 8),TBD( 37, 9),TBD( 37,10)
     *    /  3.608    ,  2.709    ,  1.820    ,  3.264    ,  2.203    /
      DATA TBD( 38, 1),TBD( 38, 2),TBD( 38, 3),TBD( 38, 4),TBD( 38, 5)
     *    /   .006    ,  -.106    ,  -.386    , -2.951    ,  -.406    /
      DATA TBD( 38, 6),TBD( 38, 7),TBD( 38, 8),TBD( 38, 9),TBD( 38,10)
     *    /  4.002    ,  3.009    ,  2.025    ,  3.542    ,  2.411    /
      DATA TBD( 39, 1),TBD( 39, 2),TBD( 39, 3),TBD( 39, 4),TBD( 39, 5)
     *    /   .007    ,  -.061    ,  -.314    , -2.965    ,  -.639    /
      DATA TBD( 39, 6),TBD( 39, 7),TBD( 39, 8),TBD( 39, 9),TBD( 39,10)
     *    /  4.422    ,  3.329    ,  2.245    ,   .560    ,  2.630    /
      DATA TBD( 40, 1),TBD( 40, 2),TBD( 40, 3),TBD( 40, 4),TBD( 40, 5)
     *    /  -.013    ,  -.028    ,  -.248    , -2.197    ,  -.957    /
      DATA TBD( 40, 6),TBD( 40, 7),TBD( 40, 8),TBD( 40, 9),TBD( 40,10)
     *    /  4.876    ,  3.676    ,  2.482    ,   .621    ,  2.860    /
      DATA TBD( 41, 1),TBD( 41, 2),TBD( 41, 3),TBD( 41, 4),TBD( 41, 5)
     *    /  -.063    ,  -.012    ,  -.191    , -1.825    , -1.416    /
      DATA TBD( 41, 6),TBD( 41, 7),TBD( 41, 8),TBD( 41, 9),TBD( 41,10)
     *    /  5.353    ,  4.043    ,  2.735    ,   .688    ,  3.103    /
      DATA TBD( 42, 1),TBD( 42, 2),TBD( 42, 3),TBD( 42, 4),TBD( 42, 5)
     *    /  -.153    ,  -.017    ,  -.145    , -1.590    , -2.205    /
      DATA TBD( 42, 6),TBD( 42, 7),TBD( 42, 8),TBD( 42, 9),TBD( 42,10)
     *    /  5.862    ,  4.434    ,  3.005    ,   .759    ,  3.353    /
      DATA TBD( 43, 1),TBD( 43, 2),TBD( 43, 3),TBD( 43, 4),TBD( 43, 5)
     *    /  -.270    ,  -.039    ,  -.105    , -1.420    , -5.524    /
      DATA TBD( 43, 6),TBD( 43, 7),TBD( 43, 8),TBD( 43, 9),TBD( 43,10)
     *    /  6.406    ,  4.854    ,  3.296    ,   .836    ,  3.651    /
      DATA TBD( 44, 1),TBD( 44, 2),TBD( 44, 3),TBD( 44, 4),TBD( 44, 5)
     *    /  -.424    ,  -.083    ,  -.077    , -1.287    , -2.649    /
      DATA TBD( 44, 6),TBD( 44, 7),TBD( 44, 8),TBD( 44, 9),TBD( 44,10)
     *    /  6.984    ,  5.300    ,  3.605    ,   .919    ,   .596    /
      DATA TBD( 45, 1),TBD( 45, 2),TBD( 45, 3),TBD( 45, 4),TBD( 45, 5)
     *    /  -.639    ,  -.157    ,  0.1215   , -1.177    , -2.128    /
      DATA TBD( 45, 6),TBD( 45, 7),TBD( 45, 8),TBD( 45, 9),TBD( 45,10)
     *    /  7.594    ,  5.773    ,  3.9337   ,  1.007    ,   .654    /
      DATA TBD( 46, 1),TBD( 46, 2),TBD( 46, 3),TBD( 46, 4),TBD( 46, 5)
     *    /  -.924    ,  -.259    ,  -.060    , -1.085    , -1.834    /
      DATA TBD( 46, 6),TBD( 46, 7),TBD( 46, 8),TBD( 46, 9),TBD( 46,10)
     *    /  8.235    ,  6.271    ,  4.282    ,  1.101    ,   .717    /
      DATA TBD( 47, 1),TBD( 47, 2),TBD( 47, 3),TBD( 47, 4),TBD( 47, 5)
     *    / -1.303    ,  -.416    ,  -.079    , -1.005    , -1.637    /
      DATA TBD( 47, 6),TBD( 47, 7),TBD( 47, 8),TBD( 47, 9),TBD( 47,10)
     *    /  8.912    ,  6.800    ,  4.653    ,  1.202    ,   .783    /
      DATA TBD( 48, 1),TBD( 48, 2),TBD( 48, 3),TBD( 48, 4),TBD( 48, 5)
     *    / -1.788    ,  -.626    ,  -.126    ,  -.936    , -1.493    /
      DATA TBD( 48, 6),TBD( 48, 7),TBD( 48, 8),TBD( 48, 9),TBD( 48,10)
     *    /  9.627    ,  7.356    ,  5.045    ,  1.310    ,   .854    /
      DATA TBD( 49, 1),TBD( 49, 2),TBD( 49, 3),TBD( 49, 4),TBD( 49, 5)
     *    / -2.401    ,  -.888    ,  -.194    ,  -.873    , -1.378    /
      DATA TBD( 49, 6),TBD( 49, 7),TBD( 49, 8),TBD( 49, 9),TBD( 49,10)
     *    / 10.380    ,  7.943    ,  5.459    ,  1.424    ,   .930    /
      DATA TBD( 50, 1),TBD( 50, 2),TBD( 50, 3),TBD( 50, 4),TBD( 50, 5)
     *    / -3.194    , -1.214    ,  -.287    ,  -.816    , -1.284    /
      DATA TBD( 50, 6),TBD( 50, 7),TBD( 50, 8),TBD( 50, 9),TBD( 50,10)
     *    / 11.166    ,  8.557    ,  5.894    ,  1.546    ,  1.010    /
      DATA TBD( 51, 1),TBD( 51, 2),TBD( 51, 3),TBD( 51, 4),TBD( 51, 5)
     *    / -4.267    , -1.630    ,  -.418    ,  -.772    , -1.212    /
      DATA TBD( 51, 6),TBD( 51, 7),TBD( 51, 8),TBD( 51, 9),TBD( 51,10)
     *    / 11.995    ,  9.203    ,  6.352    ,  1.675    ,  1.096    /
      DATA TBD( 52, 1),TBD( 52, 2),TBD( 52, 3),TBD( 52, 4),TBD( 52, 5)
     *    / -5.852    , -2.147    ,  -.579    ,  -.726    , -1.144    /
      DATA TBD( 52, 6),TBD( 52, 7),TBD( 52, 8),TBD( 52, 9),TBD( 52,10)
     *    / 12.850    ,  9.885    ,  6.835    ,  1.812    ,  1.187    /
      DATA TBD( 53, 1),TBD( 53, 2),TBD( 53, 3),TBD( 53, 4),TBD( 53, 5)
     *    / -8.133    , -2.812    ,  -.783    ,  -.684    , -1.084    /
      DATA TBD( 53, 6),TBD( 53, 7),TBD( 53, 8),TBD( 53, 9),TBD( 53,10)
     *    / 11.933    , 10.608    ,  7.348    ,  1.958    ,  1.284    /
      DATA TBD( 54, 1),TBD( 54, 2),TBD( 54, 3),TBD( 54, 4),TBD( 54, 5)
     *    /-10.742    , -3.652    , -1.022    ,  -.644    , -1.029    /
      DATA TBD( 54, 6),TBD( 54, 7),TBD( 54, 8),TBD( 54, 9),TBD( 54,10)
     *    / 12.919    , 11.382    ,  7.904    ,  2.119    ,  1.391    /
      DATA TBD( 55, 1),TBD( 55, 2),TBD( 55, 3),TBD( 55, 4),TBD( 55, 5)
     *    /-11.460    , -4.832    , -1.334    ,  -.613    ,  -.983    /
      DATA TBD( 55, 6),TBD( 55, 7),TBD( 55, 8),TBD( 55, 9),TBD( 55,10)
     *    /  9.981    , 12.164    ,  8.460    ,  2.282    ,  1.500    /
      DATA TBD( 56, 1),TBD( 56, 2),TBD( 56, 3),TBD( 56, 4),TBD( 56, 5)
     *    /-12.135    , -6.683    , -1.716    ,  -.588    ,  -.942    /
      DATA TBD( 56, 6),TBD( 56, 7),TBD( 56, 8),TBD( 56, 9),TBD( 56,10)
     *    /  3.565    , 12.937    ,  9.036    ,  2.452    ,  1.615    /
      DATA TBD( 57, 1),TBD( 57, 2),TBD( 57, 3),TBD( 57, 4),TBD( 57, 5)
     *    / -9.574    , -8.388    , -2.170    ,  -.564    ,  -.904    /
      DATA TBD( 57, 6),TBD( 57, 7),TBD( 57, 8),TBD( 57, 9),TBD( 57,10)
     *    /  3.843    , 11.953    ,  9.648    ,  2.632    ,  1.735    /
      DATA TBD( 58, 1),TBD( 58, 2),TBD( 58, 3),TBD( 58, 4),TBD( 58, 5)
     *    / -7.817    ,-12.457    , -2.939    ,  -.530    ,  -.859    /
      DATA TBD( 58, 6),TBD( 58, 7),TBD( 58, 8),TBD( 58, 9),TBD( 58,10)
     *    /  4.130    ,  6.285    , 10.535    ,  2.845    ,  1.873    /
      DATA TBD( 59, 1),TBD( 59, 2),TBD( 59, 3),TBD( 59, 4),TBD( 59, 5)
     *    / -7.486    ,-11.016    , -3.431    ,  -.535    ,  -.842    /
      DATA TBD( 59, 6),TBD( 59, 7),TBD( 59, 8),TBD( 59, 9),TBD( 59,10)
     *    /  4.427    ,  9.874    , 10.933    ,  3.018    ,  1.995    /
      DATA TBD( 60, 1),TBD( 60, 2),TBD( 60, 3),TBD( 60, 4),TBD( 60, 5)
     *    / -6.891    ,-12.122    , -4.357    ,  -.530    ,  -.818    /
      DATA TBD( 60, 6),TBD( 60, 7),TBD( 60, 8),TBD( 60, 9),TBD( 60,10)
     *    /  4.741    ,  3.627    , 11.614    ,  3.225    ,  2.135    /
      DATA TBD( 61, 1),TBD( 61, 2),TBD( 61, 3),TBD( 61, 4),TBD( 61, 5)
     *    / -6.429    , -9.616    , -5.696    ,  -.533    ,  -.798    /
      DATA TBD( 61, 6),TBD( 61, 7),TBD( 61, 8),TBD( 61, 9),TBD( 61,10)
     *    /  5.073    ,  3.883    , 12.320    ,  3.442    ,  2.281    /
      DATA TBD( 62, 1),TBD( 62, 2),TBD( 62, 3),TBD( 62, 4),TBD( 62, 5)
     *    / -6.050    , -8.352    , -7.718    ,  -.542    ,  -.782    /
      DATA TBD( 62, 6),TBD( 62, 7),TBD( 62, 8),TBD( 62, 9),TBD( 62,10)
     *    /  5.416    ,  4.149    , 11.276    ,  3.669    ,  2.435    /
      DATA TBD( 63, 1),TBD( 63, 2),TBD( 63, 3),TBD( 63, 4),TBD( 63, 5)
     *    / -5.779    , -7.565    , -9.242    ,  -.564    ,  -.774    /
      DATA TBD( 63, 6),TBD( 63, 7),TBD( 63, 8),TBD( 63, 9),TBD( 63,10)
     *    /  5.773    ,  4.427    , 11.946    ,  3.904    ,  2.595    /
      DATA TBD( 64, 1),TBD( 64, 2),TBD( 64, 3),TBD( 64, 4),TBD( 64, 5)
     *    / -5.525    , -6.980    , -9.498    ,  -.591    ,  -.767    /
      DATA TBD( 64, 6),TBD( 64, 7),TBD( 64, 8),TBD( 64, 9),TBD( 64,10)
     *    /  6.153    ,  4.721    ,  9.242    ,  4.151    ,  2.764    /
      DATA TBD( 65, 1),TBD( 65, 2),TBD( 65, 3),TBD( 65, 4),TBD( 65, 5)
     *    / -5.250    , -6.492    ,-10.423    ,  -.619    ,  -.761    /
      DATA TBD( 65, 6),TBD( 65, 7),TBD( 65, 8),TBD( 65, 9),TBD( 65,10)
     *    /  6.549    ,  5.026    ,  9.748    ,  4.410    ,  2.940    /
      DATA TBD( 66, 1),TBD( 66, 2),TBD( 66, 3),TBD( 66, 4),TBD( 66, 5)
     *    / -5.040    , -6.112    ,-12.255    ,  -.666    ,  -.765    /
      DATA TBD( 66, 6),TBD( 66, 7),TBD( 66, 8),TBD( 66, 9),TBD( 66,10)
     *    /  6.958    ,  5.343    ,  3.704    ,  4.678    ,  3.124    /
      DATA TBD( 67, 1),TBD( 67, 2),TBD( 67, 3),TBD( 67, 4),TBD( 67, 5)
     *    / -4.878    , -5.810    , -9.733    ,  -.723    ,  -.773    /
      DATA TBD( 67, 6),TBD( 67, 7),TBD( 67, 8),TBD( 67, 9),TBD( 67,10)
     *    /  7.387    ,  5.675    ,  3.937    ,  4.958    ,  3.316    /
      DATA TBD( 68, 1),TBD( 68, 2),TBD( 68, 3),TBD( 68, 4),TBD( 68, 5)
     *    / -4.753    , -5.565    , -8.488    ,  -.795    ,  -.790    /
      DATA TBD( 68, 6),TBD( 68, 7),TBD( 68, 8),TBD( 68, 9),TBD( 68,10)
     *    /  7.833    ,  6.022    ,  4.181    ,  5.248    ,  3.515    /
      DATA TBD( 69, 1),TBD( 69, 2),TBD( 69, 3),TBD( 69, 4),TBD( 69, 5)
     *    / -4.652    , -5.361    , -7.701    ,  -.884    ,  -.815    /
      DATA TBD( 69, 6),TBD( 69, 7),TBD( 69, 8),TBD( 69, 9),TBD( 69,10)
     *    /  8.291    ,  6.378    ,  4.432    ,  5.548    ,  3.723    /
      DATA TBD( 70, 1),TBD( 70, 2),TBD( 70, 3),TBD( 70, 4),TBD( 70, 5)
     *    / -4.580    , -5.190    , -7.133    ,  -.988    ,  -.847    /
      DATA TBD( 70, 6),TBD( 70, 7),TBD( 70, 8),TBD( 70, 9),TBD( 70,10)
     *    /  8.759    ,  6.745    ,  4.693    ,  5.858    ,  3.937    /
      DATA TBD( 71, 1),TBD( 71, 2),TBD( 71, 3),TBD( 71, 4),TBD( 71, 5)
     *    / -4.592    , -5.088    , -6.715    , -1.118    ,  -.890    /
      DATA TBD( 71, 6),TBD( 71, 7),TBD( 71, 8),TBD( 71, 9),TBD( 71,10)
     *    /  9.277    ,  7.148    ,  4.977    ,  6.185    ,  4.164    /
      DATA TBD( 72, 1),TBD( 72, 2),TBD( 72, 3),TBD( 72, 4),TBD( 72, 5)
     *    / -4.540    , -4.948    , -6.351    , -1.258    ,  -.937    /
      DATA TBD( 72, 6),TBD( 72, 7),TBD( 72, 8),TBD( 72, 9),TBD( 72,10)
     *    /  9.811    ,  7.565    ,  5.271    ,  6.523    ,  4.399    /
      DATA TBD( 73, 1),TBD( 73, 2),TBD( 73, 3),TBD( 73, 4),TBD( 73, 5)
     *    / -4.499    , -4.823    , -6.048    , -1.421    ,  -.993    /
      DATA TBD( 73, 6),TBD( 73, 7),TBD( 73, 8),TBD( 73, 9),TBD( 73,10)
     *    / 10.364    ,  7.996    ,  5.577    ,  6.872    ,  4.643    /
      DATA TBD( 74, 1),TBD( 74, 2),TBD( 74, 3),TBD( 74, 4),TBD( 74, 5)
     *    / -4.483    , -4.719    , -5.790    , -1.598    , -1.048    /
      DATA TBD( 74, 6),TBD( 74, 7),TBD( 74, 8),TBD( 74, 9),TBD( 74,10)
     *    / 10.929    ,  8.439    ,  5.891    ,  7.232    ,  4.894    /
      DATA TBD( 75, 1),TBD( 75, 2),TBD( 75, 3),TBD( 75, 4),TBD( 75, 5)
     *    / -4.503    , -4.647    , -5.581    , -1.816    , -1.127    /
      DATA TBD( 75, 6),TBD( 75, 7),TBD( 75, 8),TBD( 75, 9),TBD( 75,10)
     *    / 11.520    ,  8.903    ,  6.221    ,  7.605    ,  5.156    /
      DATA TBD( 76, 1),TBD( 76, 2),TBD( 76, 3),TBD( 76, 4),TBD( 76, 5)
     *    / -4.527    , -4.578    , -5.391    , -2.066    , -1.216    /
      DATA TBD( 76, 6),TBD( 76, 7),TBD( 76, 8),TBD( 76, 9),TBD( 76,10)
     *    / 12.140    ,  9.389    ,  6.566    ,  7.990    ,  5.427    /
      DATA TBD( 77, 1),TBD( 77, 2),TBD( 77, 3),TBD( 77, 4),TBD( 77, 5)
     *    / -4.584    , -4.535    , -5.233    , -2.352    , -1.319    /
      DATA TBD( 77, 6),TBD( 77, 7),TBD( 77, 8),TBD( 77, 9),TBD( 77,10)
     *    / 12.787    ,  9.895    ,  6.925    ,  8.388    ,  5.708    /
      DATA TBD( 78, 1),TBD( 78, 2),TBD( 78, 3),TBD( 78, 4),TBD( 78, 5)
     *    / -4.668    , -4.510    , -5.096    , -2.688    , -1.438    /
      DATA TBD( 78, 6),TBD( 78, 7),TBD( 78, 8),TBD( 78, 9),TBD( 78,10)
     *    / 13.451    , 10.418    ,  7.297    ,  8.798    ,  5.998    /
      DATA TBD( 79, 1),TBD( 79, 2),TBD( 79, 3),TBD( 79, 4),TBD( 79, 5)
     *    / -4.803    , -4.523    , -4.990    , -3.084    , -1.576    /
      DATA TBD( 79, 6),TBD( 79, 7),TBD( 79, 8),TBD( 79, 9),TBD( 79,10)
     *    / 14.143    , 10.963    ,  7.686    ,  9.223    ,  6.299    /
      DATA TBD( 80, 1),TBD( 80, 2),TBD( 80, 3),TBD( 80, 4),TBD( 80, 5)
     *    / -4.945    , -4.532    , -4.883    , -3.556    , -1.730    /
      DATA TBD( 80, 6),TBD( 80, 7),TBD( 80, 8),TBD( 80, 9),TBD( 80,10)
     *    / 14.860    , 11.528    ,  8.089    ,  9.659    ,  6.610    /
      DATA TBD( 81, 1),TBD( 81, 2),TBD( 81, 3),TBD( 81, 4),TBD( 81, 5)
     *    / -5.161    , -4.596    , -4.818    , -4.133    , -1.910    /
      DATA TBD( 81, 6),TBD( 81, 7),TBD( 81, 8),TBD( 81, 9),TBD( 81,10)
     *    / 15.595    , 12.108    ,  8.505    , 10.102    ,  6.930    /
      DATA TBD( 82, 1),TBD( 82, 2),TBD( 82, 3),TBD( 82, 4),TBD( 82, 5)
     *    / -5.420    , -4.688    , -4.776    , -4.861    , -2.116    /
      DATA TBD( 82, 6),TBD( 82, 7),TBD( 82, 8),TBD( 82, 9),TBD( 82,10)
     *    / 16.341    , 12.700    ,  8.930    , 10.559    ,  7.258    /
      DATA TBD( 83, 1),TBD( 83, 2),TBD( 83, 3),TBD( 83, 4),TBD( 83, 5)
     *    / -5.742    , -4.817    , -4.756    , -5.924    , -2.353    /
      DATA TBD( 83, 6),TBD( 83, 7),TBD( 83, 8),TBD( 83, 9),TBD( 83,10)
     *    / 17.139    , 13.331    ,  9.383    , 11.042    ,  7.600    /
      DATA TBD( 84, 1),TBD( 84, 2),TBD( 84, 3),TBD( 84, 4),TBD( 84, 5)
     *    / -6.132    , -4.992    , -4.772    , -7.444    , -2.630    /
      DATA TBD( 84, 6),TBD( 84, 7),TBD( 84, 8),TBD( 84, 9),TBD( 84,10)
     *    / 17.942    , 13.969    ,  9.843    ,  9.961    ,  7.949    /
      DATA TBD( 85, 1),TBD( 85, 2),TBD( 85, 3),TBD( 85, 4),TBD( 85, 5)
     *    / -6.545    , -5.173    , -4.787    , -8.862    , -2.932    /
      DATA TBD( 85, 6),TBD( 85, 7),TBD( 85, 8),TBD( 85, 9),TBD( 85,10)
     *    / 18.775    , 14.629    , 10.317    , 10.403    ,  8.307    /
      DATA TBD( 86, 1),TBD( 86, 2),TBD( 86, 3),TBD( 86, 4),TBD( 86, 5)
     *    / -7.052    , -5.402    , -4.833    , -7.912    , -3.285    /
      DATA TBD( 86, 6),TBD( 86, 7),TBD( 86, 8),TBD( 86, 9),TBD( 86,10)
     *    / 19.615    , 15.299    , 10.803    ,  7.754    ,  8.674    /
      DATA TBD( 87, 1),TBD( 87, 2),TBD( 87, 3),TBD( 87, 4),TBD( 87, 5)
     *    / -7.614    , -5.659    , -4.898    , -7.620    , -3.702    /
      DATA TBD( 87, 6),TBD( 87, 7),TBD( 87, 8),TBD( 87, 9),TBD( 87,10)
     *    / 20.461    , 15.977    , 11.296    ,  8.105    ,  9.047    /
      DATA TBD( 88, 1),TBD( 88, 2),TBD( 88, 3),TBD( 88, 4),TBD( 88, 5)
     *    / -8.318    , -5.976    , -4.994    , -7.725    , -4.192    /
      DATA TBD( 88, 6),TBD( 88, 7),TBD( 88, 8),TBD( 88, 9),TBD( 88,10)
     *    / 21.327    , 16.668    , 11.799    ,  8.472    ,  9.428    /
      DATA TBD( 89, 1),TBD( 89, 2),TBD( 89, 3),TBD( 89, 4),TBD( 89, 5)
     *    / -9.150    , -6.313    , -5.091    , -8.127    , -4.784    /
      DATA TBD( 89, 6),TBD( 89, 7),TBD( 89, 8),TBD( 89, 9),TBD( 89,10)
     *    / 22.240    , 17.397    , 12.330    ,  8.870    ,  9.819    /
      DATA TBD( 90, 1),TBD( 90, 2),TBD( 90, 3),TBD( 90, 4),TBD( 90, 5)
     *    /-10.382    , -6.695    , -5.216    , -8.960    , -5.555    /
      DATA TBD( 90, 6),TBD( 90, 7),TBD( 90, 8),TBD( 90, 9),TBD( 90,10)
     *    / 23.161    , 18.140    , 12.868    ,  9.284    , 10.227    /
      DATA TBD( 91, 1),TBD( 91, 2),TBD( 91, 3),TBD( 91, 4),TBD( 91, 5)
     *    /-10.930    , -7.126    , -5.359    ,-10.673    , -6.735    /
      DATA TBD( 91, 6),TBD( 91, 7),TBD( 91, 8),TBD( 91, 9),TBD( 91,10)
     *    / 23.121    , 18.879    , 13.409    ,  9.654    , 10.637    /
      DATA TBD( 92, 1),TBD( 92, 2),TBD( 92, 3),TBD( 92, 4),TBD( 92, 5)
     *    /-12.152    , -7.624    , -5.529    ,-11.158    , -7.842    /
      DATA TBD( 92, 6),TBD( 92, 7),TBD( 92, 8),TBD( 92, 9),TBD( 92,10)
     *    / 24.097    , 19.642    , 13.967    ,  4.148    ,  9.570    /
      DATA TBD( 93, 1),TBD( 93, 2),TBD( 93, 3),TBD( 93, 4),TBD( 93, 5)
     *    /-12.280    , -8.187    , -5.712    , -9.725    , -8.473    /
      DATA TBD( 93, 6),TBD( 93, 7),TBD( 93, 8),TBD( 93, 9),TBD( 93,10)
     *    / 23.658    , 20.425    , 14.536    ,  4.330    ,  6.999    /
      DATA TBD( 94, 1),TBD( 94, 2),TBD( 94, 3),TBD( 94, 4),TBD( 94, 5)
     *    /-12.771    , -8.872    , -5.930    , -8.926    , -7.701    /
      DATA TBD( 94, 6),TBD( 94, 7),TBD( 94, 8),TBD( 94, 9),TBD( 94,10)
     *    / 24.607    , 21.173    , 15.087    ,  4.511    ,  7.296    /
      DATA TBD( 95, 1),TBD( 95, 2),TBD( 95, 3),TBD( 95, 4),TBD( 95, 5)
     *    /-13.513    , -9.743    , -6.176    , -8.416    , -7.388    /
      DATA TBD( 95, 6),TBD( 95, 7),TBD( 95, 8),TBD( 95, 9),TBD( 95,10)
     *    / 25.540    , 21.896    , 15.634    ,  4.697    ,  7.589    /
      DATA TBD( 96, 1),TBD( 96, 2),TBD( 96, 3),TBD( 96, 4),TBD( 96, 5)
     *    /-14.827    ,-10.539    , -6.498    , -7.990    , -7.485    /
      DATA TBD( 96, 6),TBD( 96, 7),TBD( 96, 8),TBD( 96, 9),TBD( 96,10)
     *    / 26.801    , 21.942    , 16.317    ,  4.908    ,  7.931    /
      DATA TBD( 97, 1),TBD( 97, 2),TBD( 97, 3),TBD( 97, 4),TBD( 97, 5)
     *    /-16.272    ,-11.641    , -6.798    , -7.683    , -7.638    /
      DATA TBD( 97, 6),TBD( 97, 7),TBD( 97, 8),TBD( 97, 9),TBD( 97,10)
     *    / 27.898    , 22.785    , 16.930    ,  5.107    ,  8.246    /
      data tbxc( 1),tbx(  1,1),tbx(  1,2),tbx(  1,3),tbx(  1,4)
     *   /'h   '   ,.493002   ,10.5109   ,.322912   ,26.1257   /
      data tbx(  1,5),tbx(  1,6),tbx(  1,7),tbx(  1,8),tbx(  1,9)
     *   / .140191   ,3.14236   ,.040810   ,57.7997   ,.003038   /
      data tbx(  1,10)/1./
      data tbxc(  2),tbx(  2,1),tbx(  2,2),tbx(  2,3),tbx(  2,4)
     *   /'h   '   ,.489918   ,20.6593   ,.262003   ,7.74039   /
      data tbx(  2,5),tbx(  2,6),tbx(  2,7),tbx(  2,8),tbx(  2,9)
     *   / .196767   ,49.5519   ,.049879   ,2.20159   ,.001305   /
      data tbx(  2,10)/1./
      data tbxc(  3),tbx(  3,1),tbx(  3,2),tbx(  3,3),tbx(  3,4)
     *   /'h-1 '   ,.897661   ,53.1368   ,.565616   ,15.1870   /
      data tbx(  3,5),tbx(  3,6),tbx(  3,7),tbx(  3,8),tbx(  3,9)
     *   / .415815   ,186.576   ,.116973   ,3.56709   ,.002389   /
      data tbx(  3,10)/1./
      data tbxc(  4),tbx(  4,1),tbx(  4,2),tbx(  4,3),tbx(  4,4)
     *   /'he  '   ,  .8734   , 9.1037   ,  .6309   , 3.3568   /
      data tbx(  4,5),tbx(  4,6),tbx(  4,7),tbx(  4,8),tbx(  4,9)
     *   /   .3112   ,22.9276   ,  .1780   ,  .9821   ,  .0064   /
      data tbx(  4,10)/1./
      data tbxc(  5),tbx(  5,1),tbx(  5,2),tbx(  5,3),tbx(  5,4)
     *   /'li  '   , 1.1282   , 3.9546   ,  .7508   , 1.0524   /
      data tbx(  5,5),tbx(  5,6),tbx(  5,7),tbx(  5,8),tbx(  5,9)
     *   /   .6175   ,85.3905   ,  .4653   ,168.261   ,  .0377   /
      data tbx(  5,10)/2./
      data tbxc(  6),tbx(  6,1),tbx(  6,2),tbx(  6,3),tbx(  6,4)
     *   /'li+1'   ,  .6968   , 4.6237   ,  .7888   , 1.9557   /
      data tbx(  6,5),tbx(  6,6),tbx(  6,7),tbx(  6,8),tbx(  6,9)
     *   /   .3414   ,  .6316   ,  .1563   ,10.0953   ,  .0167   /
      data tbx(  6,10)/2./
      data tbxc(  7),tbx(  7,1),tbx(  7,2),tbx(  7,3),tbx(  7,4)
     *   /'be  '   , 1.5919   ,43.6427   , 1.1278   , 1.8623   /
      data tbx(  7,5),tbx(  7,6),tbx(  7,7),tbx(  7,8),tbx(  7,9)
     *   /   .5391   ,103.483   ,  .7029   ,  .5420   ,  .0385   /
      data tbx(  7,10)/3./
      data tbxc(  8),tbx(  8,1),tbx(  8,2),tbx(  8,3),tbx(  8,4)
     *   /'be+2'   , 6.2603   ,  .0027   ,  .8849   ,  .8313   /
      data tbx(  8,5),tbx(  8,6),tbx(  8,7),tbx(  8,8),tbx(  8,9)
     *   /   .7993   , 2.2758   ,  .1647   , 5.1146   ,-6.1092   /
      data tbx(  8,10)/3./
      data tbxc(  9),tbx(  9,1),tbx(  9,2),tbx(  9,3),tbx(  9,4)
     *   /'b   '   , 2.0545   ,23.2185   , 1.3326   , 1.0210   /
      data tbx(  9,5),tbx(  9,6),tbx(  9,7),tbx(  9,8),tbx(  9,9)
     *   /  1.0979   ,60.3498   ,  .7068   ,  .1403   , -.1932   /
      data tbx(  9,10)/4./
      data tbxc( 10),tbx( 10,1),tbx( 10,2),tbx( 10,3),tbx( 10,4)
     *   /'c   '   , 2.3100   ,20.8439   , 1.0200   ,10.2075   /
      data tbx( 10,5),tbx( 10,6),tbx( 10,7),tbx( 10,8),tbx( 10,9)
     *   /  1.5886   ,  .5687   ,  .8650   ,51.6512   ,  .2156   /
      data tbx( 10,10)/5./
      data tbxc( 11),tbx( 11,1),tbx( 11,2),tbx( 11,3),tbx( 11,4)
     *   /'cval'   ,2.26069   ,22.6907   ,1.56165   ,.656665   /
      data tbx( 11,5),tbx( 11,6),tbx( 11,7),tbx( 11,8),tbx( 11,9)
     *   / 1.05075   ,9.75618   ,.839259   ,55.5949   ,.286977   /
      data tbx( 11,10)/5./
      data tbxc( 12),tbx( 12,1),tbx( 12,2),tbx( 12,3),tbx( 12,4)
     *   /'n   '   ,12.2126   ,  .0057   , 3.1322   , 9.8933   /
      data tbx( 12,5),tbx( 12,6),tbx( 12,7),tbx( 12,8),tbx( 12,9)
     *   /  2.0125   ,28.9975   , 1.1663   ,  .5826   ,-11.529   /
      data tbx( 12,10)/6./
      data tbxc( 13),tbx( 13,1),tbx( 13,2),tbx( 13,3),tbx( 13,4)
     *   /'o   '   , 3.0485   ,13.2771   , 2.2868   , 5.7011   /
      data tbx( 13,5),tbx( 13,6),tbx( 13,7),tbx( 13,8),tbx( 13,9)
     *   /  1.5463   ,  .3239   ,  .8670   ,32.9089   ,  .2508   /
      data tbx( 13,10)/7./
      data tbxc( 14),tbx( 14,1),tbx( 14,2),tbx( 14,3),tbx( 14,4)
     *   /'o-1 '   ,4.19160   ,12.8573   ,1.63969   ,4.17236   /
      data tbx( 14,5),tbx( 14,6),tbx( 14,7),tbx( 14,8),tbx( 14,9)
     *   / 1.52673   ,47.0179   ,-20.307   ,-.01404   ,21.9412   /
      data tbx( 14,10)/7./
      data tbxc(213),tbx(213,1),tbx(213,2),tbx(213,3),tbx(213,4)
     *   /'o-2 '   ,4.758   ,7.831   ,3.637   ,30.05   /
      data tbx(213,5),tbx(213,6),tbx(213,7),tbx(213,8),tbx(213,9)
     *   / 0.000   ,0.000   ,0.0000   ,0.000   ,1.594   /
      data tbx(213,10)/7./
      data tbxc( 15),tbx( 15,1),tbx( 15,2),tbx( 15,3),tbx( 15,4)
     *   /'f   '   , 3.5392   ,10.2825   , 2.6412   , 4.2944   /
      data tbx( 15,5),tbx( 15,6),tbx( 15,7),tbx( 15,8),tbx( 15,9)
     *   /  1.5170   ,  .2615   , 1.0243   ,26.1476   ,  .2776   /
      data tbx( 15,10)/8./
      data tbxc( 16),tbx( 16,1),tbx( 16,2),tbx( 16,3),tbx( 16,4)
     *   /'f-1 '   ,3.63220   ,5.27756   ,3.51057   ,14.7353   /
      data tbx( 16,5),tbx( 16,6),tbx( 16,7),tbx( 16,8),tbx( 16,9)
     *   / 1.26064   ,.442258   ,.940706   ,47.3437   ,.653396   /
      data tbx( 16,10)/8./
      data tbxc( 17),tbx( 17,1),tbx( 17,2),tbx( 17,3),tbx( 17,4)
     *   /'ne  '   , 3.9553   , 8.4042   , 3.1125   , 3.4262   /
      data tbx( 17,5),tbx( 17,6),tbx( 17,7),tbx( 17,8),tbx( 17,9)
     *   /  1.4546   ,  .2306   , 1.1251   ,21.7184   ,  .3515   /
      data tbx( 17,10)/9./
      data tbxc( 18),tbx( 18,1),tbx( 18,2),tbx( 18,3),tbx( 18,4)
     *   /'na  '   , 4.7626   , 3.2850   , 3.1736   , 8.8422   /
      data tbx( 18,5),tbx( 18,6),tbx( 18,7),tbx( 18,8),tbx( 18,9)
     *   /  1.2674   ,  .3136   , 1.1128   ,129.424   ,  .6760   /
      data tbx( 18,10)/10./
      data tbxc( 19),tbx( 19,1),tbx( 19,2),tbx( 19,3),tbx( 19,4)
     *   /'na+1'   , 3.2565   , 2.6671   , 3.9362   , 6.1153   /
      data tbx( 19,5),tbx( 19,6),tbx( 19,7),tbx( 19,8),tbx( 19,9)
     *   /  1.3998   ,  .2001   , 1.0032   ,14.0390   ,  .4040   /
      data tbx( 19,10)/10./
      data tbxc( 20),tbx( 20,1),tbx( 20,2),tbx( 20,3),tbx( 20,4)
     *   /'mg  '   , 5.4204   , 2.8275   , 2.1735   ,79.2611   /
      data tbx( 20,5),tbx( 20,6),tbx( 20,7),tbx( 20,8),tbx( 20,9)
     *   /  1.2269   ,  .3808   , 2.3073   , 7.1937   ,  .8584   /
      data tbx( 20,10)/11./
      data tbxc( 21),tbx( 21,1),tbx( 21,2),tbx( 21,3),tbx( 21,4)
     *   /'mg+2'   , 3.4988   , 2.1676   , 3.8378   , 4.7542   /
      data tbx( 21,5),tbx( 21,6),tbx( 21,7),tbx( 21,8),tbx( 21,9)
     *   /  1.3284   ,  .1850   ,  .8497   ,10.1411   ,  .4853   /
      data tbx( 21,10)/11./
      data tbxc( 22),tbx( 22,1),tbx( 22,2),tbx( 22,3),tbx( 22,4)
     *   /'al  '   , 6.4202   , 3.0387   , 1.9002   ,  .7426   /
      data tbx( 22,5),tbx( 22,6),tbx( 22,7),tbx( 22,8),tbx( 22,9)
     *   /  1.5936   ,31.5472   , 1.9646   ,85.0886   , 1.1151   /
      data tbx( 22,10)/12./
      data tbxc( 23),tbx( 23,1),tbx( 23,2),tbx( 23,3),tbx( 23,4)
     *   /'al+3'   ,4.17448   ,1.93816   ,3.38760   ,4.14553   /
      data tbx( 23,5),tbx( 23,6),tbx( 23,7),tbx( 23,8),tbx( 23,9)
     *   / 1.20296   ,.228753   ,.528137   ,8.28524   ,.706786   /
      data tbx( 23,10)/12./
      data tbxc( 24),tbx( 24,1),tbx( 24,2),tbx( 24,3),tbx( 24,4)
     *   /'si  '   , 6.2915   , 2.4386   , 3.0353   ,32.3337   /
      data tbx( 24,5),tbx( 24,6),tbx( 24,7),tbx( 24,8),tbx( 24,9)
     *   /  1.9891   ,  .6785   , 1.5410   ,81.6937   , 1.1407   /
      data tbx( 24,10)/13./
      data tbxc( 25),tbx( 25,1),tbx( 25,2),tbx( 25,3),tbx( 25,4)
     *   /'siv '   ,5.66269   ,2.66520   ,3.07164   ,38.6634   /
      data tbx( 25,5),tbx( 25,6),tbx( 25,7),tbx( 25,8),tbx( 25,9)
     *   / 2.62446   ,.916946   ,1.39320   ,93.5458   ,1.24707   /
      data tbx( 25,10)/13./
      data tbxc( 26),tbx( 26,1),tbx( 26,2),tbx( 26,3),tbx( 26,4)
     *   /'si+4'   ,4.43918   ,1.64167   ,3.20345   ,3.43757   /
      data tbx( 26,5),tbx( 26,6),tbx( 26,7),tbx( 26,8),tbx( 26,9)
     *   / 1.19453   ,.214900   ,.416530   ,6.65365   ,.746297   /
      data tbx( 26,10)/13./
      data tbxc( 27),tbx( 27,1),tbx( 27,2),tbx( 27,3),tbx( 27,4)
     *   /'s   '   , 6.9053   , 1.4679   , 5.2034   ,22.2151   /
      data tbx( 27,5),tbx( 27,6),tbx( 27,7),tbx( 27,8),tbx( 27,9)
     *   /  1.4379   ,  .2536   , 1.5863   ,56.1720   ,  .8669   /
      data tbx( 27,10)/15./
      data tbxc( 28),tbx( 28,1),tbx( 28,2),tbx( 28,3),tbx( 28,4)
     *   /'p   '   , 6.4345   , 1.9067   , 4.1791   ,27.1570   /
      data tbx( 28,5),tbx( 28,6),tbx( 28,7),tbx( 28,8),tbx( 28,9)
     *   /  1.7800   ,  .5260   , 1.4908   ,68.1645   , 1.1149   /
      data tbx( 28,10)/14./
      data tbxc( 29),tbx( 29,1),tbx( 29,2),tbx( 29,3),tbx( 29,4)
     *   /'cl  '   ,11.4604   ,  .0104   , 7.1964   , 1.1662   /
      data tbx( 29,5),tbx( 29,6),tbx( 29,7),tbx( 29,8),tbx( 29,9)
     *   /  6.2556   ,18.5194   , 1.6455   ,47.7784   ,-9.5574   /
      data tbx( 29,10)/16./
      data tbxc( 30),tbx( 30,1),tbx( 30,2),tbx( 30,3),tbx( 30,4)
     *   /'cl-1'   ,18.2915   ,  .0066   , 7.2084   , 1.1717   /
      data tbx( 30,5),tbx( 30,6),tbx( 30,7),tbx( 30,8),tbx( 30,9)
     *   /  6.5337   ,19.5424   , 2.3386   ,60.4486   ,-16.378   /
      data tbx( 30,10)/16./
      data tbxc( 31),tbx( 31,1),tbx( 31,2),tbx( 31,3),tbx( 31,4)
     *   /'ar  '   , 7.4845   ,  .9072   , 6.7723   ,14.8407   /
      data tbx( 31,5),tbx( 31,6),tbx( 31,7),tbx( 31,8),tbx( 31,9)
     *   /   .6539   ,43.8983   , 1.6442   ,33.3929   , 1.4445   /
      data tbx( 31,10)/17./
      data tbxc( 32),tbx( 32,1),tbx( 32,2),tbx( 32,3),tbx( 32,4)
     *   /'k   '   , 8.2186   ,12.7949   , 7.4398   ,  .7748   /
      data tbx( 32,5),tbx( 32,6),tbx( 32,7),tbx( 32,8),tbx( 32,9)
     *   /  1.0519   ,213.187   ,  .8659   ,41.6841   , 1.4228   /
      data tbx( 32,10)/18./
      data tbxc( 33),tbx( 33,1),tbx( 33,2),tbx( 33,3),tbx( 33,4)
     *   /'k+1 '   , 7.9578   ,12.6331   , 7.4917   ,  .7674   /
      data tbx( 33,5),tbx( 33,6),tbx( 33,7),tbx( 33,8),tbx( 33,9)
     *   /  6.3590   , -.0020   , 1.1915   ,31.9128   ,-4.9978   /
      data tbx( 33,10)/18./
      data tbxc( 34),tbx( 34,1),tbx( 34,2),tbx( 34,3),tbx( 34,4)
     *   /'ca  '   , 8.6266   ,10.4421   , 7.3873   ,  .6599   /
      data tbx( 34,5),tbx( 34,6),tbx( 34,7),tbx( 34,8),tbx( 34,9)
     *   /  1.5899   ,85.7484   , 1.0211   ,178.437   , 1.3751   /
      data tbx( 34,10)/19./
      data tbxc( 35),tbx( 35,1),tbx( 35,2),tbx( 35,3),tbx( 35,4)
     *   /'ca+2'   ,15.6348   , -.0074   , 7.9518   ,  .6089   /
      data tbx( 35,5),tbx( 35,6),tbx( 35,7),tbx( 35,8),tbx( 35,9)
     *   /  8.4372   ,10.3116   ,  .8537   ,25.9905   ,-14.875   /
      data tbx( 35,10)/19./
      data tbxc( 36),tbx( 36,1),tbx( 36,2),tbx( 36,3),tbx( 36,4)
     *   /'sc  '   , 9.1890   , 9.0213   , 7.3679   ,  .5729   /
      data tbx( 36,5),tbx( 36,6),tbx( 36,7),tbx( 36,8),tbx( 36,9)
     *   /  1.6409   ,136.108   , 1.4680   ,51.3531   , 1.3329   /
      data tbx( 36,10)/20./
      data tbxc( 37),tbx( 37,1),tbx( 37,2),tbx( 37,3),tbx( 37,4)
     *   /'sc+3'   ,13.4008   ,.298540   ,8.02730   ,7.96290   /
      data tbx( 37,5),tbx( 37,6),tbx( 37,7),tbx( 37,8),tbx( 37,9)
     *   / 1.65943   ,-.28604   ,1.57936   ,16.0662   ,-6.6667   /
      data tbx( 37,10)/20./
      data tbxc( 38),tbx( 38,1),tbx( 38,2),tbx( 38,3),tbx( 38,4)
     *   /'ti  '   , 9.7595   , 7.8508   , 7.3558   ,  .5000   /
      data tbx( 38,5),tbx( 38,6),tbx( 38,7),tbx( 38,8),tbx( 38,9)
     *   /  1.6991   ,35.6338   , 1.9021   ,116.105   , 1.2807   /
      data tbx( 38,10)/21./
      data tbxc( 39),tbx( 39,1),tbx( 39,2),tbx( 39,3),tbx( 39,4)
     *   /'ti+2'   ,9.11423   ,7.52430   ,7.62174   ,.457585   /
      data tbx( 39,5),tbx( 39,6),tbx( 39,7),tbx( 39,8),tbx( 39,9)
     *   / 2.27930   ,19.5361   ,.087899   ,61.6558   ,.897155   /
      data tbx( 39,10)/21./
      data tbxc( 40),tbx( 40,1),tbx( 40,2),tbx( 40,3),tbx( 40,4)
     *   /'ti+3'   ,17.7344   ,.220610   ,8.73816   ,7.04716   /
      data tbx( 40,5),tbx( 40,6),tbx( 40,7),tbx( 40,8),tbx( 40,9)
     *   / 5.25691   ,-.15762   ,1.92134   ,15.9768   ,-14.652   /
      data tbx( 40,10)/21./
      data tbxc( 41),tbx( 41,1),tbx( 41,2),tbx( 41,3),tbx( 41,4)
     *   /'ti+4'   ,19.5114   ,.178847   ,8.23473   ,6.67018   /
      data tbx( 41,5),tbx( 41,6),tbx( 41,7),tbx( 41,8),tbx( 41,9)
     *   / 2.01341   ,-.29263   ,1.52080   ,12.9464   ,-13.280   /
      data tbx( 41,10)/21./
      data tbxc( 42),tbx( 42,1),tbx( 42,2),tbx( 42,3),tbx( 42,4)
     *   /'v   '   ,10.2971   , 6.8657   , 7.3511   ,  .4385   /
      data tbx( 42,5),tbx( 42,6),tbx( 42,7),tbx( 42,8),tbx( 42,9)
     *   /  2.0703   ,26.8938   , 2.0571   ,102.478   , 1.2199   /
      data tbx( 42,10)/22./
      data tbxc( 43),tbx( 43,1),tbx( 43,2),tbx( 43,3),tbx( 43,4)
     *   /'v+2 '   ,10.1060   , 6.8818   , 7.3541   ,  .4409   /
      data tbx( 43,5),tbx( 43,6),tbx( 43,7),tbx( 43,8),tbx( 43,9)
     *   /  2.2884   ,20.3004   ,  .0223   ,115.122   , 1.2298   /
      data tbx( 43,10)/22./
      data tbxc( 44),tbx( 44,1),tbx( 44,2),tbx( 44,3),tbx( 44,4)
     *   /'v+3 '   ,9.43141   ,6.39535   ,7.74190   ,.383349   /
      data tbx( 44,5),tbx( 44,6),tbx( 44,7),tbx( 44,8),tbx( 44,9)
     *   / 2.15343   ,15.1908   ,.016865   ,63.9690   ,.656565   /
      data tbx( 44,10)/22./
      data tbxc( 45),tbx( 45,1),tbx( 45,2),tbx( 45,3),tbx( 45,4)
     *   /'v+5 '   ,15.6887   ,.679003   ,8.14208   ,5.40135   /
      data tbx( 45,5),tbx( 45,6),tbx( 45,7),tbx( 45,8),tbx( 45,9)
     *   / 2.03081   ,9.97278   ,-9.5760   ,.940464   ,1.71430   /
      data tbx( 45,10)/22./
      data tbxc( 46),tbx( 46,1),tbx( 46,2),tbx( 46,3),tbx( 46,4)
     *   /'cr  '   ,10.6406   , 6.1038   , 7.3537   ,  .3920   /
      data tbx( 46,5),tbx( 46,6),tbx( 46,7),tbx( 46,8),tbx( 46,9)
     *   /  3.3240   ,20.2626   , 1.4922   ,98.7399   , 1.1832   /
      data tbx( 46,10)/23./
      data tbxc( 47),tbx( 47,1),tbx( 47,2),tbx( 47,3),tbx( 47,4)
     *   /'cr+2'   ,9.54034   ,5.66078   ,7.75090   ,.344261   /
      data tbx( 47,5),tbx( 47,6),tbx( 47,7),tbx( 47,8),tbx( 47,9)
     *   / 3.58274   ,13.3075   ,.509107   ,32.4224   ,.616898   /
      data tbx( 47,10)/23./
      data tbxc( 48),tbx( 48,1),tbx( 48,2),tbx( 48,3),tbx( 48,4)
     *   /'cr+3'   ,9.68090   ,5.59463   ,7.81136   ,.334393   /
      data tbx( 48,5),tbx( 48,6),tbx( 48,7),tbx( 48,8),tbx( 48,9)
     *   / 2.87603   ,12.8288   ,.113575   ,32.8761   ,.518275   /
      data tbx( 48,10)/23./
      data tbxc( 49),tbx( 49,1),tbx( 49,2),tbx( 49,3),tbx( 49,4)
     *   /'mn  '   ,11.2819   , 5.3409   , 7.3573   ,  .3432   /
      data tbx( 49,5),tbx( 49,6),tbx( 49,7),tbx( 49,8),tbx( 49,9)
     *   /  3.0193   ,17.8674   , 2.2441   ,83.7543   , 1.0896   /
      data tbx( 49,10)/24./
      data tbxc( 50),tbx( 50,1),tbx( 50,2),tbx( 50,3),tbx( 50,4)
     *   /'mn+2'   ,10.8061   , 5.2796   , 7.3620   ,  .3435   /
      data tbx( 50,5),tbx( 50,6),tbx( 50,7),tbx( 50,8),tbx( 50,9)
     *   /  3.5268   ,14.3430   ,  .2184   ,41.3235   , 1.0874   /
      data tbx( 50,10)/24./
      data tbxc( 51),tbx( 51,1),tbx( 51,2),tbx( 51,3),tbx( 51,4)
     *   /'mn+3'   ,9.84521   ,4.91797   ,7.87194   ,.294393   /
      data tbx( 51,5),tbx( 51,6),tbx( 51,7),tbx( 51,8),tbx( 51,9)
     *   / 3.56531   ,10.8171   ,.323613   ,24.1281   ,.393974   /
      data tbx( 51,10)/24./
      data tbxc( 52),tbx( 52,1),tbx( 52,2),tbx( 52,3),tbx( 52,4)
     *   /'mn+4'   ,9.96253   ,4.84850   ,7.97057   ,.283303   /
      data tbx( 52,5),tbx( 52,6),tbx( 52,7),tbx( 52,8),tbx( 52,9)
     *   / 2.76067   ,10.4852   ,.054447   ,27.5730   ,.251877   /
      data tbx( 52,10)/24./
      data tbxc( 53),tbx( 53,1),tbx( 53,2),tbx( 53,3),tbx( 53,4)
     *   /'fe  '   ,11.7695   , 4.7611   , 7.3573   ,  .3072   /
      data tbx( 53,5),tbx( 53,6),tbx( 53,7),tbx( 53,8),tbx( 53,9)
     *   /  3.5222   ,15.3535   , 2.3045   ,76.8805   , 1.0369   /
      data tbx( 53,10)/25./
      data tbxc( 54),tbx( 54,1),tbx( 54,2),tbx( 54,3),tbx( 54,4)
     *   /'fe+2'   ,11.0424   , 4.6538   , 7.3740   ,  .3053   /
      data tbx( 54,5),tbx( 54,6),tbx( 54,7),tbx( 54,8),tbx( 54,9)
     *   /  4.1346   ,12.0546   ,  .4399   ,31.2809   , 1.0097   /
      data tbx( 54,10)/25./
      data tbxc( 55),tbx( 55,1),tbx( 55,2),tbx( 55,3),tbx( 55,4)
     *   /'fe+3'   ,11.1764   , 4.6147   , 7.3863   ,  .3005   /
      data tbx( 55,5),tbx( 55,6),tbx( 55,7),tbx( 55,8),tbx( 55,9)
     *   /  3.3948   ,11.6729   ,  .0724   ,38.5566   ,  .9707   /
      data tbx( 55,10)/25./
      data tbxc( 56),tbx( 56,1),tbx( 56,2),tbx( 56,3),tbx( 56,4)
     *   /'co  '   ,12.2841   , 4.2791   , 7.3409   ,  .2784   /
      data tbx( 56,5),tbx( 56,6),tbx( 56,7),tbx( 56,8),tbx( 56,9)
     *   /  4.0034   ,13.5359   , 2.3488   ,71.1692   , 1.0118   /
      data tbx( 56,10)/26./
      data tbxc( 57),tbx( 57,1),tbx( 57,2),tbx( 57,3),tbx( 57,4)
     *   /'co+2'   ,11.2296   , 4.1231   , 7.3883   ,  .2726   /
      data tbx( 57,5),tbx( 57,6),tbx( 57,7),tbx( 57,8),tbx( 57,9)
     *   /  4.7393   ,10.2443   ,  .7108   ,25.6466   ,  .9324   /
      data tbx( 57,10)/26./
      data tbxc( 58),tbx( 58,1),tbx( 58,2),tbx( 58,3),tbx( 58,4)
     *   /'co+3'   ,10.3380   ,3.90969   ,7.88173   ,.238668   /
      data tbx( 58,5),tbx( 58,6),tbx( 58,7),tbx( 58,8),tbx( 58,9)
     *   / 4.76795   ,8.35583   ,.725591   ,18.3491   ,.286667   /
      data tbx( 58,10)/26./
      data tbxc( 59),tbx( 59,1),tbx( 59,2),tbx( 59,3),tbx( 59,4)
     *   /'ni  '   ,12.8376   , 3.8785   , 7.2920   ,  .2565   /
      data tbx( 59,5),tbx( 59,6),tbx( 59,7),tbx( 59,8),tbx( 59,9)
     *   /  4.4438   ,12.1763   , 2.3800   ,66.3421   , 1.0341   /
      data tbx( 59,10)/27./
      data tbxc( 60),tbx( 60,1),tbx( 60,2),tbx( 60,3),tbx( 60,4)
     *   /'ni+2'   ,11.4166   , 3.6766   , 7.4005   ,  .2449   /
      data tbx( 60,5),tbx( 60,6),tbx( 60,7),tbx( 60,8),tbx( 60,9)
     *   /  5.3442   , 8.8730   ,  .9773   ,22.1626   ,  .8614   /
      data tbx( 60,10)/27./
      data tbxc( 61),tbx( 61,1),tbx( 61,2),tbx( 61,3),tbx( 61,4)
     *   /'ni+3'   ,10.7806   ,3.54770   ,7.75868   ,.223140   /
      data tbx( 61,5),tbx( 61,6),tbx( 61,7),tbx( 61,8),tbx( 61,9)
     *   / 5.22746   ,7.64468   ,.847114   ,16.9673   ,.386044   /
      data tbx( 61,10)/27./
      data tbxc( 62),tbx( 62,1),tbx( 62,2),tbx( 62,3),tbx( 62,4)
     *   /'cu  '   ,13.3380   , 3.5828   , 7.1676   ,  .2470   /
      data tbx( 62,5),tbx( 62,6),tbx( 62,7),tbx( 62,8),tbx( 62,9)
     *   /  5.6158   ,11.3966   , 1.6735   ,64.8126   , 1.1910   /
      data tbx( 62,10)/28./
      data tbxc( 63),tbx( 63,1),tbx( 63,2),tbx( 63,3),tbx( 63,4)
     *   /'cu+1'   ,11.9475   , 3.3669   , 7.3573   ,  .2274   /
      data tbx( 63,5),tbx( 63,6),tbx( 63,7),tbx( 63,8),tbx( 63,9)
     *   /  6.2455   , 8.6625   , 1.5578   ,25.8487   ,  .8900   /
      data tbx( 63,10)/28./
      data tbxc( 64),tbx( 64,1),tbx( 64,2),tbx( 64,3),tbx( 64,4)
     *   /'cu+2'   ,11.8168   ,3.37484   ,7.11181   ,.244078   /
      data tbx( 64,5),tbx( 64,6),tbx( 64,7),tbx( 64,8),tbx( 64,9)
     *   / 5.78135   ,7.98760   ,1.14523   ,19.8970   ,1.14431   /
      data tbx( 64,10)/28./
      data tbxc( 65),tbx( 65,1),tbx( 65,2),tbx( 65,3),tbx( 65,4)
     *   /'zn  '   ,14.0743   , 3.2655   , 7.0318   ,  .2333   /
      data tbx( 65,5),tbx( 65,6),tbx( 65,7),tbx( 65,8),tbx( 65,9)
     *   /  5.1652   ,10.3163   , 2.4100   ,58.7097   , 1.3041   /
      data tbx( 65,10)/29./
      data tbxc( 66),tbx( 66,1),tbx( 66,2),tbx( 66,3),tbx( 66,4)
     *   /'zn+2'   ,11.9719   , 2.9946   , 7.3862   ,  .2031   /
      data tbx( 66,5),tbx( 66,6),tbx( 66,7),tbx( 66,8),tbx( 66,9)
     *   /  6.4668   , 7.0826   , 1.3940   ,18.0995   ,  .7807   /
      data tbx( 66,10)/29./
      data tbxc( 67),tbx( 67,1),tbx( 67,2),tbx( 67,3),tbx( 67,4)
     *   /'ga  '   ,15.2354   , 3.0669   , 6.7006   ,  .2412   /
      data tbx( 67,5),tbx( 67,6),tbx( 67,7),tbx( 67,8),tbx( 67,9)
     *   /  4.3591   ,10.7805   , 2.9623   ,61.4135   , 1.7189   /
      data tbx( 67,10)/30./
      data tbxc( 68),tbx( 68,1),tbx( 68,2),tbx( 68,3),tbx( 68,4)
     *   /'ga+3'   ,12.6920   ,2.81262   ,6.69883   ,.227890   /
      data tbx( 68,5),tbx( 68,6),tbx( 68,7),tbx( 68,8),tbx( 68,9)
     *   / 6.06692   ,6.36441   ,1.00660   ,14.4122   ,1.53545   /
      data tbx( 68,10)/30./
      data tbxc( 69),tbx( 69,1),tbx( 69,2),tbx( 69,3),tbx( 69,4)
     *   /'ge  '   ,16.0816   , 2.8509   , 6.3747   ,  .2516   /
      data tbx( 69,5),tbx( 69,6),tbx( 69,7),tbx( 69,8),tbx( 69,9)
     *   /  3.7068   ,11.4468   , 3.6830   ,54.7625   , 2.1313   /
      data tbx( 69,10)/31./
      data tbxc( 70),tbx( 70,1),tbx( 70,2),tbx( 70,3),tbx( 70,4)
     *   /'ge+4'   ,12.9172   ,2.53718   ,6.70003   ,.205855   /
      data tbx( 70,5),tbx( 70,6),tbx( 70,7),tbx( 70,8),tbx( 70,9)
     *   / 6.06791   ,5.47913   ,.859041   ,11.6030   ,1.45572   /
      data tbx( 70,10)/31./
      data tbxc( 71),tbx( 71,1),tbx( 71,2),tbx( 71,3),tbx( 71,4)
     *   /'as  '   ,16.6723   , 2.6345   , 6.0701   ,  .2647   /
      data tbx( 71,5),tbx( 71,6),tbx( 71,7),tbx( 71,8),tbx( 71,9)
     *   /  3.4313   ,12.9479   , 4.2779   ,47.7972   , 2.5310   /
      data tbx( 71,10)/32./
      data tbxc( 72),tbx( 72,1),tbx( 72,2),tbx( 72,3),tbx( 72,4)
     *   /'se  '   ,17.0006   , 2.4098   , 5.8196   ,  .2726   /
      data tbx( 72,5),tbx( 72,6),tbx( 72,7),tbx( 72,8),tbx( 72,9)
     *   /  3.9731   ,15.2372   , 4.3543   ,43.8163   , 2.8409   /
      data tbx( 72,10)/33./
      data tbxc( 73),tbx( 73,1),tbx( 73,2),tbx( 73,3),tbx( 73,4)
     *   /'br  '   ,17.1789   , 2.1723   , 5.2358   ,16.5796   /
      data tbx( 73,5),tbx( 73,6),tbx( 73,7),tbx( 73,8),tbx( 73,9)
     *   /  5.6377   ,  .2609   , 3.9851   ,41.4328   , 2.9557   /
      data tbx( 73,10)/34./
      data tbxc( 74),tbx( 74,1),tbx( 74,2),tbx( 74,3),tbx( 74,4)
     *   /'br-1'   ,17.1718   , 2.2059   , 6.3338   ,19.3345   /
      data tbx( 74,5),tbx( 74,6),tbx( 74,7),tbx( 74,8),tbx( 74,9)
     *   /  5.5754   ,  .2871   , 3.7272   ,58.1535   , 3.1776   /
      data tbx( 74,10)/34./
      data tbxc( 75),tbx( 75,1),tbx( 75,2),tbx( 75,3),tbx( 75,4)
     *   /'kr  '   ,17.3555   , 1.9384   , 6.7286   ,16.5623   /
      data tbx( 75,5),tbx( 75,6),tbx( 75,7),tbx( 75,8),tbx( 75,9)
     *   /  5.5493   ,  .2261   , 3.5375   ,39.3972   , 2.8250   /
      data tbx( 75,10)/35./
      data tbxc( 76),tbx( 76,1),tbx( 76,2),tbx( 76,3),tbx( 76,4)
     *   /'rb  '   ,17.1784   , 1.7888   , 9.6435   ,17.3151   /
      data tbx( 76,5),tbx( 76,6),tbx( 76,7),tbx( 76,8),tbx( 76,9)
     *   /  5.1399   ,  .2748   , 1.5292   ,164.934   , 3.4873   /
      data tbx( 76,10)/36./
      data tbxc( 77),tbx( 77,1),tbx( 77,2),tbx( 77,3),tbx( 77,4)
     *   /'rb+1'   ,17.5816   , 1.7139   , 7.6598   ,14.7957   /
      data tbx( 77,5),tbx( 77,6),tbx( 77,7),tbx( 77,8),tbx( 77,9)
     *   /  5.8981   ,  .1603   , 2.7817   ,31.2087   , 2.0782   /
      data tbx( 77,10)/36./
      data tbxc( 78),tbx( 78,1),tbx( 78,2),tbx( 78,3),tbx( 78,4)
     *   /'sr  '   ,17.5663   , 1.5564   , 9.8184   ,14.0988   /
      data tbx( 78,5),tbx( 78,6),tbx( 78,7),tbx( 78,8),tbx( 78,9)
     *   /  5.4220   ,  .1664   , 2.6694   ,132.376   , 2.5064   /
      data tbx( 78,10)/37./
      data tbxc( 79),tbx( 79,1),tbx( 79,2),tbx( 79,3),tbx( 79,4)
     *   /'sr+2'   ,18.0874   , 1.4907   , 8.1373   ,12.6963   /
      data tbx( 79,5),tbx( 79,6),tbx( 79,7),tbx( 79,8),tbx( 79,9)
     *   /  2.5654   ,24.5651   ,-34.193   , -.0138   ,41.4025   /
      data tbx( 79,10)/37./
      data tbxc( 80),tbx( 80,1),tbx( 80,2),tbx( 80,3),tbx( 80,4)
     *   /'y   '   ,17.7760   ,1.40290   ,10.2946   ,12.8006   /
      data tbx( 80,5),tbx( 80,6),tbx( 80,7),tbx( 80,8),tbx( 80,9)
     *   / 5.72629   ,.125599   ,3.26588   ,104.354   ,1.91213   /
      data tbx( 80,10)/38./
      data tbxc( 81),tbx( 81,1),tbx( 81,2),tbx( 81,3),tbx( 81,4)
     *   /'y+3 '   ,17.9268   ,1.35417   ,9.15310   ,11.2145   /
      data tbx( 81,5),tbx( 81,6),tbx( 81,7),tbx( 81,8),tbx( 81,9)
     *   / 1.76795   ,22.6599   ,-33.108   ,-.01319   ,40.2602   /
      data tbx( 81,10)/38./
      data tbxc( 82),tbx( 82,1),tbx( 82,2),tbx( 82,3),tbx( 82,4)
     *   /'zr  '   ,17.8765   ,1.27618   ,10.9480   ,11.9160   /
      data tbx( 82,5),tbx( 82,6),tbx( 82,7),tbx( 82,8),tbx( 82,9)
     *   / 5.41732   ,.117622   ,3.65721   ,87.6627   ,2.06929   /
      data tbx( 82,10)/39./
      data tbxc( 83),tbx( 83,1),tbx( 83,2),tbx( 83,3),tbx( 83,4)
     *   /'zr+4'   ,18.1668   ,1.21480   ,10.0562   ,10.1483   /
      data tbx( 83,5),tbx( 83,6),tbx( 83,7),tbx( 83,8),tbx( 83,9)
     *   / 1.01118   ,21.6054   ,-2.6479   ,-.10276   ,9.41454   /
      data tbx( 83,10)/39./
      data tbxc( 84),tbx( 84,1),tbx( 84,2),tbx( 84,3),tbx( 84,4)
     *   /'nb  '   ,17.6142   ,1.18865   ,12.0144   ,11.7660   /
      data tbx( 84,5),tbx( 84,6),tbx( 84,7),tbx( 84,8),tbx( 84,9)
     *   / 4.04183   ,.204785   ,3.53346   ,69.7957   ,3.75591   /
      data tbx( 84,10)/40./
      data tbxc( 85),tbx( 85,1),tbx( 85,2),tbx( 85,3),tbx( 85,4)
     *   /'nb+3'   ,19.8812   ,.019175   ,18.0653   ,1.13305   /
      data tbx( 85,5),tbx( 85,6),tbx( 85,7),tbx( 85,8),tbx( 85,9)
     *   / 11.0177   ,10.1621   ,1.94715   ,28.3389   ,-12.912   /
      data tbx( 85,10)/40./
      data tbxc( 86),tbx( 86,1),tbx( 86,2),tbx( 86,3),tbx( 86,4)
     *   /'nb+5'   ,17.9163   ,1.12446   ,13.3417   ,.028781   /
      data tbx( 86,5),tbx( 86,6),tbx( 86,7),tbx( 86,8),tbx( 86,9)
     *   / 10.7990   ,9.28206   ,.337905   ,25.7228   ,-6.3934   /
      data tbx( 86,10)/40./
      data tbxc( 87),tbx( 87,1),tbx( 87,2),tbx( 87,3),tbx( 87,4)
     *   /'mo  '   , 3.7025   ,  .2772   ,17.2356   , 1.0958   /
      data tbx( 87,5),tbx( 87,6),tbx( 87,7),tbx( 87,8),tbx( 87,9)
     *   / 12.8876   ,11.0040   , 3.7429   ,61.6584   , 4.3875   /
      data tbx( 87,10)/41./
      data tbxc( 88),tbx( 88,1),tbx( 88,2),tbx( 88,3),tbx( 88,4)
     *   /'mo+3'   ,21.1664   ,.014734   ,18.2017   ,1.03031   /
      data tbx( 88,5),tbx( 88,6),tbx( 88,7),tbx( 88,8),tbx( 88,9)
     *   / 11.7423   ,9.53659   ,2.30951   ,26.6307   ,-14.421   /
      data tbx( 88,10)/41./
      data tbxc( 89),tbx( 89,1),tbx( 89,2),tbx( 89,3),tbx( 89,4)
     *   /'mo+5'   ,21.0149   ,.014345   ,18.0992   ,1.02238   /
      data tbx( 89,5),tbx( 89,6),tbx( 89,7),tbx( 89,8),tbx( 89,9)
     *   / 11.4632   ,8.78809   ,.740625   ,23.3452   ,-14.316   /
      data tbx( 89,10)/41./
      data tbxc( 90),tbx( 90,1),tbx( 90,2),tbx( 90,3),tbx( 90,4)
     *   /'mo+6'   ,17.8871   ,1.03649   ,11.1750   ,8.48061   /
      data tbx( 90,5),tbx( 90,6),tbx( 90,7),tbx( 90,8),tbx( 90,9)
     *   / 6.57891   ,.058881   ,.0000   ,.0000    ,.344941   /
      data tbx( 90,10)/41./
      data tbxc( 91),tbx( 91,1),tbx( 91,2),tbx( 91,3),tbx( 91,4)
     *   /'tc  '   ,19.1301   ,.864132   ,11.0948   ,8.14487   /
      data tbx( 91,5),tbx( 91,6),tbx( 91,7),tbx( 91,8),tbx( 91,9)
     *   / 4.64901   ,21.5707   ,2.71263   ,86.8472   ,5.40428   /
      data tbx( 91,10)/42./
      data tbxc( 92),tbx( 92,1),tbx( 92,2),tbx( 92,3),tbx( 92,4)
     *   /'ru  '   ,19.2674   ,.808520   ,12.9182   ,8.43467   /
      data tbx( 92,5),tbx( 92,6),tbx( 92,7),tbx( 92,8),tbx( 92,9)
     *   / 4.86337   ,24.7997   ,1.56756   ,94.2928   ,5.37874   /
      data tbx( 92,10)/43./
      data tbxc( 93),tbx( 93,1),tbx( 93,2),tbx( 93,3),tbx( 93,4)
     *   /'ru+3'   ,18.5638   ,.847329   ,13.2885   ,8.37164   /
      data tbx( 93,5),tbx( 93,6),tbx( 93,7),tbx( 93,8),tbx( 93,9)
     *   / 9.32602   ,.017662   ,3.00964   ,22.8870   ,-3.1892   /
      data tbx( 93,10)/43./
      data tbxc( 94),tbx( 94,1),tbx( 94,2),tbx( 94,3),tbx( 94,4)
     *   /'ru+4'   ,18.5003   ,.844582   ,13.1787   ,8.12534   /
      data tbx( 94,5),tbx( 94,6),tbx( 94,7),tbx( 94,8),tbx( 94,9)
     *   / 4.71304   ,.036495   ,2.18535   ,20.8504   ,1.42357   /
      data tbx( 94,10)/43./
      data tbxc( 95),tbx( 95,1),tbx( 95,2),tbx( 95,3),tbx( 95,4)
     *   /'rh  '   ,19.2957   ,.751536   ,14.3501   ,8.21758   /
      data tbx( 95,5),tbx( 95,6),tbx( 95,7),tbx( 95,8),tbx( 95,9)
     *   / 4.73425   ,25.8749   ,1.28918   ,98.6062   ,5.32800   /
      data tbx( 95,10)/44./
      data tbxc( 96),tbx( 96,1),tbx( 96,2),tbx( 96,3),tbx( 96,4)
     *   /'rh+3'   ,18.8785   ,.764252   ,14.1259   ,7.84438   /
      data tbx( 96,5),tbx( 96,6),tbx( 96,7),tbx( 96,8),tbx( 96,9)
     *   / 3.32515   ,21.2487   ,-6.1989   ,-.01036   ,11.8678   /
      data tbx( 96,10)/44./
      data tbxc( 97),tbx( 97,1),tbx( 97,2),tbx( 97,3),tbx( 97,4)
     *   /'rh+4'   ,18.8545   ,.760825   ,13.9806   ,7.62436   /
      data tbx( 97,5),tbx( 97,6),tbx( 97,7),tbx( 97,8),tbx( 97,9)
     *   / 2.53464   ,19.3317   ,-5.6526   ,-.01020   ,11.2835   /
      data tbx( 97,10)/44./
      data tbxc( 98),tbx( 98,1),tbx( 98,2),tbx( 98,3),tbx( 98,4)
     *   /'pd  '   ,19.3319   ,.698655   ,15.5017   ,7.98929   /
      data tbx( 98,5),tbx( 98,6),tbx( 98,7),tbx( 98,8),tbx( 98,9)
     *   / 5.29537   ,25.2052   ,.605844   ,76.8986   ,5.26593   /
      data tbx( 98,10)/45./
      data tbxc( 99),tbx( 99,1),tbx( 99,2),tbx( 99,3),tbx( 99,4)
     *   /'pd+2'   ,19.1701   ,.696219   ,15.2096   ,7.55573   /
      data tbx( 99,5),tbx( 99,6),tbx( 99,7),tbx( 99,8),tbx( 99,9)
     *   / 4.32234   ,22.5057   ,.0000   ,.0000   ,5.29160   /
      data tbx( 99,10)/45./
      data tbxc(100),tbx(100,1),tbx(100,2),tbx(100,3),tbx(100,4)
     *   /'pd+4'   ,19.2493   ,.683839   ,14.7900   ,7.14833   /
      data tbx(100,5),tbx(100,6),tbx(100,7),tbx(100,8),tbx(100,9)
     *   / 2.89289   ,17.9144   ,-7.9492   ,.005127   ,13.0174   /
      data tbx(100,10)/45./
      data tbxc(101),tbx(101,1),tbx(101,2),tbx(101,3),tbx(101,4)
     *   /'ag  '   ,19.2808   ,  .6446   ,16.6885   , 7.4726   /
      data tbx(101,5),tbx(101,6),tbx(101,7),tbx(101,8),tbx(101,9)
     *   /  4.8045   ,24.6605   , 1.0463   ,99.8156   , 5.1790   /
      data tbx(101,10)/46./
      data tbxc(102),tbx(102,1),tbx(102,2),tbx(102,3),tbx(102,4)
     *   /'ag+1'   ,19.1812   ,.646179   ,15.9719   ,7.19123   /
      data tbx(102,5),tbx(102,6),tbx(102,7),tbx(102,8),tbx(102,9)
     *   / 5.27475   ,21.7326   ,.357534   ,66.1147   ,5.21572   /
      data tbx(102,10)/46./
      data tbxc(103),tbx(103,1),tbx(103,2),tbx(103,3),tbx(103,4)
     *   /'ag+2'   ,19.1643   ,.645643   ,16.2456   ,7.18544   /
      data tbx(103,5),tbx(103,6),tbx(103,7),tbx(103,8),tbx(103,9)
     *   / 4.37090   ,21.4072   ,.0000   ,.0000   ,5.21404   /
      data tbx(103,10)/46./
      data tbxc(104),tbx(104,1),tbx(104,2),tbx(104,3),tbx(104,4)
     *   /'cd  '   ,19.2214   ,  .5946   ,17.6444   , 6.9089   /
      data tbx(104,5),tbx(104,6),tbx(104,7),tbx(104,8),tbx(104,9)
     *   /  4.4610   ,24.7008   , 1.6029   ,87.4825   , 5.0694   /
      data tbx(104,10)/47./
      data tbxc(105),tbx(105,1),tbx(105,2),tbx(105,3),tbx(105,4)
     *   /'cd+2'   ,19.1514   ,.597922   ,17.2535   ,6.80639   /
      data tbx(105,5),tbx(105,6),tbx(105,7),tbx(105,8),tbx(105,9)
     *   / 4.47128   ,20.2521   ,.0000   ,.0000   ,5.11937   /
      data tbx(105,10)/47./
      data tbxc(106),tbx(106,1),tbx(106,2),tbx(106,3),tbx(106,4)
     *   /'in  '   ,19.1624   ,  .5476   ,18.5596   , 6.3776   /
      data tbx(106,5),tbx(106,6),tbx(106,7),tbx(106,8),tbx(106,9)
     *   /  4.2948   ,25.8499   , 2.0396   ,92.8029   , 4.9391   /
      data tbx(106,10)/48./
      data tbxc(107),tbx(107,1),tbx(107,2),tbx(107,3),tbx(107,4)
     *   /'in+3'   ,19.1045   ,.551522   ,18.1108   ,6.32470   /
      data tbx(107,5),tbx(107,6),tbx(107,7),tbx(107,8),tbx(107,9)
     *   / 3.78897   ,17.3595   ,.0000   ,.0000   ,4.99635   /
      data tbx(107,10)/48./
      data tbxc(108),tbx(108,1),tbx(108,2),tbx(108,3),tbx(108,4)
     *   /'sn  '   ,19.1889   , 5.8303   ,19.1005   ,  .5031   /
      data tbx(108,5),tbx(108,6),tbx(108,7),tbx(108,8),tbx(108,9)
     *   /  4.4585   ,26.8909   , 2.4663   ,83.9571   , 4.7821   /
      data tbx(108,10)/49./
      data tbxc(109),tbx(109,1),tbx(109,2),tbx(109,3),tbx(109,4)
     *   /'sn+2'   ,19.1094   ,  .5036   ,19.0548   , 5.8378   /
      data tbx(109,5),tbx(109,6),tbx(109,7),tbx(109,8),tbx(109,9)
     *   /  4.5648   ,23.3752   ,  .4870   ,62.2061   , 4.7861   /
      data tbx(109,10)/49./
      data tbxc(110),tbx(110,1),tbx(110,2),tbx(110,3),tbx(110,4)
     *   /'sn+4'   ,18.9333   , 5.7640   ,19.7131   ,  .4655   /
      data tbx(110,5),tbx(110,6),tbx(110,7),tbx(110,8),tbx(110,9)
     *   /  3.4182   ,14.0049   ,  .0193   , -.7583   , 3.9182   /
      data tbx(110,10)/49./
      data tbxc(111),tbx(111,1),tbx(111,2),tbx(111,3),tbx(111,4)
     *   /'sb  '   ,19.6418   , 5.3034   ,19.0455   ,  .4607   /
      data tbx(111,5),tbx(111,6),tbx(111,7),tbx(111,8),tbx(111,9)
     *   /  5.0371   ,27.9074   , 2.6827   ,75.2825   , 4.5909   /
      data tbx(111,10)/50./
      data tbxc(112),tbx(112,1),tbx(112,2),tbx(112,3),tbx(112,4)
     *   /'sb+3'   ,18.9755   ,.467196   ,18.9330   ,5.22126   /
      data tbx(112,5),tbx(112,6),tbx(112,7),tbx(112,8),tbx(112,9)
     *   / 5.10789   ,19.5902   ,.288753   ,55.5113   ,4.69626   /
      data tbx(112,10)/50./
      data tbxc(113),tbx(113,1),tbx(113,2),tbx(113,3),tbx(113,4)
     *   /'sb+5'   ,19.8685   ,5.44853   ,19.0302   ,.467973   /
      data tbx(113,5),tbx(113,6),tbx(113,7),tbx(113,8),tbx(113,9)
     *   / 2.41253   ,14.1259   ,.0000   ,.0000   ,4.69263   /
      data tbx(113,10)/50./
      data tbxc(114),tbx(114,1),tbx(114,2),tbx(114,3),tbx(114,4)
     *   /'te  '   ,19.9644   ,4.81742   ,19.0138   ,.420885   /
      data tbx(114,5),tbx(114,6),tbx(114,7),tbx(114,8),tbx(114,9)
     *   / 6.14487   ,28.5284   ,2.52390   ,70.8403   ,4.35200   /
      data tbx(114,10)/51./
      data tbxc(115),tbx(115,1),tbx(115,2),tbx(115,3),tbx(115,4)
     *   /'i   '   ,20.1472   , 4.3470   ,18.9949   ,  .3814   /
      data tbx(115,5),tbx(115,6),tbx(115,7),tbx(115,8),tbx(115,9)
     *   /  7.5138   ,27.7660   , 2.2735   ,66.8776   , 4.0712   /
      data tbx(115,10)/52./
      data tbxc(116),tbx(116,1),tbx(116,2),tbx(116,3),tbx(116,4)
     *   /'i-1 '   ,20.2332   , 4.3579   ,18.9970   ,  .3815   /
      data tbx(116,5),tbx(116,6),tbx(116,7),tbx(116,8),tbx(116,9)
     *   /  7.8069   ,29.5259   , 2.8868   ,84.9304   , 4.0714   /
      data tbx(116,10)/52./
      data tbxc(117),tbx(117,1),tbx(117,2),tbx(117,3),tbx(117,4)
     *   /'xe  '   ,20.2933   , 3.9282   ,19.0298   ,  .3440   /
      data tbx(117,5),tbx(117,6),tbx(117,7),tbx(117,8),tbx(117,9)
     *   /  8.9767   ,26.4659   , 1.9900   ,64.2658   , 3.7118   /
      data tbx(117,10)/53./
      data tbxc(118),tbx(118,1),tbx(118,2),tbx(118,3),tbx(118,4)
     *   /'cs  '   ,20.3892   , 3.5690   ,19.1062   ,  .3107   /
      data tbx(118,5),tbx(118,6),tbx(118,7),tbx(118,8),tbx(118,9)
     *   / 10.6620   ,24.3879   , 1.4953   ,213.904   , 3.3352   /
      data tbx(118,10)/54./
      data tbxc(119),tbx(119,1),tbx(119,2),tbx(119,3),tbx(119,4)
     *   /'cs+1'   ,20.3524   , 3.5520   ,19.1278   ,  .3086   /
      data tbx(119,5),tbx(119,6),tbx(119,7),tbx(119,8),tbx(119,9)
     *   / 10.2821   ,23.7128   ,  .9615   ,59.4565   , 3.2791   /
      data tbx(119,10)/54./
      data tbxc(120),tbx(120,1),tbx(120,2),tbx(120,3),tbx(120,4)
     *   /'ba  '   ,20.3361   , 3.2160   ,19.2970   ,  .2756   /
      data tbx(120,5),tbx(120,6),tbx(120,7),tbx(120,8),tbx(120,9)
     *   / 10.8880   ,20.2073   , 2.6959   ,167.202   , 2.7731   /
      data tbx(120,10)/55./
      data tbxc(121),tbx(121,1),tbx(121,2),tbx(121,3),tbx(121,4)
     *   /'ba+2'   ,20.1807   ,3.21367   ,19.1136   ,.283310   /
      data tbx(121,5),tbx(121,6),tbx(121,7),tbx(121,8),tbx(121,9)
     *   / 10.9054   ,20.0558   ,.773634   ,51.7460   ,3.02902   /
      data tbx(121,10)/55./
      data tbxc(122),tbx(122,1),tbx(122,2),tbx(122,3),tbx(122,4)
     *   /'la  '   ,20.5780   ,2.94817   ,19.5990   ,.244475   /
      data tbx(122,5),tbx(122,6),tbx(122,7),tbx(122,8),tbx(122,9)
     *   / 11.3727   ,18.7726   ,3.28719   ,133.124   ,2.14678   /
      data tbx(122,10)/56./
      data tbxc(123),tbx(123,1),tbx(123,2),tbx(123,3),tbx(123,4)
     *   /'la+3'   ,20.2489   ,2.92070   ,19.3763   ,.250698   /
      data tbx(123,5),tbx(123,6),tbx(123,7),tbx(123,8),tbx(123,9)
     *   / 11.6323   ,17.8211   ,.336048   ,54.9453   ,2.40860   /
      data tbx(123,10)/56./
      data tbxc(124),tbx(124,1),tbx(124,2),tbx(124,3),tbx(124,4)
     *   /'ce  '   ,21.1671   ,2.81219   ,19.7695   ,.226836   /
      data tbx(124,5),tbx(124,6),tbx(124,7),tbx(124,8),tbx(124,9)
     *   / 11.8513   ,17.6083   ,3.33049   ,127.113   ,1.86264   /
      data tbx(124,10)/57./
      data tbxc(125),tbx(125,1),tbx(125,2),tbx(125,3),tbx(125,4)
     *   /'ce+3'   ,20.8036   ,2.77691   ,19.5590   ,.231540   /
      data tbx(125,5),tbx(125,6),tbx(125,7),tbx(125,8),tbx(125,9)
     *   / 11.9369   ,16.5408   ,.612376   ,43.1692   ,2.09013   /
      data tbx(125,10)/57./
      data tbxc(126),tbx(126,1),tbx(126,2),tbx(126,3),tbx(126,4)
     *   /'ce+4'   ,20.3235   ,2.65941   ,19.8186   ,.218850   /
      data tbx(126,5),tbx(126,6),tbx(126,7),tbx(126,8),tbx(126,9)
     *   / 12.1233   ,15.7992   ,.144583   ,62.2355   ,1.59180   /
      data tbx(126,10)/57./
      data tbxc(127),tbx(127,1),tbx(127,2),tbx(127,3),tbx(127,4)
     *   /'pr  '   ,22.0440   ,2.77393   ,19.6697   ,.222087   /
      data tbx(127,5),tbx(127,6),tbx(127,7),tbx(127,8),tbx(127,9)
     *   / 12.3856   ,16.7669   ,2.82428   ,143.644   ,2.05830   /
      data tbx(127,10)/58./
      data tbxc(128),tbx(128,1),tbx(128,2),tbx(128,3),tbx(128,4)
     *   /'pr+3'   ,21.3727   ,2.64520   ,19.7491   ,.214299   /
      data tbx(128,5),tbx(128,6),tbx(128,7),tbx(128,8),tbx(128,9)
     *   / 12.1329   ,15.3230   ,.975180   ,36.4065   ,1.77132   /
      data tbx(128,10)/58./
      data tbxc(129),tbx(129,1),tbx(129,2),tbx(129,3),tbx(129,4)
     *   /'pr+4'   ,20.9413   ,2.54467   ,20.0539   ,.202481   /
      data tbx(129,5),tbx(129,6),tbx(129,7),tbx(129,8),tbx(129,9)
     *   / 12.4668   ,14.8137   ,.296689   ,45.4643   ,1.24285   /
      data tbx(129,10)/58./
      data tbxc(130),tbx(130,1),tbx(130,2),tbx(130,3),tbx(130,4)
     *   /'nd  '   ,22.6845   ,2.66248   ,19.6847   ,.210628   /
      data tbx(130,5),tbx(130,6),tbx(130,7),tbx(130,8),tbx(130,9)
     *   / 12.7740   ,15.8850   ,2.85137   ,137.903   ,1.98486   /
      data tbx(130,10)/59./
      data tbxc(131),tbx(131,1),tbx(131,2),tbx(131,3),tbx(131,4)
     *   /'nd+3'   ,21.9610   ,2.52722   ,19.9339   ,.199237   /
      data tbx(131,5),tbx(131,6),tbx(131,7),tbx(131,8),tbx(131,9)
     *   / 12.1200   ,14.1783   ,1.51031   ,30.8717   ,1.47588   /
      data tbx(131,10)/59./
      data tbxc(132),tbx(132,1),tbx(132,2),tbx(132,3),tbx(132,4)
     *   /'pm  '   ,23.3405   ,2.56270   ,19.6095   ,.202088   /
      data tbx(132,5),tbx(132,6),tbx(132,7),tbx(132,8),tbx(132,9)
     *   / 13.1235   ,15.1009   ,2.87516   ,132.721   ,2.02876   /
      data tbx(132,10)/60./
      data tbxc(133),tbx(133,1),tbx(133,2),tbx(133,3),tbx(133,4)
     *   /'pm+3'   ,22.5527   ,2.41740   ,20.1108   ,.185769   /
      data tbx(133,5),tbx(133,6),tbx(133,7),tbx(133,8),tbx(133,9)
     *   / 12.0671   ,13.1275   ,2.07492   ,27.4491   ,1.19499   /
      data tbx(133,10)/60./
      data tbxc(134),tbx(134,1),tbx(134,2),tbx(134,3),tbx(134,4)
     *   /'sm  '   ,24.0042   ,2.47274   ,19.4258   ,.196451   /
      data tbx(134,5),tbx(134,6),tbx(134,7),tbx(134,8),tbx(134,9)
     *   / 13.4396   ,14.3996   ,2.89604   ,128.007   ,2.20963   /
      data tbx(134,10)/61./
      data tbxc(135),tbx(135,1),tbx(135,2),tbx(135,3),tbx(135,4)
     *   /'sm+3'   ,23.1504   ,2.31641   ,20.2599   ,.174081   /
      data tbx(135,5),tbx(135,6),tbx(135,7),tbx(135,8),tbx(135,9)
     *   / 11.9202   ,12.1571   ,2.71488   ,24.8242   ,.954586   /
      data tbx(135,10)/61./
      data tbxc(136),tbx(136,1),tbx(136,2),tbx(136,3),tbx(136,4)
     *   /'eu  '   ,24.6274   , 2.3879   ,19.0886   ,  .1942   /
      data tbx(136,5),tbx(136,6),tbx(136,7),tbx(136,8),tbx(136,9)
     *   / 13.7603   ,13.7546   , 2.9227   ,123.174   , 2.5745   /
      data tbx(136,10)/62./
      data tbxc(137),tbx(137,1),tbx(137,2),tbx(137,3),tbx(137,4)
     *   /'eu+2'   ,24.0063   ,2.27783   ,19.9504   ,.173530   /
      data tbx(137,5),tbx(137,6),tbx(137,7),tbx(137,8),tbx(137,9)
     *   / 11.8034   ,11.6096   ,3.87243   ,26.5156   ,1.36389   /
      data tbx(137,10)/62./
      data tbxc(138),tbx(138,1),tbx(138,2),tbx(138,3),tbx(138,4)
     *   /'eu+3'   ,23.7497   ,2.22258   ,20.3745   ,.163940   /
      data tbx(138,5),tbx(138,6),tbx(138,7),tbx(138,8),tbx(138,9)
     *   / 11.8509   ,11.3110   ,3.26503   ,22.9966   ,.759344   /
      data tbx(138,10)/62./
      data tbxc(139),tbx(139,1),tbx(139,2),tbx(139,3),tbx(139,4)
     *   /'gd  '   ,25.0709   ,2.25341   ,19.0798   ,.181951   /
      data tbx(139,5),tbx(139,6),tbx(139,7),tbx(139,8),tbx(139,9)
     *   / 13.8518   ,12.9331   ,3.54545   ,101.398   ,2.41960   /
      data tbx(139,10)/63./
      data tbxc(140),tbx(140,1),tbx(140,2),tbx(140,3),tbx(140,4)
     *   /'gd+3'   ,24.3466   ,2.13553   ,20.4208   ,.155525   /
      data tbx(140,5),tbx(140,6),tbx(140,7),tbx(140,8),tbx(140,9)
     *   / 11.8708   ,10.5782   ,3.71490   ,21.7029   ,.645089   /
      data tbx(140,10)/63./
      data tbxc(141),tbx(141,1),tbx(141,2),tbx(141,3),tbx(141,4)
     *   /'tb  '   ,25.8976   ,2.24256   ,18.2185   ,.196143   /
      data tbx(141,5),tbx(141,6),tbx(141,7),tbx(141,8),tbx(141,9)
     *   / 14.3167   ,12.6648   ,2.95354   ,115.362   ,3.58324   /
      data tbx(141,10)/64./
      data tbxc(142),tbx(142,1),tbx(142,2),tbx(142,3),tbx(142,4)
     *   /'tb+3'   ,24.9559   ,2.05601   ,20.3271   ,.149525   /
      data tbx(142,5),tbx(142,6),tbx(142,7),tbx(142,8),tbx(142,9)
     *   / 12.2471   ,10.0499   ,3.77300   ,21.2773   ,.691967   /
      data tbx(142,10)/64./
      data tbxc(143),tbx(143,1),tbx(143,2),tbx(143,3),tbx(143,4)
     *   /'dy  '   ,26.5070   ,2.18020   ,17.6383   ,.202172   /
      data tbx(143,5),tbx(143,6),tbx(143,7),tbx(143,8),tbx(143,9)
     *   / 14.5596   ,12.1899   ,2.96577   ,111.874   ,4.29728   /
      data tbx(143,10)/65./
      data tbxc(144),tbx(144,1),tbx(144,2),tbx(144,3),tbx(144,4)
     *   /'dy+3'   ,25.5395   ,1.98040   ,20.2861   ,.143384   /
      data tbx(144,5),tbx(144,6),tbx(144,7),tbx(144,8),tbx(144,9)
     *   / 11.9812   ,9.34972   ,4.50073   ,19.5810   ,.689690   /
      data tbx(144,10)/65./
      data tbxc(145),tbx(145,1),tbx(145,2),tbx(145,3),tbx(145,4)
     *   /'ho  '   ,26.9049   ,2.07051   ,17.2940   ,.197940   /
      data tbx(145,5),tbx(145,6),tbx(145,7),tbx(145,8),tbx(145,9)
     *   / 14.5583   ,11.4407   ,3.63837   ,92.6566   ,4.56796   /
      data tbx(145,10)/66./
      data tbxc(146),tbx(146,1),tbx(146,2),tbx(146,3),tbx(146,4)
     *   /'ho+3'   ,26.1296   ,1.91072   ,20.0994   ,.139358   /
      data tbx(146,5),tbx(146,6),tbx(146,7),tbx(146,8),tbx(146,9)
     *   / 11.9788   ,8.80018   ,4.93676   ,18.5908   ,.852795   /
      data tbx(146,10)/66./
      data tbxc(147),tbx(147,1),tbx(147,2),tbx(147,3),tbx(147,4)
     *   /'er  '   ,27.6563   ,2.07356   ,16.4285   ,.223545   /
      data tbx(147,5),tbx(147,6),tbx(147,7),tbx(147,8),tbx(147,9)
     *   / 14.9779   ,11.3604   ,2.98233   ,105.703   ,5.92046   /
      data tbx(147,10)/67./
      data tbxc(148),tbx(148,1),tbx(148,2),tbx(148,3),tbx(148,4)
     *   /'er+3'   ,26.7220   ,1.84659   ,19.7748   ,.137290   /
      data tbx(148,5),tbx(148,6),tbx(148,7),tbx(148,8),tbx(148,9)
     *   / 12.1506   ,8.36225   ,5.17379   ,17.8974   ,1.17613   /
      data tbx(148,10)/67./
      data tbxc(149),tbx(149,1),tbx(149,2),tbx(149,3),tbx(149,4)
     *   /'tm  '   ,28.1819   ,2.02859   ,15.8851   ,.238849   /
      data tbx(149,5),tbx(149,6),tbx(149,7),tbx(149,8),tbx(149,9)
     *   / 15.1542   ,10.9975   ,2.98706   ,102.961   ,6.75621   /
      data tbx(149,10)/68./
      data tbxc(150),tbx(150,1),tbx(150,2),tbx(150,3),tbx(150,4)
     *   /'tm+3'   ,27.3083   ,1.78711   ,19.3320   ,.136974   /
      data tbx(150,5),tbx(150,6),tbx(150,7),tbx(150,8),tbx(150,9)
     *   / 12.3339   ,7.96778   ,5.38348   ,17.2922   ,1.63929   /
      data tbx(150,10)/68./
      data tbxc(151),tbx(151,1),tbx(151,2),tbx(151,3),tbx(151,4)
     *   /'yb  '   ,28.6641   ,1.98890   ,15.4345   ,.257119   /
      data tbx(151,5),tbx(151,6),tbx(151,7),tbx(151,8),tbx(151,9)
     *   / 15.3087   ,10.6647   ,2.98963   ,100.417   ,7.56672   /
      data tbx(151,10)/69./
      data tbxc(152),tbx(152,1),tbx(152,2),tbx(152,3),tbx(152,4)
     *   /'yb+2'   ,28.1209   ,1.78503   ,17.6817   ,.159970   /
      data tbx(152,5),tbx(152,6),tbx(152,7),tbx(152,8),tbx(152,9)
     *   / 13.3335   ,8.18304   ,5.14657   ,20.3900   ,3.70983   /
      data tbx(152,10)/69./
      data tbxc(153),tbx(153,1),tbx(153,2),tbx(153,3),tbx(153,4)
     *   /'yb+3'   ,27.8917   ,1.73272   ,18.7614   ,.138790   /
      data tbx(153,5),tbx(153,6),tbx(153,7),tbx(153,8),tbx(153,9)
     *   / 12.6072   ,7.64412   ,5.47647   ,16.8153   ,2.26001   /
      data tbx(153,10)/69./
      data tbxc(154),tbx(154,1),tbx(154,2),tbx(154,3),tbx(154,4)
     *   /'lu  '   ,28.9476   ,1.90182   ,15.2208   ,9.98519   /
      data tbx(154,5),tbx(154,6),tbx(154,7),tbx(154,8),tbx(154,9)
     *   / 15.1000   ,.261033   ,3.71601   ,84.3298   ,7.97628   /
      data tbx(154,10)/70./
      data tbxc(155),tbx(155,1),tbx(155,2),tbx(155,3),tbx(155,4)
     *   /'lu+3'   ,28.4628   ,1.68216   ,18.1210   ,.142292   /
      data tbx(155,5),tbx(155,6),tbx(155,7),tbx(155,8),tbx(155,9)
     *   / 12.8429   ,7.33727   ,5.59415   ,16.3535   ,2.97573   /
      data tbx(155,10)/70./
      data tbxc(156),tbx(156,1),tbx(156,2),tbx(156,3),tbx(156,4)
     *   /'hf  '   ,29.1440   ,1.83262   ,15.1726   ,9.59990   /
      data tbx(156,5),tbx(156,6),tbx(156,7),tbx(156,8),tbx(156,9)
     *   / 14.7586   ,.275116   ,4.30013   ,72.0290   ,8.58154   /
      data tbx(156,10)/71./
      data tbxc(157),tbx(157,1),tbx(157,2),tbx(157,3),tbx(157,4)
     *   /'hf+4'   ,28.8131   ,1.59136   ,18.4601   ,.128903   /
      data tbx(157,5),tbx(157,6),tbx(157,7),tbx(157,8),tbx(157,9)
     *   / 12.7285   ,6.76232   ,5.59927   ,14.0366   ,2.39699   /
      data tbx(157,10)/71./
      data tbxc(158),tbx(158,1),tbx(158,2),tbx(158,3),tbx(158,4)
     *   /'ta  '   ,29.2024   ,1.77333   ,15.2293   ,9.37046   /
      data tbx(158,5),tbx(158,6),tbx(158,7),tbx(158,8),tbx(158,9)
     *   / 14.5135   ,.295977   ,4.76492   ,63.3644   ,9.24354   /
      data tbx(158,10)/72./
      data tbxc(159),tbx(159,1),tbx(159,2),tbx(159,3),tbx(159,4)
     *   /'ta+5'   ,29.1587   ,1.50711   ,18.8407   ,.116741   /
      data tbx(159,5),tbx(159,6),tbx(159,7),tbx(159,8),tbx(159,9)
     *   / 12.8268   ,6.31524   ,5.38695   ,12.4244   ,1.78555   /
      data tbx(159,10)/72./
      data tbxc(160),tbx(160,1),tbx(160,2),tbx(160,3),tbx(160,4)
     *   /'w   '   ,29.0818   ,1.72029   ,15.4300   ,9.22590   /
      data tbx(160,5),tbx(160,6),tbx(160,7),tbx(160,8),tbx(160,9)
     *   / 14.4327   ,.321703   ,5.11982   ,57.0560   ,9.88750   /
      data tbx(160,10)/73./
      data tbxc(161),tbx(161,1),tbx(161,2),tbx(161,3),tbx(161,4)
     *   /'w+6 '   ,29.4936   ,1.42755   ,19.3763   ,.104621   /
      data tbx(161,5),tbx(161,6),tbx(161,7),tbx(161,8),tbx(161,9)
     *   / 13.0544   ,5.93667   ,5.06412   ,11.1972   ,1.01074   /
      data tbx(161,10)/73./
      data tbxc(162),tbx(162,1),tbx(162,2),tbx(162,3),tbx(162,4)
     *   /'re  '   ,28.7621   ,1.67191   ,15.7189   ,9.09227   /
      data tbx(162,5),tbx(162,6),tbx(162,7),tbx(162,8),tbx(162,9)
     *   / 14.5564   ,.350500   ,5.44174   ,52.0861   ,10.4720   /
      data tbx(162,10)/74./
      data tbxc(163),tbx(163,1),tbx(163,2),tbx(163,3),tbx(163,4)
     *   /'os  '   ,28.1894   ,1.62903   ,16.1550   ,8.97948   /
      data tbx(163,5),tbx(163,6),tbx(163,7),tbx(163,8),tbx(163,9)
     *   / 14.9305   ,.382661   ,5.67589   ,48.1647   ,11.0005   /
      data tbx(163,10)/75./
      data tbxc(164),tbx(164,1),tbx(164,2),tbx(164,3),tbx(164,4)
     *   /'os+4'   ,30.4190   ,1.37113   ,15.2637   ,6.84706   /
      data tbx(164,5),tbx(164,6),tbx(164,7),tbx(164,8),tbx(164,9)
     *   / 14.7458   ,.165191   ,5.06795   ,18.0030   ,6.49804   /
      data tbx(164,10)/75./
      data tbxc(165),tbx(165,1),tbx(165,2),tbx(165,3),tbx(165,4)
     *   /'ir  '   ,27.3049   ,1.59279   ,16.7296   ,8.86553   /
      data tbx(165,5),tbx(165,6),tbx(165,7),tbx(165,8),tbx(165,9)
     *   / 15.6115   ,.417916   ,5.83377   ,45.0011   ,11.4722   /
      data tbx(165,10)/76./
      data tbxc(166),tbx(166,1),tbx(166,2),tbx(166,3),tbx(166,4)
     *   /'ir+3'   ,30.4156   ,1.34323   ,15.8620   ,7.10909   /
      data tbx(166,5),tbx(166,6),tbx(166,7),tbx(166,8),tbx(166,9)
     *   / 13.6145   ,.204633   ,5.82008   ,20.3254   ,8.27903   /
      data tbx(166,10)/76./
      data tbxc(167),tbx(167,1),tbx(167,2),tbx(167,3),tbx(167,4)
     *   /'ir+4'   ,30.7058   ,1.30923   ,15.5512   ,6.71983   /
      data tbx(167,5),tbx(167,6),tbx(167,7),tbx(167,8),tbx(167,9)
     *   / 14.2326   ,.167252   ,5.53672   ,17.4911   ,6.96824   /
      data tbx(167,10)/76./
      data tbxc(168),tbx(168,1),tbx(168,2),tbx(168,3),tbx(168,4)
     *   /'pt  '   ,27.0059   ,1.51293   ,17.7639   ,8.81174   /
      data tbx(168,5),tbx(168,6),tbx(168,7),tbx(168,8),tbx(168,9)
     *   / 15.7131   ,.424593   ,5.78370   ,38.6103   ,11.6883   /
      data tbx(168,10)/77./
      data tbxc(169),tbx(169,1),tbx(169,2),tbx(169,3),tbx(169,4)
     *   /'pt+2'   ,29.8429   ,1.32927   ,16.7224   ,7.38979   /
      data tbx(169,5),tbx(169,6),tbx(169,7),tbx(169,8),tbx(169,9)
     *   / 13.2153   ,.263297   ,6.35234   ,22.9426   ,9.85329   /
      data tbx(169,10)/77./
      data tbxc(170),tbx(170,1),tbx(170,2),tbx(170,3),tbx(170,4)
     *   /'pt+4'   ,30.9612   ,1.24813   ,15.9829   ,6.60834   /
      data tbx(170,5),tbx(170,6),tbx(170,7),tbx(170,8),tbx(170,9)
     *   / 13.7348   ,.168640   ,5.92034   ,16.9392   ,7.39534   /
      data tbx(170,10)/77./
      data tbxc(171),tbx(171,1),tbx(171,2),tbx(171,3),tbx(171,4)
     *   /'au  '   ,16.8819   ,  .4611   ,18.5913   , 8.6216   /
      data tbx(171,5),tbx(171,6),tbx(171,7),tbx(171,8),tbx(171,9)
     *   / 25.5582   , 1.4826   , 5.8600   ,36.3956   ,12.0658   /
      data tbx(171,10)/78./
      data tbxc(172),tbx(172,1),tbx(172,2),tbx(172,3),tbx(172,4)
     *   /'au+1'   ,28.0109   ,1.35321   ,17.8204   ,7.73950   /
      data tbx(172,5),tbx(172,6),tbx(172,7),tbx(172,8),tbx(172,9)
     *   / 14.3359   ,.356752   ,6.58077   ,26.4043   ,11.2299   /
      data tbx(172,10)/78./
      data tbxc(173),tbx(173,1),tbx(173,2),tbx(173,3),tbx(173,4)
     *   /'au+3'   ,30.6886   ,1.21990   ,16.9029   ,6.82872   /
      data tbx(173,5),tbx(173,6),tbx(173,7),tbx(173,8),tbx(173,9)
     *   / 12.7801   ,.212867   ,6.52354   ,18.6590   ,9.09680   /
      data tbx(173,10)/78./
      data tbxc(174),tbx(174,1),tbx(174,2),tbx(174,3),tbx(174,4)
     *   /'hg  '   ,20.6809   ,  .5450   ,19.0417   , 8.4484   /
      data tbx(174,5),tbx(174,6),tbx(174,7),tbx(174,8),tbx(174,9)
     *   / 21.6575   , 1.5729   , 5.9676   ,38.3246   ,12.6089   /
      data tbx(174,10)/79./
      data tbxc(175),tbx(175,1),tbx(175,2),tbx(175,3),tbx(175,4)
     *   /'hg+1'   ,25.0853   ,1.39507   ,18.4973   ,7.65105   /
      data tbx(175,5),tbx(175,6),tbx(175,7),tbx(175,8),tbx(175,9)
     *   / 16.8883   ,.443378   ,6.48216   ,28.2262   ,12.0205   /
      data tbx(175,10)/79./
      data tbxc(176),tbx(176,1),tbx(176,2),tbx(176,3),tbx(176,4)
     *   /'hg+2'   ,29.5641   ,1.21152   ,18.0600   ,7.05639   /
      data tbx(176,5),tbx(176,6),tbx(176,7),tbx(176,8),tbx(176,9)
     *   / 12.8374   ,.284738   ,6.89912   ,20.7482   ,10.6268   /
      data tbx(176,10)/79./
      data tbxc(177),tbx(177,1),tbx(177,2),tbx(177,3),tbx(177,4)
     *   /'tl  '   ,27.5446   ,.655150   ,19.1584   ,8.70751   /
      data tbx(177,5),tbx(177,6),tbx(177,7),tbx(177,8),tbx(177,9)
     *   / 15.5380   ,1.96347   ,5.52593   ,45.8149   ,13.1746   /
      data tbx(177,10)/80./
      data tbxc(178),tbx(178,1),tbx(178,2),tbx(178,3),tbx(178,4)
     *   /'tl+1'   ,21.3985   ,1.47110   ,20.4723   ,.517394   /
      data tbx(178,5),tbx(178,6),tbx(178,7),tbx(178,8),tbx(178,9)
     *   / 18.7478   ,7.43463   ,6.82847   ,28.8482   ,12.5258   /
      data tbx(178,10)/80./
      data tbxc(179),tbx(179,1),tbx(179,2),tbx(179,3),tbx(179,4)
     *   /'tl+3'   ,30.8695   ,1.10080   ,18.3841   ,6.53852   /
      data tbx(179,5),tbx(179,6),tbx(179,7),tbx(179,8),tbx(179,9)
     *   / 11.9328   ,.219074   ,7.00574   ,17.2114   ,9.80270   /
      data tbx(179,10)/80./
      data tbxc(180),tbx(180,1),tbx(180,2),tbx(180,3),tbx(180,4)
     *   /'pb  '   ,31.0617   ,  .6902   ,13.0637   , 2.3576   /
      data tbx(180,5),tbx(180,6),tbx(180,7),tbx(180,8),tbx(180,9)
     *   / 18.4420   , 8.6180   , 5.9696   ,47.2579   ,13.4118   /
      data tbx(180,10)/81./
      data tbxc(181),tbx(181,1),tbx(181,2),tbx(181,3),tbx(181,4)
     *   /'pb+2'   ,21.7886   ,1.33660   ,19.5682   ,.488383   /
      data tbx(181,5),tbx(181,6),tbx(181,7),tbx(181,8),tbx(181,9)
     *   / 19.1406   ,6.77270   ,7.01107   ,23.8132   ,12.4734   /
      data tbx(181,10)/81./
      data tbxc(182),tbx(182,1),tbx(182,2),tbx(182,3),tbx(182,4)
     *   /'pb+4'   ,32.1244   ,1.00566   ,18.8003   ,6.10926   /
      data tbx(182,5),tbx(182,6),tbx(182,7),tbx(182,8),tbx(182,9)
     *   / 12.0175   ,.147041   ,6.96886   ,14.7140   ,8.08428   /
      data tbx(182,10)/81./
      data tbxc(183),tbx(183,1),tbx(183,2),tbx(183,3),tbx(183,4)
     *   /'bi  '   ,33.3689   ,  .7040   ,12.9510   , 2.9238   /
      data tbx(183,5),tbx(183,6),tbx(183,7),tbx(183,8),tbx(183,9)
     *   / 16.5877   , 8.7937   , 6.4692   ,48.0093   ,13.5782   /
      data tbx(183,10)/82./
      data tbxc(184),tbx(184,1),tbx(184,2),tbx(184,3),tbx(184,4)
     *   /'bi+3'   ,21.8053   ,1.23560   ,19.5026   ,6.24149   /
      data tbx(184,5),tbx(184,6),tbx(184,7),tbx(184,8),tbx(184,9)
     *   / 19.1053   ,.469999   ,7.10295   ,20.3185   ,12.4711   /
      data tbx(184,10)/82./
      data tbxc(185),tbx(185,1),tbx(185,2),tbx(185,3),tbx(185,4)
     *   /'bi+5'   ,33.5364   ,.916540   ,25.0946   ,.039042   /
      data tbx(185,5),tbx(185,6),tbx(185,7),tbx(185,8),tbx(185,9)
     *   / 19.2497   ,5.71414   ,6.91555   ,12.8285   ,-6.7994   /
      data tbx(185,10)/82./
      data tbxc(186),tbx(186,1),tbx(186,2),tbx(186,3),tbx(186,4)
     *   /'po  '   ,34.6726   ,.700999   ,15.4733   ,3.55078   /
      data tbx(186,5),tbx(186,6),tbx(186,7),tbx(186,8),tbx(186,9)
     *   / 13.1138   ,9.55642   ,7.02588   ,47.0045   ,13.6770   /
      data tbx(186,10)/83./
      data tbxc(187),tbx(187,1),tbx(187,2),tbx(187,3),tbx(187,4)
     *   /'at  '   ,35.3163   ,.685870   ,19.0211   ,3.97458   /
      data tbx(187,5),tbx(187,6),tbx(187,7),tbx(187,8),tbx(187,9)
     *   / 9.49887   ,11.3824   ,7.42518   ,45.4715   ,13.7108   /
      data tbx(187,10)/84./
      data tbxc(188),tbx(188,1),tbx(188,2),tbx(188,3),tbx(188,4)
     *   /'rn  '   ,35.5631   ,  .6631   ,21.2816   , 4.0691   /
      data tbx(188,5),tbx(188,6),tbx(188,7),tbx(188,8),tbx(188,9)
     *   /  8.0037   ,14.0422   , 7.4433   ,44.2473   ,13.6905   /
      data tbx(188,10)/85./
      data tbxc(189),tbx(189,1),tbx(189,2),tbx(189,3),tbx(189,4)
     *   /'fr  '   ,35.9299   ,.646453   ,23.0547   ,4.17619   /
      data tbx(189,5),tbx(189,6),tbx(189,7),tbx(189,8),tbx(189,9)
     *   / 12.1439   ,23.1052   ,2.11253   ,150.645   ,13.7247   /
      data tbx(189,10)/86./
      data tbxc(190),tbx(190,1),tbx(190,2),tbx(190,3),tbx(190,4)
     *   /'ra  '   ,35.7630   ,.616341   ,22.9064   ,3.87135   /
      data tbx(190,5),tbx(190,6),tbx(190,7),tbx(190,8),tbx(190,9)
     *   / 12.4739   ,19.9887   ,3.21097   ,142.325   ,13.6211   /
      data tbx(190,10)/87./
      data tbxc(191),tbx(191,1),tbx(191,2),tbx(191,3),tbx(191,4)
     *   /'ra+2'   ,35.2150   ,.604909   ,21.6700   ,3.57670   /
      data tbx(191,5),tbx(191,6),tbx(191,7),tbx(191,8),tbx(191,9)
     *   / 7.91342   ,12.6010   ,7.65078   ,29.8436   ,13.5431   /
      data tbx(191,10)/87./
      data tbxc(192),tbx(192,1),tbx(192,2),tbx(192,3),tbx(192,4)
     *   /'ac  '   ,35.6597   ,.589092   ,23.1032   ,3.65155   /
      data tbx(192,5),tbx(192,6),tbx(192,7),tbx(192,8),tbx(192,9)
     *   / 12.5977   ,18.5990   ,4.08655   ,117.020   ,13.5266   /
      data tbx(192,10)/88./
      data tbxc(193),tbx(193,1),tbx(193,2),tbx(193,3),tbx(193,4)
     *   /'ac+3'   ,35.1736   ,.579689   ,22.1112   ,3.41437   /
      data tbx(193,5),tbx(193,6),tbx(193,7),tbx(193,8),tbx(193,9)
     *   / 8.19216   ,12.9187   ,7.05545   ,25.9443   ,13.4637   /
      data tbx(193,10)/88./
      data tbxc(194),tbx(194,1),tbx(194,2),tbx(194,3),tbx(194,4)
     *   /'th  '   ,35.5645   ,.563359   ,23.4219   ,3.46204   /
      data tbx(194,5),tbx(194,6),tbx(194,7),tbx(194,8),tbx(194,9)
     *   / 12.7473   ,17.8309   ,4.80703   ,99.1722   ,13.4314   /
      data tbx(194,10)/89./
      data tbxc(195),tbx(195,1),tbx(195,2),tbx(195,3),tbx(195,4)
     *   /'th+4'   ,35.1007   ,.555054   ,22.4418   ,3.24498   /
      data tbx(195,5),tbx(195,6),tbx(195,7),tbx(195,8),tbx(195,9)
     *   / 9.78554   ,13.4661   ,5.29444   ,23.9533   ,13.3760   /
      data tbx(195,10)/89./
      data tbxc(196),tbx(196,1),tbx(196,2),tbx(196,3),tbx(196,4)
     *   /'pa  '   ,35.8847   ,.547751   ,23.2948   ,3.41519   /
      data tbx(196,5),tbx(196,6),tbx(196,7),tbx(196,8),tbx(196,9)
     *   / 14.1891   ,16.9235   ,4.17287   ,105.251   ,13.4287   /
      data tbx(196,10)/90./
      data tbxc(197),tbx(197,1),tbx(197,2),tbx(197,3),tbx(197,4)
     *   /'u   '   ,36.0228   ,  .5293   ,23.4128   , 3.3253   /
      data tbx(197,5),tbx(197,6),tbx(197,7),tbx(197,8),tbx(197,9)
     *   / 14.9491   ,16.0927   , 4.1880   ,100.613   ,13.3966   /
      data tbx(197,10)/91./
      data tbxc(198),tbx(198,1),tbx(198,2),tbx(198,3),tbx(198,4)
     *   /'u+3 '  ,35.5747   ,.520480   ,22.5259   ,3.12293   /
      data tbx(198,5),tbx(198,6),tbx(198,7),tbx(198,8),tbx(198,9)
     *   / 12.2165   ,12.7148   ,5.37073   ,26.3394   ,13.3092   /
      data tbx(198,10)/91./
      data tbxc(199),tbx(199,1),tbx(199,2),tbx(199,3),tbx(199,4)
     *   /'u+4 '  ,35.3715   ,.516598   ,22.5326   ,3.05053   /
      data tbx(199,5),tbx(199,6),tbx(199,7),tbx(199,8),tbx(199,9)
     *   / 12.0291   ,12.5723   ,4.79840   ,23.4582   ,13.2671   /
      data tbx(199,10)/91./
      data tbxc(200),tbx(200,1),tbx(200,2),tbx(200,3),tbx(200,4)
     *   /'u+6 '  ,34.8509   ,.507079   ,22.7584   ,2.89030   /
      data tbx(200,5),tbx(200,6),tbx(200,7),tbx(200,8),tbx(200,9)
     *   / 14.0099   ,13.1767   ,1.21457   ,25.2017   ,13.1665   /
      data tbx(200,10)/91./
      data tbxc(201),tbx(201,1),tbx(201,2),tbx(201,3),tbx(201,4)
     *   /'np  '   ,36.1874   ,.511929   ,23.5964   ,3.25396   /
      data tbx(201,5),tbx(201,6),tbx(201,7),tbx(201,8),tbx(201,9)
     *   / 15.6402   ,15.3622   ,4.18550   ,97.4908   ,13.3573   /
      data tbx(201,10)/92./
      data tbxc(202),tbx(202,1),tbx(202,2),tbx(202,3),tbx(202,4)
     *   /'np+3'   ,35.7074   ,.502322   ,22.6130   ,3.03807   /
      data tbx(202,5),tbx(202,6),tbx(202,7),tbx(202,8),tbx(202,9)
     *   / 12.9898   ,12.1449   ,5.43227   ,25.4928   ,13.2544   /
      data tbx(202,10)/92./
      data tbxc(203),tbx(203,1),tbx(203,2),tbx(203,3),tbx(203,4)
     *   /'np+4'   ,35.5103   ,.498626   ,22.5787   ,2.96627   /
      data tbx(203,5),tbx(203,6),tbx(203,7),tbx(203,8),tbx(203,9)
     *   / 12.7766   ,11.9484   ,4.92159   ,22.7502   ,13.2116   /
      data tbx(203,10)/92./
      data tbxc(204),tbx(204,1),tbx(204,2),tbx(204,3),tbx(204,4)
     *   /'np+6'   ,35.0136   ,.489810   ,22.7286   ,2.81099   /
      data tbx(204,5),tbx(204,6),tbx(204,7),tbx(204,8),tbx(204,9)
     *   / 14.3884   ,12.3300   ,1.75669   ,22.6581   ,13.1130   /
      data tbx(204,10)/92./
      data tbxc(205),tbx(205,1),tbx(205,2),tbx(205,3),tbx(205,4)
     *   /'pu  '   ,36.5254   ,.499384   ,23.8083   ,3.26371   /
      data tbx(205,5),tbx(205,6),tbx(205,7),tbx(205,8),tbx(205,9)
     *   / 16.7707   ,14.9455   ,3.47947   ,105.980   ,13.3812   /
      data tbx(205,10)/93./
      data tbxc(206),tbx(206,1),tbx(206,2),tbx(206,3),tbx(206,4)
     *   /'pu+3'   ,35.8400   ,.484938   ,22.7169   ,2.96118   /
      data tbx(206,5),tbx(206,6),tbx(206,7),tbx(206,8),tbx(206,9)
     *   / 13.5807   ,11.5331   ,5.66016   ,24.3992   ,13.1991   /
      data tbx(206,10)/93./
      data tbxc(207),tbx(207,1),tbx(207,2),tbx(207,3),tbx(207,4)
     *   /'pu+4'   ,35.6493   ,.481422   ,22.6460   ,2.89020   /
      data tbx(207,5),tbx(207,6),tbx(207,7),tbx(207,8),tbx(207,9)
     *   / 13.3595   ,11.3160   ,5.18831   ,21.8301   ,13.1555   /
      data tbx(207,10)/93./
      data tbxc(208),tbx(208,1),tbx(208,2),tbx(208,3),tbx(208,4)
     *   /'pu+6'   ,35.1736   ,.473204   ,22.7181   ,2.73848   /
      data tbx(208,5),tbx(208,6),tbx(208,7),tbx(208,8),tbx(208,9)
     *   / 14.7635   ,11.5530   ,2.28678   ,20.9303   ,13.0582   /
      data tbx(208,10)/93./
      data tbxc(209),tbx(209,1),tbx(209,2),tbx(209,3),tbx(209,4)
     *   /'am  '   ,36.6706   ,.483629   ,24.0992   ,3.20647   /
      data tbx(209,5),tbx(209,6),tbx(209,7),tbx(209,8),tbx(209,9)
     *   / 17.3415   ,14.3136   ,3.49331   ,102.273   ,13.3592   /
      data tbx(209,10)/94./
      data tbxc(210),tbx(210,1),tbx(210,2),tbx(210,3),tbx(210,4)
     *   /'cm  '   ,36.6488   ,.465154   ,24.4096   ,3.08997   /
      data tbx(210,5),tbx(210,6),tbx(210,7),tbx(210,8),tbx(210,9)
     *   / 17.3990   ,13.4346   ,4.21665   ,88.4834   ,13.2887   /
      data tbx(210,10)/95./
      data tbxc(211),tbx(211,1),tbx(211,2),tbx(211,3),tbx(211,4)
     *   /'bk  '   ,36.7881   ,.451018   ,24.7736   ,3.04619   /
      data tbx(211,5),tbx(211,6),tbx(211,7),tbx(211,8),tbx(211,9)
     *   / 17.8919   ,12.8946   ,4.23284   ,86.0030   ,13.2754   /
      data tbx(211,10)/96./
      data tbxc(212),tbx(212,1),tbx(212,2),tbx(212,3),tbx(212,4)
     *   /'cf  '   ,36.9185   ,.437533   ,25.1995   ,3.00775   /
      data tbx(212,5),tbx(212,6),tbx(212,7),tbx(212,8),tbx(212,9)
     *   / 18.3317   ,12.4044   ,4.24391   ,83.7881   ,13.2674   /
      data tbx(212,10)/97./
      END
C
